module jp.ku6.windows.win32api.dwmapi;

import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.uxtheme;

immutable uint DWM_BB_ENABLE                = 0x00000001;
immutable uint DWM_BB_BLURREGION            = 0x00000002;
immutable uint DWM_BB_TRANSITIONONMAXIMIZED = 0x00000004;

align(1)
struct DWM_BLURBEHIND
{
	DWORD dwFlags;
	BOOL fEnable;
	HRGN hRgnBlur;
	BOOL fTransitionOnMaximized;
}
alias DWM_BLURBEHIND* PDWM_BLURBEHIND;

enum DWMWINDOWATTRIBUTE
{
	DWMWA_NCRENDERING_ENABLED = 1,
	DWMWA_NCRENDERING_POLICY,
	DWMWA_TRANSITIONS_FORCEDISABLED,
	DWMWA_ALLOW_NCPAINT,
	DWMWA_CAPTION_BUTTON_BOUNDS,
	DWMWA_NONCLIENT_RTL_LAYOUT,
	DWMWA_FORCE_ICONIC_REPRESENTATION,
	DWMWA_FLIP3D_POLICY,
	DWMWA_EXTENDED_FRAME_BOUNDS,
	DWMWA_HAS_ICONIC_BITMAP,
	DWMWA_DISALLOW_PEEK,
	DWMWA_EXCLUDED_FROM_PEEK,
	DWMWA_LAST
}

enum DWMNCRENDERINGPOLICY
{
	DWMNCRP_USEWINDOWSTYLE,
	DWMNCRP_DISABLED,
	DWMNCRP_ENABLED,
	DWMNCRP_LAST
}

enum DWMFLIP3DWINDOWPOLICY
{
	DWMFLIP3D_DEFAULT,
	DWMFLIP3D_EXCLUDEBELOW,
	DWMFLIP3D_EXCLUDEABOVE,
	DWMFLIP3D_LAST
};

alias HANDLE HTHUMBNAIL;
alias HTHUMBNAIL* PHTHUMBNAIL;

immutable uint DWM_TNP_RECTDESTINATION      = 0x00000001;
immutable uint DWM_TNP_RECTSOURCE           = 0x00000002;
immutable uint DWM_TNP_OPACITY              = 0x00000004;
immutable uint DWM_TNP_VISIBLE              = 0x00000008;
immutable uint DWM_TNP_SOURCECLIENTAREAONLY = 0x00000010;

align(1)
struct DWM_THUMBNAIL_PROPERTIES
{
	DWORD dwFlags;
	RECT rcDestination;
	RECT rcSource;
	BYTE opacity;
	BOOL fVisible;
	BOOL fSourceClientAreaOnly;
}
alias DWM_THUMBNAIL_PROPERTIES* PDWM_THUMBNAIL_PROPERTIES;

alias ULONGLONG DWM_FRAME_COUNT;
alias ULONGLONG QPC_TIME;

align(1)
struct UNSIGNED_RATIO
{
	UINT32 uiNumerator;
	UINT32 uiDenominator;
}

align(1)
struct DWM_TIMING_INFO
{
	UINT32 cbSize;
	UNSIGNED_RATIO rateRefresh;
	QPC_TIME qpcRefreshPeriod;
	UNSIGNED_RATIO rateCompose;
	QPC_TIME qpcVBlank;
	DWM_FRAME_COUNT cRefresh;
	UINT cDXRefresh;
	QPC_TIME qpcCompose;
	DWM_FRAME_COUNT cFrame;
	UINT cDXPresent;
	DWM_FRAME_COUNT cRefreshFrame;
	DWM_FRAME_COUNT cFrameSubmitted;
	UINT cDXPresentSubmitted;
	DWM_FRAME_COUNT cFrameConfirmed;
	UINT cDXPresentConfirmed;
	DWM_FRAME_COUNT cRefreshConfirmed;
	UINT cDXRefreshConfirmed;
	DWM_FRAME_COUNT cFramesLate;
	UINT cFramesOutstanding;
	DWM_FRAME_COUNT cFrameDisplayed;
	QPC_TIME qpcFrameDisplayed; 
	DWM_FRAME_COUNT cRefreshFrameDisplayed;
	DWM_FRAME_COUNT cFrameComplete;
	QPC_TIME qpcFrameComplete;
	DWM_FRAME_COUNT cFramePending;
	QPC_TIME qpcFramePending;
	DWM_FRAME_COUNT cFramesDisplayed;
	DWM_FRAME_COUNT cFramesComplete;
	DWM_FRAME_COUNT cFramesPending;
	DWM_FRAME_COUNT cFramesAvailable;
	DWM_FRAME_COUNT cFramesDropped;
	DWM_FRAME_COUNT cFramesMissed;
	DWM_FRAME_COUNT cRefreshNextDisplayed;
	DWM_FRAME_COUNT cRefreshNextPresented;
	DWM_FRAME_COUNT cRefreshesDisplayed;
	DWM_FRAME_COUNT cRefreshesPresented;
	DWM_FRAME_COUNT cRefreshStarted;
	ULONGLONG cPixelsReceived;
	ULONGLONG cPixelsDrawn;
	DWM_FRAME_COUNT cBuffersEmpty;
}

enum DWM_SOURCE_FRAME_SAMPLING
{
	DWM_SOURCE_FRAME_SAMPLING_POINT,
	DWM_SOURCE_FRAME_SAMPLING_COVERAGE,
	DWM_SOURCE_FRAME_SAMPLING_LAST
}

immutable uint c_DwmMaxQueuedBuffers = 8;
immutable uint c_DwmMaxMonitors = 16;
immutable uint c_DwmMaxAdapters = 16;

align(1)
struct DWM_PRESENT_PARAMETERS
{
	UINT32 cbSize;
	BOOL fQueue;
	DWM_FRAME_COUNT cRefreshStart;
	UINT cBuffer;
	BOOL fUseSourceRate;
	UNSIGNED_RATIO rateSource;
	UINT cRefreshesPerFrame;
	DWM_SOURCE_FRAME_SAMPLING eSampling;
}

immutable int DWM_FRAME_DURATION_DEFAULT = -1;

immutable uint DWM_EC_DISABLECOMPOSITION = 0;
immutable uint DWM_EC_ENABLECOMPOSITION  = 1;

immutable uint DWM_SIT_DISPLAYFRAME = 0x00000001;

align(1)
struct MilMatrix3x2D
{
	DOUBLE S_11;
	DOUBLE S_12;
	DOUBLE S_21;
	DOUBLE S_22;
	DOUBLE DX;
	DOUBLE DY;
}

alias MilMatrix3x2D MIL_MATRIX3X2D;

extern (Windows)
{
	BOOL DwmDefWindowProc(HWND hWnd, UINT msg, WPARAM wParam, LPARAM lParam, LRESULT* plResult);
	HRESULT DwmEnableBlurBehindWindow(HWND hWnd, const(DWM_BLURBEHIND)* pBlurBehind);
	HRESULT DwmEnableComposition(UINT uCompositionAction);
	HRESULT DwmEnableMMCSS(BOOL fEnableMMCSS);
	HRESULT DwmExtendFrameIntoClientArea(HWND hWnd, const(MARGINS)* pMarInset);
	HRESULT DwmGetColorizationColor(DWORD* pcrColorization, BOOL* pfOpaqueBlend);
	HRESULT DwmGetCompositionTimingInfo(HWND hwnd, DWM_TIMING_INFO* pTimingInfo);
	HRESULT DwmGetWindowAttribute(HWND hwnd, DWORD dwAttribute, PVOID pvAttribute, DWORD cbAttribute);
	HRESULT DwmIsCompositionEnabled(BOOL* pfEnabled);
	HRESULT DwmModifyPreviousDxFrameDuration(HWND hwnd, INT cRefreshes, BOOL fRelative);
	HRESULT DwmQueryThumbnailSourceSize(HTHUMBNAIL hThumbnail, PSIZE pSize);
	HRESULT DwmRegisterThumbnail(HWND hwndDestination, HWND hwndSource, PHTHUMBNAIL phThumbnailId);
	HRESULT DwmSetDxFrameDuration(HWND hwnd, INT cRefreshes);
	HRESULT DwmSetPresentParameters(HWND hwnd, DWM_PRESENT_PARAMETERS* pPresentParams);
	HRESULT DwmSetWindowAttribute(HWND hwnd, DWORD dwAttribute, LPCVOID pvAttribute, DWORD cbAttribute);
	HRESULT DwmUnregisterThumbnail(HTHUMBNAIL hThumbnailId);
	HRESULT DwmUpdateThumbnailProperties(HTHUMBNAIL hThumbnailId, const(DWM_THUMBNAIL_PROPERTIES)* ptnProperties);
	HRESULT DwmSetIconicThumbnail(HWND hwnd, HBITMAP hbmp, DWORD dwSITFlags);
	HRESULT DwmSetIconicLivePreviewBitmap(HWND hwnd, HBITMAP hbmp, POINT* pptClient, DWORD dwSITFlags);
	HRESULT DwmInvalidateIconicBitmaps(HWND hwnd);
	HRESULT DwmAttachMilContent(HWND hwnd);
	HRESULT DwmDetachMilContent(HWND hwnd);
	HRESULT DwmFlush();
	HRESULT DwmGetGraphicsStreamTransformHint(UINT uIndex, MilMatrix3x2D* pTransform);
	HRESULT DwmGetGraphicsStreamClient(UINT uIndex, UUID* pClientUuid);
	HRESULT DwmGetTransportAttributes(BOOL* pfIsRemoting, BOOL* pfIsConnected, DWORD* pDwGeneration);
}

