module jp.ku6.windows.win32api.objidl;

import jp.ku6.windows.win32api.w32api;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.winbase;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.rpcdcep;

extern (Windows):

struct COSERVERINFO
{
	DWORD dwReserved1;
	LPWSTR pwszName;
	COAUTHINFO* pAuthInfo;
	DWORD dwReserved2;
}

immutable IID IID_IMarshal = {0x00000003, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMarshal : IUnknown
{
	HRESULT GetUnmarshalClass(REFIID riid, void* pv, DWORD dwDestContext, void* pvDestContext, DWORD mshlflags, CLSID* pCid);
	HRESULT GetMarshalSizeMax(REFIID riid, void* pv, DWORD dwDestContext, void* pvDestContext, DWORD mshlflags, DWORD* pSize);
	HRESULT MarshalInterface(IStream pStm, REFIID riid, void* pv, DWORD dwDestContext, void* pvDestContext, DWORD mshlflags);
	HRESULT UnmarshalInterface(IStream pStm, REFIID riid, void** ppv);
	HRESULT ReleaseMarshalData(IStream pStm);
	HRESULT DisconnectObject(DWORD dwReserved);
}
alias IMarshal LPMARSHAL;

immutable IID IID_IMarshal2 = {0x000001cf, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMarshal2 : IMarshal
{
}
alias IMarshal2 LPMARSHAL2;

immutable IID IID_IMalloc = {0x00000002, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMalloc : IUnknown
{
	void* Alloc(SIZE_T cb);
	void* Realloc(void* pv, SIZE_T cb);
	void Free(void* pv);
	SIZE_T GetSize(void* pv);
	int DidAlloc(void* pv);
	void HeapMinimize();
}
alias IMalloc LPMALLOC;

immutable IID IID_IMallocSpy = {0x0000001d, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMallocSpy : IUnknown
{
	SIZE_T PreAlloc(SIZE_T cbRequest);
	void* PostAlloc(void* pActual);
	void* PreFree(void* pRequest, BOOL fSpyed);
	void PostFree(BOOL fSpyed);
	SIZE_T PreRealloc(void* pRequest, SIZE_T cbRequest, void** ppNewRequest, BOOL fSpyed);
	void* PostRealloc(void* pActual, BOOL fSpyed);
	void* PreGetSize(void* pRequest, BOOL fSpyed);
	SIZE_T PostGetSize(SIZE_T cbActual, BOOL fSpyed);
	void* PreDidAlloc(void* pRequest, BOOL fSpyed);
	int PostDidAlloc(void* pRequest, BOOL fSpyed, int fActual);
	void PreHeapMinimize();
	void PostHeapMinimize();
}
alias IMallocSpy LPMALLOCSPY;

immutable IID IID_IStdMarshalInfo = {0x00000018, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IStdMarshalInfo : IUnknown
{
	HRESULT GetClassForHandler(DWORD dwDestContext, void* pvDestContext, CLSID* pClsid);
}
alias IStdMarshalInfo LPSTDMARSHALINFO;

enum EXTCONN
{
	EXTCONN_STRONG   = 0x1,
	EXTCONN_WEAK     = 0x2,
	EXTCONN_CALLABLE = 0x4,
}

immutable IID IID_IExternalConnection = {0x00000019, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IExternalConnection : IUnknown
{
	DWORD AddConnection(DWORD extconn, DWORD reserved);
	DWORD ReleaseConnection(DWORD extconn, DWORD reserved, BOOL fLastReleaseCloses);
}
alias IExternalConnection LPEXTERNALCONNECTION;

struct MULTI_QI
{
	const(IID)* pIID;
	IUnknown pItf;
	HRESULT hr;
}

immutable IID IID_IMultiQI = {0x00000020, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMultiQI : IUnknown
{
	HRESULT QueryMultipleInterfaces(ULONG cMQIs, MULTI_QI* pMQIs);
}
alias IMultiQI LPMULTIQI;

immutable IID IID_AsyncIMultiQI = {0x000e0020, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface AsyncIMultiQI : IUnknown
{
	HRESULT Begin_QueryMultipleInterfaces(ULONG cMQIs, MULTI_QI* pMQIs);
	HRESULT Finish_QueryMultipleInterfaces(MULTI_QI* pMQIs);
}

immutable IID IID_IInternalUnknown = {0x00000021, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IInternalUnknown : IUnknown
{
	HRESULT QueryInternalInterface(REFIID riid, void** ppv);
}

immutable IID IID_IEnumUnknown = {0x00000100, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumUnknown : IUnknown
{
	HRESULT Next(ULONG celt, IUnknown* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumUnknown* ppenum);
}
alias IEnumUnknown LPENUMUNKNOWN;

HRESULT IEnumUnknown_RemoteNext_Proxy(IEnumUnknown This, ULONG celt, IUnknown* rgelt, ULONG* pceltFetched);
void IEnumUnknown_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD _pdwStubPhase);

struct BIND_OPTS
{
	DWORD cbStruct;
	DWORD grfFlags;
	DWORD grfMode;
	DWORD dwTickCountDeadline;
}
alias BIND_OPTS* LPBIND_OPTS;

struct BIND_OPTS2
{
	DWORD cbStruct;
	DWORD grfFlags;
	DWORD grfMode;
	DWORD dwTickCountDeadline;
	DWORD dwTrackFlags;
	DWORD dwClassContext;
	LCID locale;
	COSERVERINFO* pServerInfo;
}
alias BIND_OPTS2* LPBIND_OPTS2;

struct BIND_OPTS3
{
	DWORD cbStruct;
	DWORD grfFlags;
	DWORD grfMode;
	DWORD dwTickCountDeadline;
	DWORD dwTrackFlags;
	DWORD dwClassContext;
	LCID locale;
	COSERVERINFO* pServerInfo;
	HWND hwnd;
}
alias BIND_OPTS3* LPBIND_OPTS3;

enum BIND_FLAGS
{
	BIND_MAYBOTHERUSER     = 1,
	BIND_JUSTTESTEXISTENCE = 2,
}

immutable IID IID_IBindCtx = {0x0000000e, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IBindCtx : IUnknown
{
	HRESULT RegisterObjectBound(IUnknown punk);
	HRESULT RevokeObjectBound(IUnknown punk);
	HRESULT ReleaseBoundObjects();
	HRESULT SetBindOptions(BIND_OPTS* pbindopts);
	HRESULT GetBindOptions(BIND_OPTS* pbindopts);
	HRESULT GetRunningObjectTable(IRunningObjectTable* pprot);
	HRESULT RegisterObjectParam(LPOLESTR pszKey, IUnknown punk);
	HRESULT GetObjectParam(LPOLESTR pszKey, IUnknown* ppunk);
	HRESULT EnumObjectParam(IEnumString* ppenum);
	HRESULT RevokeObjectParam(LPOLESTR pszKey);
}
alias IBindCtx LPBC;
alias IBindCtx LPBINDCTX;

HRESULT IBindCtx_RemoteSetBindOptions_Proxy(IBindCtx This, BIND_OPTS2* pbindopts);
void IBindCtx_RemoteSetBindOptions_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IBindCtx_RemoteGetBindOptions_Proxy(IBindCtx This, BIND_OPTS2* pbindopts);
void IBindCtx_RemoteGetBindOptions_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IEnumMoniker = {0x00000102, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumMoniker : IUnknown
{
	HRESULT Next(ULONG celt, IMoniker* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumMoniker* ppenum);
}
alias IEnumMoniker LPENUMMONIKER;

HRESULT IEnumMoniker_RemoteNext_Proxy(IEnumMoniker This, ULONG celt, IMoniker* rgelt, ULONG* pceltFetched);
void IEnumMoniker_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IRunnableObject = {0x00000126, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IRunnableObject : IUnknown
{
	HRESULT GetRunningClass(LPCLSID lpClsid);
	HRESULT Run(LPBINDCTX pbc);
	BOOL IsRunning();
	HRESULT LockRunning(BOOL fLock, BOOL fLastUnlockCloses);
	HRESULT SetContainedObject(BOOL fContained);
}
alias IRunnableObject LPRUNNABLEOBJECT;

HRESULT IRunnableObject_RemoteIsRunning_Proxy(IRunnableObject This);
void IRunnableObject_RemoteIsRunning_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IRunningObjectTable = {0x00000010, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IRunningObjectTable : IUnknown
{
	HRESULT Register(DWORD grfFlags, IUnknown punkObject, IMoniker pmkObjectName, DWORD* pdwRegister);
	HRESULT Revoke(DWORD dwRegister);
	HRESULT IsRunning(IMoniker pmkObjectName);
	HRESULT GetObject(IMoniker pmkObjectName, IUnknown* ppunkObject);
	HRESULT NoteChangeTime(DWORD dwRegister, FILETIME* pfiletime);
	HRESULT GetTimeOfLastChange(IMoniker pmkObjectName, FILETIME* pfiletime);
	HRESULT EnumRunning(IEnumMoniker* ppenumMoniker);
}
alias IRunningObjectTable LPRUNNINGOBJECTTABLE;

immutable IID IID_IPersist = {0x0000010c, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPersist : IUnknown
{
	HRESULT GetClassID(CLSID* pClassID);
}
alias IPersist LPPERSIST;

immutable IID IID_IPersistStream = {0x00000109, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPersistStream : IPersist
{
	HRESULT IsDirty();
	HRESULT Load(IStream pStm);
	HRESULT Save(IStream pStm, BOOL fClearDirty);
	HRESULT GetSizeMax(ULARGE_INTEGER* pcbSize);
}
alias IPersistStream LPPERSISTSTREAM;

enum MKSYS
{
	MKSYS_NONE             = 0,
	MKSYS_GENERICCOMPOSITE = 1,
	MKSYS_FILEMONIKER      = 2,
	MKSYS_ANTIMONIKER      = 3,
	MKSYS_ITEMMONIKER      = 4,
	MKSYS_POINTERMONIKER   = 5,
	MKSYS_CLASSMONIKER     = 7,
	MKSYS_OBJREFMONIKER    = 8,
	MKSYS_SESSIONMONIKER   = 9,
	MKSYS_LUAMONIKER       = 10
}


enum MKRREDUCE
{
	MKRREDUCE_ONE         = 3 << 16,
	MKRREDUCE_TOUSER      = 2 << 16,
	MKRREDUCE_THROUGHUSER = 1 << 16,
	MKRREDUCE_ALL         = 0,
}

immutable IID IID_IMoniker = {0x0000000f, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMoniker : IPersistStream
{
	HRESULT BindToObject(IBindCtx pbc, IMoniker pmkToLeft, REFIID riidResult, void** ppvResult);
	HRESULT BindToStorage(IBindCtx pbc, IMoniker pmkToLeft, REFIID riid, void** ppvObj);
	HRESULT Reduce(IBindCtx pbc, DWORD dwReduceHowFar, IMoniker* ppmkToLeft, IMoniker* ppmkReduced);
	HRESULT ComposeWith(IMoniker pmkRight, BOOL fOnlyIfNotGeneric, IMoniker* ppmkComposite);
	HRESULT Enum(BOOL fForward, IEnumMoniker* ppenumMoniker);
	HRESULT IsEqual(IMoniker pmkOtherMoniker);
	HRESULT Hash(DWORD* pdwHash);
	HRESULT IsRunning(IBindCtx pbc, IMoniker pmkToLeft, IMoniker pmkNewlyRunning);
	HRESULT GetTimeOfLastChange(IBindCtx pbc, IMoniker pmkToLeft, FILETIME* pFileTime);
	HRESULT Inverse(IMoniker* ppmk);
	HRESULT CommonPrefixWith(IMoniker pmkOther, IMoniker* ppmkPrefix);
	HRESULT RelativePathTo(IMoniker pmkOther, IMoniker* ppmkRelPath);
	HRESULT GetDisplayName(IBindCtx pbc, IMoniker pmkToLeft,
	LPOLESTR* ppszDisplayName);
	HRESULT ParseDisplayName(IBindCtx pbc, IMoniker pmkToLeft, LPOLESTR pszDisplayName, ULONG* pchEaten, IMoniker* ppmkOut);
	HRESULT IsSystemMoniker(DWORD* pdwMksys);
}
alias IMoniker LPMONIKER;

HRESULT IMoniker_RemoteBindToObject_Proxy(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riidResult, IUnknown* ppvResult);
void IMoniker_RemoteBindToObject_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IMoniker_RemoteBindToStorage_Proxy(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riid, IUnknown* ppvObj);
void IMoniker_RemoteBindToStorage_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IROTData = {0xf29f6bc0, 0x5021, 0x11ce, [0xaa, 0x15, 0x00, 0x00, 0x69, 0x01, 0x29, 0x3f]};
interface IROTData : IUnknown
{
	HRESULT GetComparisonData(byte* pbData, ULONG cbMax, ULONG* pcbData);
}

immutable IID IID_IEnumString = {0x00000101, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumString : IUnknown
{
	HRESULT Next(ULONG celt, LPOLESTR* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumString* ppenum);
}
alias IEnumString LPENUMSTRING;


HRESULT IEnumString_RemoteNext_Proxy(IEnumString This, ULONG celt, LPOLESTR* rgelt, ULONG* pceltFetched);
void IEnumString_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_ISequentialStream = {0x0c733a30, 0x2a1c, 0x11ce, [0xad, 0xe5, 0x00, 0xaa, 0x00, 0x44, 0x77, 0x3d]};
interface ISequentialStream : IUnknown
{
	HRESULT Read(void *pv, ULONG cb, ULONG* pcbRead);
	HRESULT Write(const(void)* pv, ULONG cb, ULONG* pcbWritten);
}

HRESULT ISequentialStream_RemoteRead_Proxy(ISequentialStream This, byte *pv, ULONG cb, ULONG* pcbRead);
void ISequentialStream_RemoteRead_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT ISequentialStream_RemoteWrite_Proxy(ISequentialStream This, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
void ISequentialStream_RemoteWrite_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

struct STATSTG
{
	LPOLESTR pwcsName;
	DWORD type;
	ULARGE_INTEGER cbSize;
	FILETIME mtime;
	FILETIME ctime;
	FILETIME atime;
	DWORD grfMode;
	DWORD grfLocksSupported;
	CLSID clsid;
	DWORD grfStateBits;
	DWORD reserved;
} 
enum STGTY
{
	STGTY_STORAGE   = 1,
	STGTY_STREAM,
	STGTY_LOCKBYTES,
	STGTY_PROPERTY,
}

enum STREAM_SEEK
{
	STREAM_SEEK_SET,
	STREAM_SEEK_CUR,
	STREAM_SEEK_END,
}

enum LOCKTYPE
{
	LOCK_WRITE     = 1,
	LOCK_EXCLUSIVE = 2,
	LOCK_ONLYONCE  = 4,
}

immutable IID IID_IStream = {0x0000000c, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IStream : ISequentialStream
{
	HRESULT Seek(LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER* plibNewPosition);
	HRESULT SetSize(ULARGE_INTEGER libNewSize);
	HRESULT CopyTo(IStream pstm, ULARGE_INTEGER cb, ULARGE_INTEGER* pcbRead, ULARGE_INTEGER* pcbWritten);
	HRESULT Commit(DWORD grfCommitFlags);
	HRESULT Revert();
	HRESULT LockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType);
	HRESULT UnlockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType);
	HRESULT Stat(STATSTG* pstatstg, DWORD grfStatFlag);
	HRESULT Clone(IStream* ppstm);
}
alias IStream LPSTREAM;

HRESULT IStream_RemoteSeek_Proxy(IStream This, LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER* plibNewPosition);
void IStream_RemoteSeek_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IStream_RemoteCopyTo_Proxy(IStream This, IStream pstm, ULARGE_INTEGER cb, ULARGE_INTEGER* pcbRead, ULARGE_INTEGER* pcbWritten);
void IStream_RemoteCopyTo_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IEnumSTATSTG = {0x0000000d, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumSTATSTG : IUnknown
{
	HRESULT Next(ULONG celt, STATSTG* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumSTATSTG* ppenum);
}
alias IEnumSTATSTG LPENUMSTATSTG;

HRESULT IEnumSTATSTG_RemoteNext_Proxy(IEnumSTATSTG This, ULONG celt, STATSTG* rgelt, ULONG* pceltFetched);
void IEnumSTATSTG_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

struct RemSNB
{
	uint ulCntStr;
	uint ulCntChar;
	OLECHAR rgString[ 1 ];
}
alias RemSNB* wireSNB;
alias LPOLESTR* SNB;

immutable IID IID_IStorage = {0x0000000b, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IStorage : IUnknown
{
	HRESULT CreateStream(const(OLECHAR)* pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved2, IStream* ppstm);
	HRESULT OpenStream(const(OLECHAR)* pwcsName, void* reserved1, DWORD grfMode, DWORD reserved2, IStream* ppstm);
	HRESULT CreateStorage(const(OLECHAR)* pwcsName, DWORD grfMode, DWORD reserved1, DWORD reserved2, IStorage* ppstg);
	HRESULT OpenStorage(const(OLECHAR)* pwcsName, IStorage pstgPriority, DWORD grfMode, SNB snbExclude, DWORD reserved, IStorage* ppstg);
	HRESULT CopyTo(DWORD ciidExclude, const(IID)* rgiidExclude, SNB snbExclude, IStorage pstgDest);
	HRESULT MoveElementTo(const(OLECHAR)* pwcsName, IStorage pstgDest, const(OLECHAR)* pwcsNewName, DWORD grfFlags);
	HRESULT Commit(DWORD grfCommitFlags);
	HRESULT Revert();
	HRESULT EnumElements(DWORD reserved1, void* reserved2, DWORD reserved3, IEnumSTATSTG* ppenum);
	HRESULT DestroyElement(const(OLECHAR)* pwcsName);
	HRESULT RenameElement(const(OLECHAR)* pwcsOldName, const(OLECHAR)* pwcsNewName);
	HRESULT SetElementTimes(const(OLECHAR)* pwcsName, const(FILETIME)* pctime, const(FILETIME)* patime, const(FILETIME)* pmtime);
	HRESULT SetClass(REFCLSID clsid);
	HRESULT SetStateBits(DWORD grfStateBits, DWORD grfMask);
	HRESULT Stat(STATSTG* pstatstg, DWORD grfStatFlag);
}
alias IStorage LPSTORAGE;

HRESULT IStorage_RemoteOpenStream_Proxy(IStorage This, const(OLECHAR)* pwcsName, uint cbReserved1, byte* reserved1, DWORD grfMode, DWORD reserved2, IStream* ppstm);
void IStorage_RemoteOpenStream_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IStorage_RemoteCopyTo_Proxy(IStorage This, DWORD ciidExclude, const(IID)* rgiidExclude, SNB snbExclude, IStorage pstgDest);
void IStorage_RemoteCopyTo_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IStorage_RemoteEnumElements_Proxy(IStorage This, DWORD reserved1, uint cbReserved2, byte* reserved2, DWORD reserved3, IEnumSTATSTG* ppenum);
void IStorage_RemoteEnumElements_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IPersistFile = {0x0000010b, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPersistFile : IPersist
{
	HRESULT IsDirty();
	HRESULT Load(LPCOLESTR pszFileName, DWORD dwMode);
	HRESULT Save(LPCOLESTR pszFileName, BOOL fRemember);
	HRESULT SaveCompleted(LPCOLESTR pszFileName);
	HRESULT GetCurFile(LPOLESTR* ppszFileName);
}
alias IPersistFile LPPERSISTFILE;

immutable IID IID_IPersistStorage = {0x0000010a, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPersistStorage : IPersist
{
	HRESULT IsDirty();
	HRESULT InitNew(IStorage pStg);
	HRESULT Load(IStorage pStg);
	HRESULT Save(IStorage pStgSave, BOOL fSameAsLoad);
	HRESULT SaveCompleted(IStorage pStgNew);
	HRESULT HandsOffStorage();
}
alias IPersistStorage LPPERSISTSTORAGE;

immutable IID IID_ILockBytes = {0x0000000a, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ILockBytes : IUnknown
{
	HRESULT ReadAt(ULARGE_INTEGER ulOffset, void* pv, ULONG cb, ULONG* pcbRead);
	HRESULT WriteAt(ULARGE_INTEGER ulOffset, const(void)* pv, ULONG cb, ULONG* pcbWritten);
	HRESULT Flush();
	HRESULT SetSize(ULARGE_INTEGER cb);
	HRESULT LockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType);
	HRESULT UnlockRegion(ULARGE_INTEGER libOffset, ULARGE_INTEGER cb, DWORD dwLockType);
	HRESULT Stat(STATSTG* pstatstg, DWORD grfStatFlag);
}
alias ILockBytes LPLOCKBYTES;

HRESULT ILockBytes_RemoteReadAt_Proxy(ILockBytes This, ULARGE_INTEGER ulOffset, byte* pv, ULONG cb, ULONG* pcbRead);
void ILockBytes_RemoteReadAt_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT ILockBytes_RemoteWriteAt_Proxy(ILockBytes This, ULARGE_INTEGER ulOffset, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
void ILockBytes_RemoteWriteAt_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

struct DVTARGETDEVICE
{
	DWORD tdSize;
	WORD tdDriverNameOffset;
	WORD tdDeviceNameOffset;
	WORD tdPortNameOffset;
	WORD tdExtDevmodeOffset;
	BYTE[1] tdData;
}

struct FORMATETC
{
	CLIPFORMAT cfFormat;
	DVTARGETDEVICE* ptd;
	DWORD dwAspect;
	LONG lindex;
	DWORD tymed;
}
alias FORMATETC* LPFORMATETC;

immutable IID IID_IEnumFORMATETC = {0x00000103, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumFORMATETC : IUnknown
{
	HRESULT Next(ULONG celt, FORMATETC* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumFORMATETC* ppenum);
}
alias IEnumFORMATETC LPENUMFORMATETC;

HRESULT IEnumFORMATETC_RemoteNext_Proxy(IEnumFORMATETC This, ULONG celt, FORMATETC* rgelt, ULONG* pceltFetched);
void IEnumFORMATETC_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

enum ADVF
{
	ADVF_NODATA            = 1,
	ADVF_PRIMEFIRST        = 2,
	ADVF_ONLYONCE          = 4,
	ADVF_DATAONSTOP        = 64,
	ADVFCACHE_NOHANDLER    = 8,
	ADVFCACHE_FORCEBUILTIN = 16,
	ADVFCACHE_ONSAVE       = 32,
}

struct STATDATA
{
	FORMATETC formatetc;
	DWORD advf;
	IAdviseSink pAdvSink;
	DWORD dwConnection;
}
alias STATDATA* LPSTATDATA;

immutable IID IID_IEnumSTATDATA = {0x00000105, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumSTATDATA : IUnknown
{
	HRESULT Next(ULONG celt, STATDATA* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumSTATDATA* ppenum);
}
alias IEnumSTATDATA LPENUMSTATDATA;

HRESULT IEnumSTATDATA_RemoteNext_Proxy(IEnumSTATDATA This, ULONG celt, STATDATA* rgelt, ULONG* pceltFetched);
void IEnumSTATDATA_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IRootStorage = {0x00000012, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IRootStorage : IUnknown
{
	HRESULT SwitchToFile(LPOLESTR pszFile);
}
alias IRootStorage LPROOTSTORAGE;

enum TYMED
{
	TYMED_HGLOBAL  = 1,
	TYMED_FILE     = 2,
	TYMED_ISTREAM  = 4,
	TYMED_ISTORAGE = 8,
	TYMED_GDI      = 16,
	TYMED_MFPICT   = 32,
	TYMED_ENHMF    = 64,
	TYMED_NULL     = 0,
}

struct RemSTGMEDIUM
{
	DWORD tymed;
	DWORD dwHandleType;
	uint pData;
	uint pUnkForRelease;
	uint cbData;
	byte[1] data;
}

struct uSTGMEDIUM
{
	DWORD tymed;
	union
	{
		HBITMAP hBitmap;
		HMETAFILEPICT hMetaFilePict;
		HENHMETAFILE hEnhMetaFile;
		HGLOBAL hGlobal;
		LPOLESTR lpszFileName;
		IStream pstm;
		IStorage pstg;
	}
	IUnknown pUnkForRelease;
}

struct GDI_OBJECT
{
	DWORD ObjectType;
	union
	{
		wireHBITMAP hBitmap;
		wireHPALETTE hPalette;
		wireHGLOBAL hGeneric;
	}
}

struct userSTGMEDIUM
{
	DWORD tymed;
	union
	{
		wireHMETAFILEPICT hMetaFilePict;
		wireHENHMETAFILE hHEnhMetaFile;
		GDI_OBJECT* hGdiHandle;
		wireHGLOBAL hGlobal;
		LPOLESTR lpszFileName;
		BYTE_BLOB* pstm;
		BYTE_BLOB* pstg;
	}
	IUnknown pUnkForRelease;
}
alias userSTGMEDIUM* wireSTGMEDIUM;
alias uSTGMEDIUM STGMEDIUM;
alias userSTGMEDIUM* wireASYNC_STGMEDIUM;
alias STGMEDIUM ASYNC_STGMEDIUM;
alias STGMEDIUM* LPSTGMEDIUM;

struct userFLAG_STGMEDIUM
{
	long ContextFlags;
	long fPassOwnership;
	userSTGMEDIUM Stgmed;
}
alias userFLAG_STGMEDIUM* wireFLAG_STGMEDIUM;

struct FLAG_STGMEDIUM
{
	long ContextFlags;
	long fPassOwnership;
	STGMEDIUM Stgmed;
}

immutable IID IID_IAdviseSink = {0x0000010f, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IAdviseSink : IUnknown
{
	void OnDataChange(FORMATETC* pFormatetc, STGMEDIUM* pStgmed);
	void OnViewChange(DWORD dwAspect, LONG lindex);
	void OnRename(IMoniker pmk);
	void OnSave();
	void OnClose();
}
alias IAdviseSink LPADVISESINK;

HRESULT IAdviseSink_RemoteOnDataChange_Proxy(IAdviseSink This, FORMATETC* pFormatetc, ASYNC_STGMEDIUM* pStgmed);
void IAdviseSink_RemoteOnDataChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IAdviseSink_RemoteOnViewChange_Proxy(IAdviseSink This, DWORD dwAspect, LONG lindex);
void IAdviseSink_RemoteOnViewChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IAdviseSink_RemoteOnRename_Proxy(IAdviseSink This, IMoniker pmk);
void IAdviseSink_RemoteOnRename_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IAdviseSink_RemoteOnSave_Proxy(IAdviseSink This);
void IAdviseSink_RemoteOnSave_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IAdviseSink_RemoteOnClose_Proxy(IAdviseSink This);
void IAdviseSink_RemoteOnClose_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_AsyncIAdviseSink = {0x00000150, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface AsyncIAdviseSink : IUnknown
{
	void Begin_OnDataChange(FORMATETC* pFormatetc, STGMEDIUM* pStgmed);
	void Finish_OnDataChange();
	void Begin_OnViewChange(DWORD dwAspect, LONG lindex);
	void Finish_OnViewChange();
	void Begin_OnRename(IMoniker pmk);
	void Finish_OnRename();
	void Begin_OnSave();
	void Finish_OnSave();
	void Begin_OnClose();
	void Finish_OnClose();
}

HRESULT AsyncIAdviseSink_Begin_RemoteOnDataChange_Proxy(AsyncIAdviseSink This, FORMATETC* pFormatetc, ASYNC_STGMEDIUM* pStgmed);
void AsyncIAdviseSink_Begin_RemoteOnDataChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Finish_RemoteOnDataChange_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_RemoteOnDataChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Begin_RemoteOnViewChange_Proxy(AsyncIAdviseSink This, DWORD dwAspect, LONG lindex);
void AsyncIAdviseSink_Begin_RemoteOnViewChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Finish_RemoteOnViewChange_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_RemoteOnViewChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Begin_RemoteOnRename_Proxy(AsyncIAdviseSink This, IMoniker pmk);
void AsyncIAdviseSink_Begin_RemoteOnRename_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Finish_RemoteOnRename_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_RemoteOnRename_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Begin_RemoteOnSave_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_RemoteOnSave_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Finish_RemoteOnSave_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_RemoteOnSave_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Begin_RemoteOnClose_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_RemoteOnClose_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink_Finish_RemoteOnClose_Proxy(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_RemoteOnClose_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IAdviseSink2 = {0x00000125, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IAdviseSink2 : IAdviseSink
{
	void OnLinkSrcChange(IMoniker pmk);
}
alias IAdviseSink2 LPADVISESINK2;

HRESULT IAdviseSink2_RemoteOnLinkSrcChange_Proxy(IAdviseSink2 This, IMoniker pmk);
void IAdviseSink2_RemoteOnLinkSrcChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_AsyncIAdviseSink2 = {0x00000151, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface AsyncIAdviseSink2 : AsyncIAdviseSink
{
	void Begin_OnLinkSrcChange(IMoniker pmk);
	void Finish_OnLinkSrcChange();
}

HRESULT AsyncIAdviseSink2_Begin_RemoteOnLinkSrcChange_Proxy(AsyncIAdviseSink2 This, IMoniker pmk);
void AsyncIAdviseSink2_Begin_RemoteOnLinkSrcChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT AsyncIAdviseSink2_Finish_RemoteOnLinkSrcChange_Proxy(AsyncIAdviseSink2 This);
void AsyncIAdviseSink2_Finish_RemoteOnLinkSrcChange_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

enum DATADIR
{
	DATADIR_GET = 1,
	DATADIR_SET = 2,
}

immutable IID IID_IDataObject = {0x0000010e, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IDataObject : IUnknown
{
	HRESULT GetData(FORMATETC* pformatetcIn, STGMEDIUM* pmedium);
	HRESULT GetDataHere(FORMATETC* pformatetc, STGMEDIUM* pmedium);
	HRESULT QueryGetData(FORMATETC* pformatetc);
	HRESULT GetCanonicalFormatEtc(FORMATETC* pformatectIn, FORMATETC* pformatetcOut);
	HRESULT SetData(FORMATETC* pformatetc, STGMEDIUM* pmedium, BOOL fRelease);
	HRESULT EnumFormatEtc(DWORD dwDirection, IEnumFORMATETC* ppenumFormatEtc);
	HRESULT DAdvise(FORMATETC* pformatetc, DWORD advf, IAdviseSink pAdvSink, DWORD* pdwConnection);
	HRESULT DUnadvise(DWORD dwConnection);
	HRESULT EnumDAdvise(IEnumSTATDATA* ppenumAdvise);
}
alias IDataObject LPDATAOBJECT;

HRESULT IDataObject_RemoteGetData_Proxy(IDataObject This, FORMATETC* pformatetcIn, STGMEDIUM* pRemoteMedium);
void IDataObject_RemoteGetData_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IDataObject_RemoteGetDataHere_Proxy(IDataObject This, FORMATETC* pformatetc, STGMEDIUM* pRemoteMedium);
void IDataObject_RemoteGetDataHere_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IDataObject_RemoteSetData_Proxy(IDataObject This, FORMATETC* pformatetc, FLAG_STGMEDIUM* pmedium, BOOL fRelease);
void IDataObject_RemoteSetData_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IDataAdviseHolder = {0x00000110, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IDataAdviseHolder : IUnknown
{
	HRESULT Advise(IDataObject pDataObject, FORMATETC* pFetc, DWORD advf, IAdviseSink pAdvise, DWORD* pdwConnection);
	HRESULT Unadvise(DWORD dwConnection);
	HRESULT EnumAdvise(IEnumSTATDATA* ppenumAdvise);
	HRESULT SendOnDataChange(IDataObject pDataObject, DWORD dwReserved, DWORD advf);
}
alias IDataAdviseHolder LPDATAADVISEHOLDER;

enum CALLTYPE
{
	CALLTYPE_TOPLEVEL             = 1,
	CALLTYPE_NESTED               = 2,
	CALLTYPE_ASYNC                = 3,
	CALLTYPE_TOPLEVEL_CALLPENDING = 4,
	CALLTYPE_ASYNC_CALLPENDING    = 5,
}

enum SERVERCALL
{
	SERVERCALL_ISHANDLED  = 0,
	SERVERCALL_REJECTED   = 1,
	SERVERCALL_RETRYLATER = 2,
}

enum PENDINGTYPE
{
	PENDINGTYPE_TOPLEVEL = 1,
	PENDINGTYPE_NESTED   = 2,
}

enum PENDINGMSG
{
	PENDINGMSG_CANCELCALL     = 0,
	PENDINGMSG_WAITNOPROCESS  = 1,
	PENDINGMSG_WAITDEFPROCESS = 2,
}

struct INTERFACEINFO
{
	IUnknown pUnk;
	IID iid;
	WORD wMethod;
}
alias INTERFACEINFO* LPINTERFACEINFO;

immutable IID IID_IMessageFilter = {0x00000016, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IMessageFilter : IUnknown
{
	DWORD HandleInComingCall(DWORD dwCallType, HTASK htaskCaller, DWORD dwTickCount, LPINTERFACEINFO lpInterfaceInfo);
	DWORD RetryRejectedCall(HTASK htaskCallee, DWORD dwTickCount, DWORD dwRejectType);
	DWORD MessagePending(HTASK htaskCallee, DWORD dwTickCount, DWORD dwPendingType);
}
alias IMessageFilter LPMESSAGEFILTER;

alias uint RPCOLEDATAREP;

struct RPCOLEMESSAGE
{
	void* reserved1;
	RPCOLEDATAREP dataRepresentation;
	void* Buffer;
	ULONG cbBuffer;
	ULONG iMethod;
	void*[5] reserved2;
	ULONG rpcFlags;
}
alias RPCOLEMESSAGE* PRPCOLEMESSAGE;

immutable IID IID_IRpcChannelBuffer = {0xD5F56B60, 0x593B, 0x101A, [0xB5, 0x69, 0x08, 0x00, 0x2B, 0x2D, 0xBF, 0x7A]};
interface IRpcChannelBuffer : IUnknown
{
	HRESULT GetBuffer(RPCOLEMESSAGE* pMessage, REFIID riid);
	HRESULT SendReceive(RPCOLEMESSAGE* pMessage, ULONG* pStatus);
	HRESULT FreeBuffer(RPCOLEMESSAGE* pMessage);
	HRESULT GetDestCtx(DWORD* pdwDestContext, void** ppvDestContext);
	HRESULT IsConnected();
}

immutable IID IID_IRpcChannelBuffer2 = {0x594f31d0, 0x7f19, 0x11d0, [0xb1, 0x94, 0x00, 0xa0, 0xc9, 0x0d, 0xc8, 0xbf]};
interface IRpcChannelBuffer2 : IRpcChannelBuffer
{
	HRESULT GetProtocolVersion(DWORD* pdwVersion);
}

immutable IID IID_IAsyncRpcChannelBuffer = {0xa5029fb6, 0x3c34, 0x11d1, [0x9c, 0x99, 0x00, 0xc0, 0x4f, 0xb9, 0x98, 0xaa]};
interface IAsyncRpcChannelBuffer : IRpcChannelBuffer2
{
	HRESULT Send(RPCOLEMESSAGE* pMsg, ISynchronize pSync, ULONG* pulStatus);
	HRESULT Receive(RPCOLEMESSAGE* pMsg, ULONG* pulStatus);
	HRESULT GetDestCtxEx(RPCOLEMESSAGE* pMsg, DWORD* pdwDestContext, void** ppvDestContext);
}

immutable IID IID_IRpcChannelBuffer3 = {0x25B15600, 0x0115, 0x11d0, [0xBF, 0x0D, 0x00, 0xAA, 0x00, 0xB8, 0xDF, 0xD2]};
interface IRpcChannelBuffer3 : IRpcChannelBuffer2
{
	HRESULT Send(RPCOLEMESSAGE* pMsg, ULONG* pulStatus);
	HRESULT Receive(RPCOLEMESSAGE* pMsg, ULONG ulSize, ULONG* pulStatus);
	HRESULT Cancel(RPCOLEMESSAGE* pMsg);
	HRESULT GetCallContext(RPCOLEMESSAGE* pMsg, REFIID riid, void** pInterface);
	HRESULT GetDestCtxEx(RPCOLEMESSAGE* pMsg, DWORD* pdwDestContext, void** ppvDestContext);
	HRESULT GetState(RPCOLEMESSAGE* pMsg, DWORD* pState);
	HRESULT RegisterAsync(RPCOLEMESSAGE* pMsg, IAsyncManager pAsyncMgr);
}

immutable IID IID_IRpcSyntaxNegotiate = {0x58a08519, 0x24c8, 0x4935, [0xb4, 0x82, 0x3f, 0xd8, 0x23, 0x33, 0x3a, 0x4f]};
interface IRpcSyntaxNegotiate : IUnknown
{
	HRESULT NegotiateSyntax(RPCOLEMESSAGE* pMsg);
}

immutable IID IID_IRpcProxyBuffer = {0xD5F56A34, 0x593B, 0x101A, [0xB5, 0x69, 0x08, 0x00, 0x2B, 0x2D, 0xBF, 0x7A]};
interface IRpcProxyBuffer : IUnknown
{
	HRESULT Connect(IRpcChannelBuffer pRpcChannelBuffer);
	void Disconnect();
}

immutable IID IID_IRpcStubBuffer = {0xD5F56AFC, 0x593B, 0x101A, [0xB5, 0x69, 0x08, 0x00, 0x2B, 0x2D, 0xBF, 0x7A]};
interface IRpcStubBuffer : IUnknown
{
	HRESULT Connect(IUnknown pUnkServer);
	void Disconnect();
	HRESULT Invoke(RPCOLEMESSAGE* _prpcmsg, IRpcChannelBuffer _pRpcChannelBuffer);
	IRpcStubBuffer IsIIDSupported(REFIID riid);
	ULONG CountRefs();
	HRESULT DebugServerQueryInterface(void** ppv);
	void DebugServerRelease(void* pv);
}

immutable IID IID_IPSFactoryBuffer = {0xD5F569D0, 0x593B, 0x101A, [0xB5, 0x69, 0x08, 0x00, 0x2B, 0x2D, 0xBF, 0x7A]};
interface IPSFactoryBuffer : IUnknown
{
	HRESULT CreateProxy(IUnknown pUnkOuter, REFIID riid, IRpcProxyBuffer* ppProxy, void** ppv);
	HRESULT CreateStub(REFIID riid, IUnknown pUnkServer, IRpcStubBuffer* ppStub);
}

static if  (_WIN32_WINNT >= 0x0400 || _WIN32_DCOM)
{
	struct SChannelHookCallInfo
	{
		IID iid;
		DWORD cbSize;
		GUID uCausality;
		DWORD dwServerPid;
		DWORD iMethod;
		void* pObject;
	}

	immutable IID IID_IChannelHook = {0x1008c4a0, 0x7613, 0x11cf, [0x9a, 0xf1, 0x00, 0x20, 0xaf, 0x6e, 0x72, 0xf4]};
	interface IChannelHook : IUnknown
	{
		void ClientGetSize(REFGUID uExtent, REFIID riid, ULONG* pDataSize);
		void ClientFillBuffer(REFGUID uExtent, REFIID riid, ULONG* pDataSize, void* pDataBuffer);
		void ClientNotify(REFGUID uExtent, REFIID riid, ULONG cbDataSize, void* pDataBuffer, DWORD lDataRep, HRESULT hrFault);
		void ServerNotify(REFGUID uExtent, REFIID riid, ULONG cbDataSize, void* pDataBuffer, DWORD lDataRep);
		void ServerGetSize(REFGUID uExtent, REFIID riid, HRESULT hrFault, ULONG* pDataSize);
		void ServerFillBuffer(REFGUID uExtent, REFIID riid, ULONG* pDataSize, void* pDataBuffer, HRESULT hrFault);
	}
}

immutable FMTID FMTID_SummaryInformation          = {0xF29F85E0, 0x4FF9, 0x1068, [0xAB, 0x91, 0x08, 0x00, 0x2B, 0x27, 0xB3, 0xD9]};
immutable FMTID FMTID_DocSummaryInformation       = {0xD5CDD502, 0x2E9C, 0x101B, [0x93, 0x97, 0x08, 0x00, 0x2B, 0x2C, 0xF9, 0xAE]};
immutable FMTID FMTID_UserDefinedProperties       = {0xD5CDD505, 0x2E9C, 0x101B, [0x93, 0x97, 0x08, 0x00, 0x2B, 0x2C, 0xF9, 0xAE]};
immutable FMTID FMTID_DiscardableInformation      = {0xD725EBB0, 0xC9B8, 0x11D1, [0x89, 0xBC, 0x00, 0x00, 0xF8, 0x04, 0xB0, 0x57]};
immutable FMTID FMTID_ImageSummaryInformation     = {0x6444048F, 0x4C8B, 0x11D1, [0x8B, 0x70, 0x08, 0x00, 0x36, 0xB1, 0x1A, 0x03]};
immutable FMTID FMTID_AudioSummaryInformation     = {0x64440490, 0x4C8B, 0x11D1, [0x8B, 0x70, 0x08, 0x00, 0x36, 0xB1, 0x1A, 0x03]};
immutable FMTID FMTID_VideoSummaryInformation     = {0x64440491, 0x4C8B, 0x11D1, [0x8B, 0x70, 0x08, 0x00, 0x36, 0xB1, 0x1A, 0x03]};
immutable FMTID FMTID_MediaFileSummaryInformation = {0x64440492, 0x4C8B, 0x11D1, [0x8B, 0x70, 0x08, 0x00, 0x36, 0xB1, 0x1A, 0x03]};

static if  (_WIN32_WINNT >= 0x0400 || _WIN32_DCOM)
{
	struct SOLE_AUTHENTICATION_SERVICE
	{
		DWORD dwAuthnSvc;
		DWORD dwAuthzSvc;
		OLECHAR* pPrincipalName;
		HRESULT hr;
	}
	alias SOLE_AUTHENTICATION_SERVICE* PSOLE_AUTHENTICATION_SERVICE;

	enum EOLE_AUTHENTICATION_CAPABILITIES
	{
		EOAC_NONE              = 0,
		EOAC_MUTUAL_AUTH       = 0x1,
		EOAC_STATIC_CLOAKING   = 0x20,
		EOAC_DYNAMIC_CLOAKING  = 0x40,
		EOAC_ANY_AUTHORITY     = 0x80,
		EOAC_MAKE_FULLSIC      = 0x100,
		EOAC_DEFAULT           = 0x800,
		EOAC_SECURE_REFS       = 0x2,
		EOAC_ACCESS_CONTROL    = 0x4,
		EOAC_APPID             = 0x8,
		EOAC_DYNAMIC           = 0x10,
		EOAC_REQUIRE_FULLSIC   = 0x200,
		EOAC_AUTO_IMPERSONATE  = 0x400,
		EOAC_NO_CUSTOM_MARSHAL = 0x2000,
		EOAC_DISABLE_AAA       = 0x1000,
	}

	immutable OLECHAR* COLE_DEFAULT_PRINCIPAL = cast(OLECHAR*)-1;
	immutable void*    COLE_DEFAULT_AUTHINFO  = cast(void*)-1;

	struct SOLE_AUTHENTICATION_INFO
	{
		DWORD dwAuthnSvc;
		DWORD dwAuthzSvc;
		void* pAuthInfo;
	}
	alias  SOLE_AUTHENTICATION_INFO* PSOLE_AUTHENTICATION_INFO;

	struct SOLE_AUTHENTICATION_LIST
	{
		DWORD cAuthInfo;
		SOLE_AUTHENTICATION_INFO* aAuthInfo;
	}
	alias SOLE_AUTHENTICATION_LIST* PSOLE_AUTHENTICATION_LIST;

	immutable IID IID_IClientSecurity = {0x0000013D, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IClientSecurity : IUnknown
	{
		HRESULT QueryBlanket(IUnknown pProxy, DWORD* pAuthnSvc, DWORD* pAuthzSvc, OLECHAR** pServerPrincName, DWORD* pAuthnLevel, DWORD* pImpLevel, void** pAuthInfo, DWORD* pCapabilites);
		HRESULT SetBlanket(IUnknown pProxy, DWORD dwAuthnSvc, DWORD dwAuthzSvc, OLECHAR* pServerPrincName, DWORD dwAuthnLevel, DWORD dwImpLevel, void* pAuthInfo, DWORD dwCapabilities);
		HRESULT CopyProxy(IUnknown pProxy, IUnknown* ppCopy);
	}

	immutable IID IID_IServerSecurity = {0x0000013E, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IServerSecurity : IUnknown
	{
		HRESULT QueryBlanket(DWORD* pAuthnSvc, DWORD* pAuthzSvc, OLECHAR** pServerPrincName, DWORD* pAuthnLevel, DWORD* pImpLevel, void** pPrivs, DWORD* pCapabilities);
		HRESULT ImpersonateClient();
		HRESULT RevertToSelf();
		BOOL IsImpersonating();
	}

	immutable IID IID_IClassActivator = {0x00000140, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IClassActivator : IUnknown
	{
		HRESULT GetClassObject(REFCLSID rclsid, DWORD dwClassContext, LCID locale, REFIID riid, void** ppv);
	}

	enum RPCOPT_PROPERTIES
	{
		COMBND_RPCTIMEOUT      = 0x1,
		COMBND_SERVER_LOCALITY = 0x2,
	}

	enum RPCOPT_SERVER_LOCALITY_VALUES
	{
		SERVER_LOCALITY_PROCESS_LOCAL = 0,
		SERVER_LOCALITY_MACHINE_LOCAL = 1,
		SERVER_LOCALITY_REMOTE        = 2,
	}

	immutable IID IID_IRpcOptions = {0x00000144, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IRpcOptions : IUnknown
	{
		HRESULT Set(IUnknown pPrx, RPCOPT_PROPERTIES dwProperty, ULONG_PTR dwValue);
		HRESULT Query(IUnknown pPrx, RPCOPT_PROPERTIES dwProperty, ULONG_PTR* pdwValue);
	}

	enum GLOBALOPT_PROPERTIES
	{
		COMGLB_EXCEPTION_HANDLING     = 1,
		COMGLB_APPID                  = 2,
		COMGLB_RPC_THREADPOOL_SETTING = 3,
	}

	enum GLOBALOPT_EH_VALUES
	{
		COMGLB_EXCEPTION_HANDLE             = 0,
		COMGLB_EXCEPTION_DONOT_HANDLE_FATAL = 1,
		COMGLB_EXCEPTION_DONOT_HANDLE       = COMGLB_EXCEPTION_DONOT_HANDLE_FATAL,
		COMGLB_EXCEPTION_DONOT_HANDLE_ANY   = 2,
	}

	enum GLOBALOPT_RPCTP_VALUES
	{
		COMGLB_RPC_THREADPOOL_SETTING_DEFAULT_POOL = 0,
		COMGLB_RPC_THREADPOOL_SETTING_PRIVATE_POOL = 1,
	}

	immutable IID IID_IGlobalOptions = {0x0000015B, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IGlobalOptions : IUnknown
	{
		HRESULT Set(GLOBALOPT_PROPERTIES dwProperty, ULONG_PTR dwValue);
		HRESULT Query(GLOBALOPT_PROPERTIES dwProperty, ULONG_PTR* pdwValue);
	}
}

immutable IID IID_IFillLockBytes = {0x99caf010, 0x415e, 0x11cf, [0x88, 0x14, 0x00, 0xaa, 0x00, 0xb5, 0x69, 0xf5]};
interface IFillLockBytes : IUnknown
{
	HRESULT FillAppend(const(void)* pv, ULONG cb, ULONG* pcbWritten);
	HRESULT FillAt(ULARGE_INTEGER ulOffset, const(void)* pv, ULONG cb, ULONG* pcbWritten);
	HRESULT SetFillSize(ULARGE_INTEGER ulSize);
	HRESULT Terminate(BOOL bCanceled);
}

HRESULT IFillLockBytes_RemoteFillAppend_Proxy(IFillLockBytes This, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
void IFillLockBytes_RemoteFillAppend_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
HRESULT IFillLockBytes_RemoteFillAt_Proxy(IFillLockBytes This, ULARGE_INTEGER ulOffset, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
void IFillLockBytes_RemoteFillAt_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IProgressNotify = {0xa9d758a0, 0x4617, 0x11cf, [0x95, 0xfc, 0x00, 0xaa, 0x00, 0x68, 0x0d, 0xb4]};
interface IProgressNotify : IUnknown
{
	HRESULT OnProgress(DWORD dwProgressCurrent, DWORD dwProgressMaximum, BOOL fAccurate, BOOL fOwner);
}

struct StorageLayout
{
	DWORD LayoutType;
	OLECHAR* pwcsElementName;
	LARGE_INTEGER cOffset;
	LARGE_INTEGER cBytes;
}

immutable IID IID_ILayoutStorage = {0x0e6d4d90, 0x6738, 0x11cf, [0x96, 0x08, 0x00, 0xaa, 0x00, 0x68, 0x0d, 0xb4]};
interface ILayoutStorage : IUnknown
{
	HRESULT LayoutScript(StorageLayout* pStorageLayout, DWORD nEntries, DWORD glfInterleavedFlag);
	HRESULT BeginMonitor();
	HRESULT EndMonitor();
	HRESULT ReLayoutDocfile(OLECHAR* pwcsNewDfName);
	HRESULT ReLayoutDocfileOnILockBytes(ILockBytes pILockBytes);
}

immutable IID IID_IBlockingLock = {0x30f3d47a, 0x6447, 0x11d1, [0x8e, 0x3c, 0x00, 0xc0, 0x4f, 0xb9, 0x38, 0x6d]};
interface IBlockingLock : IUnknown
{
	HRESULT Lock(DWORD dwTimeout);
	HRESULT Unlock();
}

immutable IID IID_ITimeAndNoticeControl = {0xbc0bf6ae, 0x8878, 0x11d1, [0x83, 0xe9, 0x00, 0xc0, 0x4f, 0xc2, 0xc6, 0xd4]};
interface ITimeAndNoticeControl : IUnknown
{
	HRESULT SuppressChanges(DWORD res1, DWORD res2);
}

immutable IID IID_IOplockStorage = {0x8d19c834, 0x8879, 0x11d1, [0x83, 0xe9, 0x00, 0xc0, 0x4f, 0xc2, 0xc6, 0xd4]};
interface IOplockStorage : IUnknown
{
	HRESULT CreateStorageEx(LPCWSTR pwcsName, DWORD grfMode, DWORD stgfmt, DWORD grfAttrs, REFIID riid, void** ppstgOpen);
	HRESULT OpenStorageEx(LPCWSTR pwcsName, DWORD grfMode, DWORD stgfmt, DWORD grfAttrs, REFIID riid, void** ppstgOpen);
}

immutable IID IID_ISurrogate = {0x00000022, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISurrogate : IUnknown
{
	HRESULT LoadDllServer(REFCLSID Clsid);
	HRESULT FreeSurrogate();
}
alias ISurrogate LPSURROGATE;

immutable IID IID_IGlobalInterfaceTable = {0x00000146, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IGlobalInterfaceTable : IUnknown
{
	HRESULT RegisterInterfaceInGlobal(IUnknown pUnk, REFIID riid, DWORD* pdwCookie);
	HRESULT RevokeInterfaceFromGlobal(DWORD dwCookie);
	HRESULT GetInterfaceFromGlobal(DWORD dwCookie, REFIID riid, void** ppv);
}
alias IGlobalInterfaceTable LPGLOBALINTERFACETABLE;

immutable IID IID_IDirectWriterLock = {0x0e6d4d92, 0x6738, 0x11cf, [0x96, 0x08, 0x00, 0xaa, 0x00, 0x68, 0x0d, 0xb4]};
interface IDirectWriterLock : IUnknown
{
	HRESULT WaitForWriteAccess(DWORD dwTimeout);
	HRESULT ReleaseWriteAccess();
	HRESULT HaveWriteAccess();
}

immutable IID IID_ISynchronize = {0x00000030, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISynchronize : IUnknown
{
	HRESULT Wait(DWORD dwFlags, DWORD dwMilliseconds);
	HRESULT Signal();
	HRESULT Reset();
}

immutable IID IID_ISynchronizeHandle = {0x00000031, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISynchronizeHandle : IUnknown
{
	HRESULT GetHandle(HANDLE* ph);
}

immutable IID IID_ISynchronizeEvent = {0x00000032, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISynchronizeEvent : ISynchronizeHandle
{
	HRESULT SetEventHandle(HANDLE* ph);
}

immutable IID IID_ISynchronizeContainer = {0x00000033, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISynchronizeContainer : IUnknown
{
	HRESULT AddSynchronize(ISynchronize pSync);
	HRESULT WaitMultiple(DWORD dwFlags, DWORD dwTimeOut, ISynchronize* ppSync);
}

immutable IID IID_ISynchronizeMutex = {0x00000025, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISynchronizeMutex : ISynchronize
{
	HRESULT ReleaseMutex();
}

immutable IID IID_ICancelMethodCalls = {0x00000029, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ICancelMethodCalls : IUnknown
{
	HRESULT Cancel(ULONG ulSeconds);
	HRESULT TestCancel();
}
alias ICancelMethodCalls LPCANCELMETHODCALLS;

enum DCOM_CALL_STATE
{
	DCOM_NONE          = 0,
	DCOM_CALL_COMPLETE = 0x1,
	DCOM_CALL_CANCELED = 0x2,
}

immutable IID IID_IAsyncManager = {0x0000002A, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IAsyncManager : IUnknown
{
	HRESULT CompleteCall(HRESULT Result);
	HRESULT GetCallContext(REFIID riid, void** pInterface);
	HRESULT GetState(ULONG* pulStateFlags);
}

immutable IID IID_ICallFactory = {0x1c733a30, 0x2a1c, 0x11ce, [0xad, 0xe5, 0x00, 0xaa, 0x00, 0x44, 0x77, 0x3d]};
interface ICallFactory : IUnknown
{
	HRESULT CreateCall(REFIID riid, IUnknown pCtrlUnk, REFIID riid2, IUnknown* ppv);
}

immutable IID IID_IRpcHelper = {0x00000149, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IRpcHelper : IUnknown
{
	HRESULT GetDCOMProtocolVersion(DWORD* pComVersion);
	HRESULT GetIIDFromOBJREF(void* pObjRef, IID** piid);
}

immutable IID IID_IReleaseMarshalBuffers = {0xeb0cb9e8, 0x7996, 0x11d2, [0x87, 0x2e, 0x00, 0x00, 0xf8, 0x08, 0x08, 0x59]};
interface IReleaseMarshalBuffers : IUnknown
{
	HRESULT ReleaseMarshalBuffer(RPCOLEMESSAGE* pMsg, DWORD dwFlags, IUnknown pChnl);
}

immutable IID IID_IWaitMultiple = {0x0000002B, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IWaitMultiple : IUnknown
{
	HRESULT WaitMultiple(DWORD timeout, ISynchronize* pSync);
	HRESULT AddSynchronize(ISynchronize pSync);
}

immutable IID IID_IUrlMon = {0x00000026, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IUrlMon : IUnknown
{
	HRESULT AsyncGetClassBits(REFCLSID rclsid, LPCWSTR pszTYPE, LPCWSTR pszExt, DWORD dwFileVersionMS, DWORD dwFileVersionLS, LPCWSTR pszCodeBase, IBindCtx pbc, DWORD dwClassContext, REFIID riid, DWORD flags);
}

immutable IID IID_IForegroundTransfer = {0x00000145, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IForegroundTransfer : IUnknown
{
	HRESULT AllowForegroundTransfer(void* lpvReserved);
}

immutable IID IID_IAddrTrackingControl = {0x00000147, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IAddrTrackingControl : IUnknown
{
	HRESULT EnableCOMDynamicAddrTracking();
	HRESULT DisableCOMDynamicAddrTracking();
}
alias IAddrTrackingControl LPADDRTRACKINGCONTROL;

immutable IID IID_IAddrExclusionControl = {0x00000148, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IAddrExclusionControl : IUnknown
{
	HRESULT GetCurrentAddrExclusionList(REFIID riid, void** ppEnumerator);
	HRESULT UpdateAddrExclusionList(IUnknown pEnumerator);
}
alias IAddrExclusionControl LPADDREXCLUSIONCONTROL;

immutable IID IID_IPipeByte = {0xDB2F3ACA, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface IPipeByte : IUnknown
{
	HRESULT Pull(BYTE* buf, ULONG cRequest, ULONG* pcReturned);
	HRESULT Push(BYTE* buf, ULONG cSent);
}

immutable IID IID_AsyncIPipeByte = {0xDB2F3ACB, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface AsyncIPipeByte : IUnknown
{
	HRESULT Begin_Pull(ULONG cRequest);
	HRESULT Finish_Pull(BYTE* buf, ULONG* pcReturned);
	HRESULT Begin_Push(BYTE* buf, ULONG cSent);
	HRESULT Finish_Push();
}

immutable IID IID_IPipeLong = {0xDB2F3ACC, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface IPipeLong : IUnknown
{
	HRESULT Pull(LONG* buf, ULONG cRequest, ULONG* pcReturned);
	HRESULT Push(LONG* buf, ULONG cSent);
}

immutable IID IID_AsyncIPipeLong = {0xDB2F3ACD, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface AsyncIPipeLong : IUnknown
{
	HRESULT Begin_Pull(ULONG cRequest);
	HRESULT Finish_Pull(LONG* buf, ULONG* pcReturned);
	HRESULT Begin_Push(LONG* buf, ULONG cSent);
	HRESULT Finish_Push();
}

immutable IID IID_IPipeDouble = {0xDB2F3ACE, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface IPipeDouble : IUnknown
{
	HRESULT Pull(DOUBLE* buf, ULONG cRequest, ULONG* pcReturned);
	HRESULT Push(DOUBLE* buf, ULONG cSent);
}

immutable IID IID_AsyncIPipeDouble = {0xDB2F3ACF, 0x2F86, 0x11d1, [0x8E, 0x04, 0x00, 0xC0, 0x4F, 0xB9, 0x98, 0x9A]};
interface AsyncIPipeDouble : IUnknown
{
	HRESULT Begin_Pull(ULONG cRequest);
	HRESULT Finish_Pull(DOUBLE* buf, ULONG* pcReturned);
	HRESULT Begin_Push(DOUBLE* buf, ULONG cSent);
	HRESULT Finish_Push();
}

immutable IID IID_IThumbnailExtractor = {0x969dc708, 0x5c76, 0x11d1, [0x8d, 0x86, 0x00, 0x00, 0xf8, 0x04, 0xb0, 0x57]};
interface IThumbnailExtractor : IUnknown
{
	HRESULT ExtractThumbnail(IStorage pStg, ULONG ulLength, ULONG ulHeight, ULONG* pulOutputLength, ULONG* pulOutputHeight, HBITMAP* phOutputBitmap);
	HRESULT OnFileUpdated(IStorage pStg);
}

immutable IID IID_IDummyHICONIncluder = {0x947990de, 0xcc28, 0x11d2, [0xa0, 0xf7, 0x00, 0x80, 0x5f, 0x85, 0x8f, 0xb1]};
interface IDummyHICONIncluder : IUnknown
{
	HRESULT Dummy(HICON h1, HDC h2);
}

alias DWORD CPFLAGS;
struct ContextProperty
{
	GUID policyId;
	CPFLAGS flags;
	IUnknown pUnk;
}

immutable IID IID_IEnumContextProps = {0x000001c1, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumContextProps : IUnknown
{
	HRESULT Next(ULONG celt, ContextProperty* pContextProperties, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumContextProps* ppEnumContextProps);
	HRESULT Count(ULONG* pcelt);
}
alias IEnumContextProps LPENUMCONTEXTPROPS;

immutable IID IID_IContext = {0x000001c0, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IContext : IUnknown
{
	HRESULT SetProperty(REFGUID rpolicyId, CPFLAGS flags, IUnknown pUnk);
	HRESULT RemoveProperty(REFGUID rPolicyId);
	HRESULT GetProperty(REFGUID rGuid, CPFLAGS* pFlags, IUnknown* ppUnk);
	HRESULT EnumContextProps(IEnumContextProps* ppEnumContextProps);
}

enum ApplicationType
{
	ServerApplication  = 0,
	LibraryApplication = 1,
}

enum ShutdownType
{
	IdleShutdown   = 0,
	ForcedShutdown = 1,
}

immutable IID IID_IProcessLock = {0x000001d5, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IProcessLock : IUnknown
{
	ULONG AddRefOnProcess();
	ULONG ReleaseRefOnProcess();
}

immutable IID IID_ISurrogateService = {0x000001d4, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface ISurrogateService : IUnknown
{
	HRESULT Init(REFGUID rguidProcessID, IProcessLock pProcessLock, BOOL* pfApplicationAware);
	HRESULT ApplicationLaunch(REFGUID rguidApplID, ApplicationType appType);
	HRESULT ApplicationFree(REFGUID rguidApplID);
	HRESULT CatalogRefresh(ULONG ulReserved);
	HRESULT ProcessShutdown(ShutdownType shutdownType);
}

enum APTTYPEQUALIFIER
{
	APTTYPEQUALIFIER_NONE,
	APTTYPEQUALIFIER_IMPLICIT_MTA,
	APTTYPEQUALIFIER_NA_ON_MTA,
	APTTYPEQUALIFIER_NA_ON_STA,
	APTTYPEQUALIFIER_NA_ON_IMPLICIT_MTA,
	APTTYPEQUALIFIER_NA_ON_MAINSTA,
}

enum APTTYPE
{
	APTTYPE_CURRENT = -1,
	APTTYPE_STA     = 0,
	APTTYPE_MTA     = 1,
	APTTYPE_NA      = 2,
	APTTYPE_MAINSTA = 3
}

enum THDTYPE
{
	THDTYPE_BLOCKMESSAGES   = 0,
	THDTYPE_PROCESSMESSAGES = 1,
}

alias DWORD APARTMENTID;

immutable IID IID_IComThreadingInfo = {0x000001ce, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IComThreadingInfo : IUnknown
{
	HRESULT GetCurrentApartmentType(APTTYPE* pAptType);
	HRESULT GetCurrentThreadType(THDTYPE* pThreadType);
	HRESULT GetCurrentLogicalThreadId(GUID* pguidLogicalThreadId);
	HRESULT SetCurrentLogicalThreadId(REFGUID rguid);
}

immutable IID IID_IProcessInitControl = {0x72380d55, 0x8d2b, 0x43a3, [0x85, 0x13, 0x2b, 0x6e, 0xf3, 0x14, 0x34, 0xe9]};
interface IProcessInitControl : IUnknown
{
	HRESULT ResetInitializerTimeout(DWORD dwSecondsRemaining);
}

static if  (_WIN32_WINNT >= 0x0501)
{
	immutable IID IID_IInitializeSpy = {0x00000034, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
	interface IInitializeSpy : IUnknown
	{
		HRESULT PreInitialize(DWORD dwCoInit, DWORD dwCurThreadAptRefs);
		HRESULT PostInitialize(HRESULT hrCoInit, DWORD dwCoInit, DWORD dwNewThreadAptRefs);
		HRESULT PreUninitialize(DWORD dwCurThreadAptRefs);
		HRESULT PostUninitialize(DWORD dwNewThreadAptRefs);
	}
	alias IInitializeSpy LPINITIALIZESPY;
}

uint ASYNC_STGMEDIUM_UserSize(uint*, uint, ASYNC_STGMEDIUM*); 
ubyte* ASYNC_STGMEDIUM_UserMarshal(uint*, ubyte*, ASYNC_STGMEDIUM*); 
ubyte* ASYNC_STGMEDIUM_UserUnmarshal(uint*, ubyte*, ASYNC_STGMEDIUM*);  
void ASYNC_STGMEDIUM_UserFree(uint*, ASYNC_STGMEDIUM*); 

uint CLIPFORMAT_UserSize(uint*, uint, CLIPFORMAT*); 
ubyte* CLIPFORMAT_UserMarshal(uint*, ubyte*, CLIPFORMAT*);
ubyte* CLIPFORMAT_UserUnmarshal(uint*, ubyte*, CLIPFORMAT*);
void CLIPFORMAT_UserFree(uint*, CLIPFORMAT*);

uint FLAG_STGMEDIUM_UserSize(uint*, uint, FLAG_STGMEDIUM*);
ubyte* FLAG_STGMEDIUM_UserMarshal(uint*, ubyte*, FLAG_STGMEDIUM*);
ubyte* FLAG_STGMEDIUM_UserUnmarshal(uint*, ubyte*, FLAG_STGMEDIUM*);
void FLAG_STGMEDIUM_UserFree(uint*, FLAG_STGMEDIUM*);

uint HBITMAP_UserSize(uint* pFlags, uint Offset, HBITMAP* pHbitmap);
ubyte* HBITMAP_UserMarshal(uint* pFlags, ubyte* pBuffer, HBITMAP* pHbitmap);
ubyte* HBITMAP_UserUnmarshal(uint* pFlags, ubyte* pBuffer, HBITMAP* pHbitmap);
void HBITMAP_UserFree(uint* pFlags, HBITMAP* pHbitmap);

uint HDC_UserSize(uint*, uint, HDC*);
ubyte* HDC_UserMarshal(uint*, ubyte*, HDC*);
ubyte* HDC_UserUnmarshal(uint*, ubyte*, HDC*);
void HDC_UserFree(uint*, HDC*);

uint HICON_UserSize(uint* pFlags, uint Offset, HICON* pHicon);
ubyte* HICON_UserMarshal(uint* pFlags, ubyte* pBuffer, HICON* pHicon);
ubyte* HICON_UserUnmarshal(uint* pFlags, ubyte* pBuffer, HICON* pHicon);
void HICON_UserFree(uint* pFlags, HICON* pHicon);

uint SNB_UserSize(uint*, uint, SNB*);
ubyte* SNB_UserMarshal(uint*, ubyte*, SNB*);
ubyte* SNB_UserUnmarshal(uint*, ubyte*, SNB*);
void SNB_UserFree(uint*, SNB*);

uint STGMEDIUM_UserSize(uint*, uint, STGMEDIUM*);
ubyte* STGMEDIUM_UserMarshal(uint*, ubyte*, STGMEDIUM*);
ubyte* STGMEDIUM_UserUnmarshal(uint*, ubyte*, STGMEDIUM*);
void STGMEDIUM_UserFree(uint*, STGMEDIUM*);

uint ASYNC_STGMEDIUM_UserSize64(uint*, uint, ASYNC_STGMEDIUM*);
ubyte* ASYNC_STGMEDIUM_UserMarshal64(uint*, ubyte*, ASYNC_STGMEDIUM*);
ubyte* ASYNC_STGMEDIUM_UserUnmarshal64(uint*, ubyte*, ASYNC_STGMEDIUM*);
void ASYNC_STGMEDIUM_UserFree64(uint*, ASYNC_STGMEDIUM*);

uint CLIPFORMAT_UserSize64(uint*, uint, CLIPFORMAT*);
ubyte* CLIPFORMAT_UserMarshal64(uint*, ubyte*, CLIPFORMAT*);
ubyte* CLIPFORMAT_UserUnmarshal64(uint*, ubyte*, CLIPFORMAT*);
void CLIPFORMAT_UserFree64(uint*, CLIPFORMAT*);

uint FLAG_STGMEDIUM_UserSize64(uint*, uint, FLAG_STGMEDIUM*);
ubyte* FLAG_STGMEDIUM_UserMarshal64(uint*, ubyte*, FLAG_STGMEDIUM*);
ubyte* FLAG_STGMEDIUM_UserUnmarshal64(uint*, ubyte*, FLAG_STGMEDIUM*);
void FLAG_STGMEDIUM_UserFree64(uint*, FLAG_STGMEDIUM*);

uint HBITMAP_UserSize64(uint* pFlags, uint Offset, HBITMAP* pHbitmap);
ubyte* HBITMAP_UserMarshal64(uint* pFlags, ubyte* pBuffer, HBITMAP* pHbitmap);
ubyte* HBITMAP_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HBITMAP* pHbitmap);
void HBITMAP_UserFree64(uint* pFlags, HBITMAP* pHbitmap);

uint HDC_UserSize64(uint*, uint, HDC*);
ubyte* HDC_UserMarshal64(uint*, ubyte*, HDC*);
ubyte* HDC_UserUnmarshal64(uint*, ubyte*, HDC*);
void HDC_UserFree64(uint*, HDC*);

uint HICON_UserSize64(uint* pFlags, uint Offset, HICON* pIcon);
ubyte* HICON_UserMarshal64(uint* pFlags, ubyte* pBuffer, HICON* pIcon);
ubyte* HICON_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HICON* pIcon);
void HICON_UserFree64(uint* pFlags, HICON* pIcon);

uint SNB_UserSize64(uint*, uint, SNB*);
ubyte* SNB_UserMarshal64(uint*, ubyte*, SNB*);
ubyte* SNB_UserUnmarshal64(uint*, ubyte*, SNB*);
void SNB_UserFree64(uint*, SNB*);

uint STGMEDIUM_UserSize64(uint*, uint, STGMEDIUM*);
ubyte* STGMEDIUM_UserMarshal64(uint*, ubyte*, STGMEDIUM*);
ubyte* STGMEDIUM_UserUnmarshal64(uint*, ubyte*, STGMEDIUM*);
void STGMEDIUM_UserFree64(uint*, STGMEDIUM*);

HRESULT IEnumUnknown_Next_Proxy(IEnumUnknown This, ULONG celt, IUnknown* rgelt, ULONG* pceltFetched);
HRESULT IEnumUnknown_Next_Stub(IEnumUnknown This, ULONG celt,IUnknown* rgelt, ULONG* pceltFetched);
HRESULT IBindCtx_SetBindOptions_Proxy(IBindCtx This, BIND_OPTS* pbindopts);
HRESULT IBindCtx_SetBindOptions_Stub(IBindCtx This, BIND_OPTS2* pbindopts);
HRESULT IBindCtx_GetBindOptions_Proxy(IBindCtx This, BIND_OPTS* pbindopts);
HRESULT IBindCtx_GetBindOptions_Stub(IBindCtx This, BIND_OPTS2* pbindopts);
HRESULT IEnumMoniker_Next_Proxy(IEnumMoniker This, ULONG celt, IMoniker* rgelt, ULONG* pceltFetched);
HRESULT IEnumMoniker_Next_Stub(IEnumMoniker This, ULONG celt, IMoniker* rgelt, ULONG* pceltFetched);
BOOL IRunnableObject_IsRunning_Proxy(IRunnableObject This);
HRESULT IRunnableObject_IsRunning_Stub(IRunnableObject This);
HRESULT IMoniker_BindToObject_Proxy(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riidResult, void** ppvResult);
HRESULT IMoniker_BindToObject_Stub(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riidResult, IUnknown* ppvResult);
HRESULT IMoniker_BindToStorage_Proxy(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riid, void** ppvObj);
HRESULT IMoniker_BindToStorage_Stub(IMoniker This, IBindCtx pbc, IMoniker pmkToLeft, REFIID riid, IUnknown* ppvObj);
HRESULT IEnumString_Next_Proxy(IEnumString This, ULONG celt, LPOLESTR* rgelt, ULONG* pceltFetched);
HRESULT IEnumString_Next_Stub(IEnumString This, ULONG celt, LPOLESTR* rgelt, ULONG* pceltFetched);
HRESULT ISequentialStream_Read_Proxy(ISequentialStream This, void* pv, ULONG cb, ULONG* pcbRead);
HRESULT ISequentialStream_Read_Stub(ISequentialStream This, byte* pv, ULONG cb, ULONG* pcbRead);
HRESULT ISequentialStream_Write_Proxy(ISequentialStream This, const(void)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT ISequentialStream_Write_Stub(ISequentialStream This, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT IStream_Seek_Proxy(IStream This, LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER* plibNewPosition);
HRESULT IStream_Seek_Stub(IStream This, LARGE_INTEGER dlibMove, DWORD dwOrigin, ULARGE_INTEGER* plibNewPosition);
HRESULT IStream_CopyTo_Proxy(IStream This, IStream pstm, ULARGE_INTEGER cb, ULARGE_INTEGER* pcbRead, ULARGE_INTEGER* pcbWritten);
HRESULT IStream_CopyTo_Stub(IStream This, IStream pstm, ULARGE_INTEGER cb, ULARGE_INTEGER* pcbRead, ULARGE_INTEGER* pcbWritten);
HRESULT IEnumSTATSTG_Next_Proxy(IEnumSTATSTG This, ULONG celt, STATSTG* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATSTG_Next_Stub(IEnumSTATSTG This, ULONG celt, STATSTG*rgelt, ULONG* pceltFetched);
HRESULT IStorage_OpenStream_Proxy(IStorage This, const(OLECHAR)* pwcsName, void* reserved1, DWORD grfMode, DWORD reserved2, IStream* ppstm);
HRESULT IStorage_OpenStream_Stub(IStorage This, const(OLECHAR)* pwcsName, uint cbReserved1, byte* reserved1, DWORD grfMode, DWORD reserved2, IStream* ppstm);
HRESULT IStorage_CopyTo_Proxy(IStorage This, DWORD ciidExclude, const(IID)* rgiidExclude, SNB snbExclude, IStorage pstgDest);
HRESULT IStorage_CopyTo_Stub(IStorage This, DWORD ciidExclude, const(IID)* rgiidExclude, SNB snbExclude, IStorage pstgDest);
HRESULT IStorage_EnumElements_Proxy(IStorage This, DWORD reserved1, void* reserved2, DWORD reserved3, IEnumSTATSTG* ppenum);
HRESULT IStorage_EnumElements_Stub(IStorage This, DWORD reserved1, uint cbReserved2, byte* reserved2, DWORD reserved3, IEnumSTATSTG* ppenum);
HRESULT ILockBytes_ReadAt_Proxy(ILockBytes This, ULARGE_INTEGER ulOffset, void* pv, ULONG cb, ULONG* pcbRead);
HRESULT ILockBytes_ReadAt_Stub(ILockBytes This, ULARGE_INTEGER ulOffset, byte* pv, ULONG cb, ULONG* pcbRead);
HRESULT ILockBytes_WriteAt_Proxy(ILockBytes This, ULARGE_INTEGER ulOffset, const(void)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT ILockBytes_WriteAt_Stub(ILockBytes This, ULARGE_INTEGER ulOffset, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT IEnumFORMATETC_Next_Proxy(IEnumFORMATETC This, ULONG celt, FORMATETC* rgelt, ULONG* pceltFetched);
HRESULT IEnumFORMATETC_Next_Stub(IEnumFORMATETC This, ULONG celt, FORMATETC* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATDATA_Next_Proxy(IEnumSTATDATA This, ULONG celt, STATDATA* rgelt, ULONG* pceltFetched);
HRESULT IEnumSTATDATA_Next_Stub(IEnumSTATDATA This, ULONG celt, STATDATA* rgelt, ULONG* pceltFetched);
void IAdviseSink_OnDataChange_Proxy(IAdviseSink This, FORMATETC* pFormatetc, STGMEDIUM* pStgmed);
HRESULT IAdviseSink_OnDataChange_Stub(IAdviseSink This, FORMATETC* pFormatetc, ASYNC_STGMEDIUM* pStgmed);
void IAdviseSink_OnViewChange_Proxy(IAdviseSink This, DWORD dwAspect, LONG lindex);
HRESULT IAdviseSink_OnViewChange_Stub(IAdviseSink This, DWORD dwAspect, LONG lindex);
void IAdviseSink_OnRename_Proxy(IAdviseSink This, IMoniker pmk);
HRESULT IAdviseSink_OnRename_Stub(IAdviseSink This, IMoniker pmk);
void IAdviseSink_OnSave_Proxy(IAdviseSink This);
HRESULT IAdviseSink_OnSave_Stub(IAdviseSink This);
void IAdviseSink_OnClose_Proxy(IAdviseSink This);
HRESULT IAdviseSink_OnClose_Stub(IAdviseSink This);
void IAdviseSink2_OnLinkSrcChange_Proxy(IAdviseSink2 This, IMoniker pmk);
HRESULT IAdviseSink2_OnLinkSrcChange_Stub(IAdviseSink2 This, IMoniker pmk);
HRESULT IDataObject_GetData_Proxy(IDataObject This, FORMATETC* pformatetcIn, STGMEDIUM* pmedium);
HRESULT IDataObject_GetData_Stub(IDataObject This, FORMATETC* pformatetcIn, STGMEDIUM* pRemoteMedium);
HRESULT IDataObject_GetDataHere_Proxy(IDataObject This, FORMATETC* pformatetc, STGMEDIUM* pmedium);
HRESULT IDataObject_GetDataHere_Stub(IDataObject This, FORMATETC* pformatetc, STGMEDIUM* pRemoteMedium);
HRESULT IDataObject_SetData_Proxy(IDataObject This, FORMATETC* pformatetc, STGMEDIUM* pmedium, BOOL fRelease);
HRESULT IDataObject_SetData_Stub(IDataObject This, FORMATETC* pformatetc, FLAG_STGMEDIUM* pmedium, BOOL fRelease);
HRESULT IFillLockBytes_FillAppend_Proxy(IFillLockBytes This, const(void)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT IFillLockBytes_FillAppend_Stub(IFillLockBytes This, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT IFillLockBytes_FillAt_Proxy(IFillLockBytes This, ULARGE_INTEGER ulOffset, const(void)* pv, ULONG cb, ULONG* pcbWritten);
HRESULT IFillLockBytes_FillAt_Stub(IFillLockBytes This, ULARGE_INTEGER ulOffset, const(byte)* pv, ULONG cb, ULONG* pcbWritten);
void AsyncIAdviseSink_Begin_OnDataChange_Proxy(AsyncIAdviseSink This, FORMATETC* pFormatetc, STGMEDIUM* pStgmed);
HRESULT AsyncIAdviseSink_Begin_OnDataChange_Stub(AsyncIAdviseSink This, FORMATETC* pFormatetc, ASYNC_STGMEDIUM* pStgmed);
void AsyncIAdviseSink_Finish_OnDataChange_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Finish_OnDataChange_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_OnViewChange_Proxy(AsyncIAdviseSink This, DWORD dwAspect, LONG lindex);
HRESULT AsyncIAdviseSink_Begin_OnViewChange_Stub(AsyncIAdviseSink This, DWORD dwAspect, LONG lindex);
void AsyncIAdviseSink_Finish_OnViewChange_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Finish_OnViewChange_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_OnRename_Proxy(AsyncIAdviseSink This, IMoniker pmk);
HRESULT AsyncIAdviseSink_Begin_OnRename_Stub(AsyncIAdviseSink This, IMoniker pmk);
void AsyncIAdviseSink_Finish_OnRename_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Finish_OnRename_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_OnSave_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Begin_OnSave_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_OnSave_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Finish_OnSave_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Begin_OnClose_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Begin_OnClose_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink_Finish_OnClose_Proxy(AsyncIAdviseSink This);
HRESULT AsyncIAdviseSink_Finish_OnClose_Stub(AsyncIAdviseSink This);
void AsyncIAdviseSink2_Begin_OnLinkSrcChange_Proxy(AsyncIAdviseSink2 This, IMoniker pmk);
HRESULT AsyncIAdviseSink2_Begin_OnLinkSrcChange_Stub(AsyncIAdviseSink2 This, IMoniker pmk);
void AsyncIAdviseSink2_Finish_OnLinkSrcChange_Proxy(AsyncIAdviseSink2 This);
HRESULT AsyncIAdviseSink2_Finish_OnLinkSrcChange_Stub(AsyncIAdviseSink2 This);

