/***********************************************************************\
*                                w32api.d                               *
*                                                                       *
*                       Windows API header module                       *
*                                                                       *
*             Translated from MinGW API for MS-Windows 3.12             *
*                           by Stewart Gordon                           *
*                                                                       *
*                       Placed into public domain                       *
\***********************************************************************/
module jp.ku6.windows.win32api.w32api;

const __W32API_VERSION = 3.12;
const __W32API_MAJOR_VERSION = 3;
const __W32API_MINOR_VERSION = 12;

immutable ushort _WIN32_WINNT_NT4      = 0x0400;
immutable ushort _WIN32_WINNT_WIN2K    = 0x0500;
immutable ushort _WIN32_WINNT_WINXP    = 0x0501;
immutable ushort _WIN32_WINNT_WS03     = 0x0502;
immutable ushort _WIN32_WINNT_WIN6     = 0x0600;
immutable ushort _WIN32_WINNT_VISTA    = 0x0600;
immutable ushort _WIN32_WINNT_WS08     = 0x0600;
immutable ushort _WIN32_WINNT_LONGHORN = 0x0600;
immutable ushort _WIN32_WINNT_WIN7     = 0x0601;

immutable ushort _WIN32_IE_IE20    = 0x0200;
immutable ushort _WIN32_IE_IE30    = 0x0300;
immutable ushort _WIN32_IE_IE302   = 0x0302;
immutable ushort _WIN32_IE_IE40    = 0x0400;
immutable ushort _WIN32_IE_IE401   = 0x0401;
immutable ushort _WIN32_IE_IE50    = 0x0500;
immutable ushort _WIN32_IE_IE501   = 0x0501;
immutable ushort _WIN32_IE_IE55    = 0x0550;
immutable ushort _WIN32_IE_IE60    = 0x0600;
immutable ushort _WIN32_IE_IE60SP1 = 0x0601;
immutable ushort _WIN32_IE_IE60SP2 = 0x0603;
immutable ushort _WIN32_IE_IE70    = 0x0700;
immutable ushort _WIN32_IE_IE80    = 0x0800;

immutable ushort _WIN32_IE_NT4      = _WIN32_IE_IE20;
immutable ushort _WIN32_IE_NT4SP1   = _WIN32_IE_IE20;
immutable ushort _WIN32_IE_NT4SP2   = _WIN32_IE_IE20;
immutable ushort _WIN32_IE_NT4SP3   = _WIN32_IE_IE302;
immutable ushort _WIN32_IE_NT4SP4   = _WIN32_IE_IE401;
immutable ushort _WIN32_IE_NT4SP5   = _WIN32_IE_IE401;
immutable ushort _WIN32_IE_NT4SP6   = _WIN32_IE_IE50;
immutable ushort _WIN32_IE_WIN98    = _WIN32_IE_IE401;
immutable ushort _WIN32_IE_WIN98SE  = _WIN32_IE_IE50;
immutable ushort _WIN32_IE_WINME    = _WIN32_IE_IE55;
immutable ushort _WIN32_IE_WIN2K    = _WIN32_IE_IE501;
immutable ushort _WIN32_IE_WIN2KSP1 = _WIN32_IE_IE501;
immutable ushort _WIN32_IE_WIN2KSP2 = _WIN32_IE_IE501;
immutable ushort _WIN32_IE_WIN2KSP3 = _WIN32_IE_IE501;
immutable ushort _WIN32_IE_WIN2KSP4 = _WIN32_IE_IE501;
immutable ushort _WIN32_IE_XP       = _WIN32_IE_IE60;
immutable ushort _WIN32_IE_XPSP1    = _WIN32_IE_IE60SP1;
immutable ushort _WIN32_IE_XPSP2    = _WIN32_IE_IE60SP2;
immutable ushort _WIN32_IE_WS03     = 0x0602;
immutable ushort _WIN32_IE_WS03SP1  = _WIN32_IE_IE60SP2;
immutable ushort _WIN32_IE_WIN6     = _WIN32_IE_IE70;
immutable ushort _WIN32_IE_LONGHORN = _WIN32_IE_IE70;
immutable ushort _WIN32_IE_WIN7     = _WIN32_IE_IE80;

immutable uint NTDDI_WIN2K    = 0x05000000;
immutable uint NTDDI_WIN2KSP1 = 0x05000100;
immutable uint NTDDI_WIN2KSP2 = 0x05000200;
immutable uint NTDDI_WIN2KSP3 = 0x05000300;
immutable uint NTDDI_WIN2KSP4 = 0x05000400;
immutable uint NTDDI_WINXP    = 0x05010000;
immutable uint NTDDI_WINXPSP1 = 0x05010100;
immutable uint NTDDI_WINXPSP2 = 0x05010200;
immutable uint NTDDI_WINXPSP3 = 0x05010300;
immutable uint NTDDI_WINXPSP4 = 0x05010400;
immutable uint NTDDI_WS03     = 0x05020000;
immutable uint NTDDI_WS03SP1  = 0x05020100;
immutable uint NTDDI_WS03SP2  = 0x05020200;
immutable uint NTDDI_WS03SP3  = 0x05020300;
immutable uint NTDDI_WS03SP4  = 0x05020400;
immutable uint NTDDI_WIN6     = 0x06000000;
immutable uint NTDDI_WIN6SP1  = 0x06000100;
immutable uint NTDDI_WIN6SP2  = 0x06000200;
immutable uint NTDDI_WIN6SP3  = 0x06000300;
immutable uint NTDDI_WIN6SP4  = 0x06000400;
immutable uint NTDDI_VISTA    = NTDDI_WIN6;
immutable uint NTDDI_VISTASP1 = NTDDI_WIN6SP1;
immutable uint NTDDI_VISTASP2 = NTDDI_WIN6SP2;
immutable uint NTDDI_VISTASP3 = NTDDI_WIN6SP3;
immutable uint NTDDI_VISTASP4 = NTDDI_WIN6SP4;
immutable uint NTDDI_LONGHORN = NTDDI_VISTA;
immutable uint NTDDI_WS08     = NTDDI_WIN6SP1;
immutable uint NTDDI_WS08SP2  = NTDDI_WIN6SP2;
immutable uint NTDDI_WS08SP3  = NTDDI_WIN6SP3;
immutable uint NTDDI_WS08SP4  = NTDDI_WIN6SP4;
immutable uint NTDDI_WIN7     = 0x06010000;

immutable uint OSVERSION_MASK  = 0xFFFF0000;
immutable uint SPVERSION_MASK  = 0x0000FF00;
immutable uint SUBVERSION_MASK = 0x000000FF;

template OSVER(uint ver)
{
	immutable uint OSVER = ver & OSVERSION_MASK;
}

template SPVER(uint ver)
{
	immutable uint SPVER = (ver & SPVERSION_MASK) >> 8;
}

template SUBVER(uint ver)
{
	immutable uint SUBVER = (ver & SUBVERSION_MASK) >> 8;
}

template NTDDI_VERSION_FROM_WIN32_WINNT2(ushort ver)
{
	immutable uint NTDDI_VERSION_FROM_WIN32_WINNT2 = (cast(uint)ver) << 16;
}

template NTDDI_VERSION_FROM_WIN32_WINNT(ushort ver)
{
	immutable uint NTDDI_VERSION_FROM_WIN32_WINNT = NTDDI_VERSION_FROM_WIN32_WINNT2!(ver);
}

immutable int PSAPI_VERSION = 1;

version (Windows7)
{
	immutable ushort _WIN32_WINNT = _WIN32_WINNT_WIN7;
	immutable uint _WIN32_WINDOWS = uint.max;
}
else version (WindowsVista)
{
	immutable ushort _WIN32_WINNT = _WIN32_WINNT_VISTA;
	immutable uint _WIN32_WINDOWS = uint.max;
}
else version (Windows2003)
{
	immutable ushort _WIN32_WINNT = _WIN32_WINNT_WS03;
	immutable uint _WIN32_WINDOWS = uint.max;
}
else version (WindowsXP)
{
	immutable ushort _WIN32_WINNT = _WIN32_WINNT_WINXP;
	immutable uint _WIN32_WINDOWS = uint.max;
}
else
{
	version (Windows2000)
	{
		immutable ushort _WIN32_WINNT = _WIN32_WINNT_WIN2K;
	}
	else
	{
		immutable ushort _WIN32_WINNT = _WIN32_WINNT_NT4;
	}

	version (WindowsNTonly)
	{
		immutable uint _WIN32_WINDOWS = uint.max;
	}
	else version (WindowsME)
	{
		immutable uint _WIN32_WINDOWS = 0x500;
	}
	else version (Windows98)
	{
		immutable uint _WIN32_WINDOWS = 0x410;
	}
	else
	{
		immutable uint _WIN32_WINDOWS = 0x400;
	}
}

static if (_WIN32_WINDOWS < _WIN32_WINNT)
{
	immutable uint WINVER = _WIN32_WINDOWS;
}
else
{
	immutable uint WINVER = _WIN32_WINNT;
}

immutable bool _WIN32_WINNT_ONLY = _WIN32_WINDOWS == uint.max;

immutable uint NTDDI_VERSION = NTDDI_VERSION_FROM_WIN32_WINNT!(_WIN32_WINNT);

static if (_WIN32_WINNT <= _WIN32_WINNT_NT4)
{
	immutable ushort _WIN32_IE = _WIN32_IE_IE50;
}
else static if (_WIN32_WINNT <= _WIN32_WINNT_WIN2K)
{
	immutable ushort _WIN32_IE = _WIN32_IE_IE501;
}
else static if (_WIN32_WINNT <= _WIN32_WINNT_WINXP)
{
	immutable ushort _WIN32_IE = _WIN32_IE_IE60;
}
else static if (_WIN32_WINNT <= _WIN32_WINNT_WS03)
{
	immutable ushort _WIN32_IE = 0x0602;
}
else
{
	immutable ushort _WIN32_IE = _WIN32_IE_IE80;
}

immutable bool _WIN32_DCOM = true;

debug (WindowsUnitTest)
{
	unittest
	{
		printf("Windows NT version: %03x\n", _WIN32_WINNT);
		printf("Windows NT DDI version: %08x\n", NTDDI_VERSION);
		printf("IE version:         %03x\n", _WIN32_IE);
	}
}
