module jp.ku6.windows.win32api.shobjidl;

import jp.ku6.windows.win32api.w32api;
import jp.ku6.windows.win32api.basetyps;
import jp.ku6.windows.win32api.objbase;
import jp.ku6.windows.win32api.windef;
import jp.ku6.windows.win32api.objidl;
import jp.ku6.windows.win32api.oaidl;
import jp.ku6.windows.win32api.unknwn;
import jp.ku6.windows.win32api.uuid;
import jp.ku6.windows.win32api.wtypes;
import jp.ku6.windows.win32api.winbase;
import jp.ku6.windows.win32api.winuser;
import jp.ku6.windows.win32api.shtypes;
import jp.ku6.windows.win32api.shlobj;
import jp.ku6.windows.win32api.shellapi;
import jp.ku6.windows.win32api.prsht;
import jp.ku6.windows.win32api.rpcdcep;
import jp.ku6.windows.win32api.oleidl;
import jp.ku6.windows.win32api.propidl;
import jp.ku6.windows.win32api.structuredquerycondition;
import jp.ku6.windows.win32api.commctrl;
import jp.ku6.windows.win32api.ocidl;
import jp.ku6.windows.win32api.comcat;
import jp.ku6.windows.win32api.propsys;
import jp.ku6.windows.win32api.objectarray;

extern (Windows):

immutable uint CMF_NORMAL            = 0x00000000;
immutable uint CMF_DEFAULTONLY       = 0x00000001;
immutable uint CMF_VERBSONLY         = 0x00000002;
immutable uint CMF_EXPLORE           = 0x00000004;
immutable uint CMF_NOVERBS           = 0x00000008;
immutable uint CMF_CANRENAME         = 0x00000010;
immutable uint CMF_NODEFAULT         = 0x00000020;
immutable uint CMF_EXTENDEDVERBS     = 0x00000100;
immutable uint CMF_ASYNCVERBSTATE    = 0x00000400;
immutable uint CMF_OPTIMIZEFORINVOKE = 0x00000800;
immutable uint CMF_SYNCCASCADEMENU   = 0x00001000;
immutable uint CMF_DONOTPICKDEFAULT  = 0x00002000;
immutable uint CMF_RESERVED          = 0xffff0000;
static if (NTDDI_VERSION < NTDDI_VISTA)
{
	immutable uint CMF_INCLUDESTATIC = 0x00000040;
}
else
{
	immutable uint CMF_ITEMMENU      = 0x00000080;
	immutable uint CMF_DISABLEDVERBS = 0x00000200;
}


immutable uint GCS_VERBA     = 0x00000000;
immutable uint GCS_HELPTEXTA = 0x00000001;
immutable uint GCS_VALIDATEA = 0x00000002;
immutable uint GCS_VERBW     = 0x00000004;
immutable uint GCS_HELPTEXTW = 0x00000005;
immutable uint GCS_VALIDATEW = 0x00000006;
immutable uint GCS_VERBICONW = 0x00000014;
immutable uint GCS_UNICODE   = 0x00000004;
version (Unicode)
{
	alias GCS_VERBW     GCS_VERB;
	alias GCS_HELPTEXTW GCS_HELPTEXT;
	alias GCS_VALIDATEW GCS_VALIDATE;
}
else
{
	alias GCS_VERBA     GCS_VERB;
	alias GCS_HELPTEXTA GCS_HELPTEXT;
	alias GCS_VALIDATEA GCS_VALIDATE;
}


immutable string CMDSTR_NEWFOLDERA    = "NewFolder";
immutable string CMDSTR_VIEWLISTA     = "ViewList";
immutable string CMDSTR_VIEWDETAILSA  = "ViewDetails";
immutable wstring CMDSTR_NEWFOLDERW   = "NewFolder"w;
immutable wstring CMDSTR_VIEWLISTW    = "ViewList"w;
immutable wstring CMDSTR_VIEWDETAILSW = "ViewDetails"w;
version (Unicode)
{
	alias CMDSTR_NEWFOLDERW   CMDSTR_NEWFOLDER;
	alias CMDSTR_VIEWLISTW    CMDSTR_VIEWLIST;
	alias CMDSTR_VIEWDETAILSW CMDSTR_VIEWDETAILS;
}
else
{
	alias CMDSTR_NEWFOLDERA   CMDSTR_NEWFOLDER;
	alias CMDSTR_VIEWLISTA    CMDSTR_VIEWLIST;
	alias CMDSTR_VIEWDETAILSA CMDSTR_VIEWDETAILS;
}

immutable uint CMIC_MASK_HOTKEY       = SEE_MASK_HOTKEY;
immutable uint CMIC_MASK_FLAG_NO_UI   = SEE_MASK_FLAG_NO_UI;
immutable uint CMIC_MASK_UNICODE      = SEE_MASK_UNICODE;
immutable uint CMIC_MASK_NO_CONSOLE   = SEE_MASK_NO_CONSOLE;
//immutable uint CMIC_MASK_FLAG_SEP_VDM = SEE_MASK_FLAG_SEPVDM;
immutable uint CMIC_MASK_ASYNCOK      = SEE_MASK_ASYNCOK ;
static if (NTDDI_VERSION < NTDDI_VISTA)
{
	immutable uint CMIC_MASK_ICON         = SEE_MASK_ICON;
	immutable uint CMIC_MASK_HASLINKNAME = SEE_MASK_HASLINKNAME;
	immutable uint CMIC_MASK_HASTITLE    = SEE_MASK_HASTITLE;
}
else
{
	immutable uint CMIC_MASK_NOASYNC = SEE_MASK_NOASYNC;
}
static if (_WIN32_IE >= _WIN32_IE_IE501)
{
	immutable uint CMIC_MASK_SHIFT_DOWN   = 0x10000000;
	immutable uint CMIC_MASK_CONTROL_DOWN = 0x40000000;
}
static if (_WIN32_IE >= 0x0560)
{
	immutable uint CMIC_MASK_FLAG_LOG_USAGE = SEE_MASK_FLAG_LOG_USAGE;
	immutable uint CMIC_MASK_NOZONECHECKS   = SEE_MASK_NOZONECHECKS;
}
static if (_WIN32_IE >= _WIN32_IE_IE40)
{
	immutable uint CMIC_MASK_PTINVOKE = 0x20000000;
}


align (8)
struct CMINVOKECOMMANDINFO
{
    DWORD cbSize;
    DWORD fMask;
    HWND hwnd;
    LPCSTR lpVerb;
    LPCSTR lpParameters;
    LPCSTR lpDirectory;
    int nShow;
    DWORD dwHotKey;
    HANDLE hIcon;
}
alias CMINVOKECOMMANDINFO* LPCMINVOKECOMMANDINFO;
alias const(CMINVOKECOMMANDINFO)* PCCMINVOKECOMMANDINFO;

static if (_WIN32_IE >= _WIN32_IE_IE40)
{
	align (8)
	struct CMINVOKECOMMANDINFOEX
	{
		DWORD cbSize;
		DWORD fMask;
		HWND hwnd;
		LPCSTR lpVerb;
		LPCSTR lpParameters;
		LPCSTR lpDirectory;
		int nShow;
		DWORD dwHotKey;
		HANDLE hIcon;
		LPCSTR lpTitle;
		LPCWSTR lpVerbW;
		LPCWSTR lpParametersW;
		LPCWSTR lpDirectoryW;
		LPCWSTR lpTitleW;
		POINT ptInvoke;
	}
}
else
{
	align (8)
	struct CMINVOKECOMMANDINFOEX
	{
		DWORD cbSize;
		DWORD fMask;
		HWND hwnd;
		LPCSTR lpVerb;
		LPCSTR lpParameters;
		LPCSTR lpDirectory;
		int nShow;
		DWORD dwHotKey;
		HANDLE hIcon;
		LPCSTR lpTitle;
		LPCWSTR lpVerbW;
		LPCWSTR lpParametersW;
		LPCWSTR lpDirectoryW;
		LPCWSTR lpTitleW;
	};
}
alias CMINVOKECOMMANDINFOEX* LPCMINVOKECOMMANDINFOEX;
alias const(CMINVOKECOMMANDINFOEX)* PCCMINVOKECOMMANDINFOEX;

immutable IID IID_IContextMenu = {0x000214e4, 0x0000, 0x0000, [0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IContextMenu : IUnknown
{
	HRESULT QueryContextMenu(HMENU hmenu, UINT indexMenu, UINT idCmdFirst, UINT idCmdLast, UINT uFlags);
	HRESULT InvokeCommand(CMINVOKECOMMANDINFO* pici);
	HRESULT GetCommandString(UINT_PTR idCmd, UINT uType, UINT* pReserved, LPSTR pszName, UINT cchMax);
}
alias IContextMenu   LPCONTEXTMENU;

immutable IID IID_IContextMenu2 = {0x000214f4, 0x0000, 0x0000, [0xc0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IContextMenu2 : IContextMenu
{
	HRESULT HandleMenuMsg(UINT uMsg, WPARAM wParam, LPARAM lParam);
}
alias IContextMenu2  LPCONTEXTMENU2;

immutable IID IID_IContextMenu3 = {0xBCFCE0A0, 0xEC17, 0x11d0, [0x8D, 0x10, 0x00, 0xA0, 0xC9, 0x0F, 0x27, 0x19]};
interface IContextMenu3 : IContextMenu2
{
	HRESULT HandleMenuMsg2(UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* plResult);
}

immutable IID IID_IExecuteCommand = {0x7F9185B0, 0xCB92, 0x43c5, [0x80, 0xA9, 0x92, 0x27, 0x7A, 0x4F, 0x7B, 0x54]};
interface IExecuteCommand : IUnknown
{
	HRESULT SetKeyState(DWORD grfKeyState);
	HRESULT SetParameters(LPCWSTR pszParameters);
	HRESULT SetPosition(POINT pt);
	HRESULT SetShowWindow(int nShow);
	HRESULT SetNoShowUI(BOOL fNoShowUI);
	HRESULT SetDirectory(LPCWSTR pszDirectory);
	HRESULT Execute();
}
alias IContextMenu3  LPCONTEXTMENU3;

immutable IID IID_IPersistFolder  = {0x000214EA, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IPersistFolder : IPersist
{
	HRESULT Initialize(PCIDLIST_ABSOLUTE pidl);
}
alias IPersistFolder LPPERSISTFOLDER;

static if (_WIN32_IE >= 0x0400)
{
	immutable ULONG IRTIR_TASK_NOT_RUNNING = 0;
	immutable ULONG IRTIR_TASK_RUNNING     = 1;
	immutable ULONG IRTIR_TASK_SUSPENDED   = 2;
	immutable ULONG IRTIR_TASK_PENDING     = 3;
	immutable ULONG IRTIR_TASK_FINISHED    = 4;

	alias GUID_NULL TOID_NULL;

	immutable DWORD_PTR ITSAT_DEFAULT_LPARAM = cast(DWORD_PTR)-1;
	immutable DWORD ITSAT_DEFAULT_PRIORITY = 0x10000000;
	immutable DWORD ITSAT_MAX_PRIORITY = 0x7fffffff;
	immutable DWORD ITSAT_MIN_PRIORITY = 0x00000000;
	immutable DWORD ITSSFLAG_COMPLETE_ON_DESTROY = 0x0000;
	immutable DWORD ITSSFLAG_KILL_ON_DESTROY = 0x0001;
	immutable DWORD ITSSFLAG_FLAGS_MASK = 0x0003;
	immutable DWORD ITSS_THREAD_DESTROY_DEFAULT_TIMEOUT = 10*1000;
	immutable DWORD ITSS_THREAD_TERMINATE_TIMEOUT = INFINITE;
	immutable DWORD ITSS_THREAD_TIMEOUT_NO_CHANGE = INFINITE - 1;

	immutable IID IID_IRunnableTask = {0x85788d00, 0x6807, 0x11d0, [0xb8, 0x10, 0x00, 0xc0, 0x4f, 0xd7, 0x06, 0xec]};
	interface IRunnableTask : IUnknown
	{
		HRESULT Run();
		HRESULT Kill(BOOL bWait);
		HRESULT Suspend();
		HRESULT Resume();
		ULONG IsRunning();
	}

	immutable IID IID_IShellTaskScheduler = {0x6CCB7BE0, 0x6807, 0x11d0, [0xB8, 0x10, 0x00, 0xC0, 0x4F, 0xD7, 0x06, 0xEC]};
	alias IID_IShellTaskScheduler SID_ShellTaskScheduler;
	interface IShellTaskScheduler : IUnknown
	{
		HRESULT AddTask(IRunnableTask prt, REFTASKOWNERID rtoid, DWORD_PTR lParam, DWORD dwPriority);
		HRESULT RemoveTasks(REFTASKOWNERID rtoid, DWORD_PTR lParam, BOOL bWaitIfRunning);
		UINT CountTasks(REFTASKOWNERID rtoid);
		HRESULT Status(DWORD dwReleaseStatus, DWORD dwThreadTimeout);
	}

	immutable IID IID_IQueryCodePage = {0xC7B236CE, 0xEE80, 0x11D0, [0x98, 0x5F, 0x00, 0x60, 0x08, 0x05, 0x93, 0x82]};
	interface IQueryCodePage : IUnknown
	{
		HRESULT GetCodePage(UINT* puiCodePage);
		HRESULT SetCodePage(UINT uiCodePage);
	}

	immutable IID IID_IPersistFolder2 = {0x1AC3D9F0, 0x175C, 0x11d1, [0x95, 0xBE, 0x00, 0x60, 0x97, 0x97, 0xEA, 0x4F]};
	interface IPersistFolder2 : IPersistFolder
	{
		HRESULT GetCurFolder(PIDLIST_ABSOLUTE* ppidl);
	}
}
static if (_WIN32_IE >= 0x0500)
{
	alias CSIDL_FLAG_DONT_VERIFY CSIDL_FLAG_PFTI_TRACKTARGET;

	align (8)
	struct PERSIST_FOLDER_TARGET_INFO
	{
		PIDLIST_ABSOLUTE pidlTargetFolder;
		WCHAR[260] szTargetParsingName;
		WCHAR[260] szNetworkProvider;
		DWORD dwAttributes;
		int csidl;
	}

	immutable IID IID_IPersistFolder3 = {0xCEF04FDF, 0xFE72, 0x11d2, [0x87, 0xA5, 0x00, 0xC0, 0x4F, 0x68, 0x37, 0xCF]};
	interface IPersistFolder3 : IPersistFolder2
	{
		HRESULT InitializeEx(IBindCtx pbc, PCIDLIST_ABSOLUTE pidlRoot, const(PERSIST_FOLDER_TARGET_INFO)* ppfti);
		HRESULT GetFolderTargetInfo(PERSIST_FOLDER_TARGET_INFO* ppfti);
	}
}
static if (NTDDI_VERSION >= NTDDI_WINXP || _WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IPersistIDList = {0x1079acfc, 0x29bd, 0x11d3, [0x8e, 0x0d, 0x00, 0xc0, 0x4f, 0x68, 0x37, 0xd5]};
	interface IPersistIDList : IPersist
	{
		HRESULT SetIDList(PCIDLIST_ABSOLUTE pidl);
		HRESULT GetIDList(PIDLIST_ABSOLUTE* ppidl);
	}
}

immutable IID IID_IEnumIDList = {0x000214F2, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IEnumIDList : IUnknown
{
	HRESULT Next(ULONG celt, PITEMID_CHILD* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumIDList* ppenum);
}
alias IEnumIDList LPENUMIDLIST;

HRESULT IEnumIDList_RemoteNext_Proxy(IEnumIDList This, ULONG celt, PITEMID_CHILD* rgelt, ULONG* pceltFetched);
void IEnumIDList_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IEnumFullIDList = {0xd0191542, 0x7954, 0x4908, [0xbc, 0x06, 0xb2, 0x36, 0x0b, 0xbe, 0x45, 0xba]};
interface IEnumFullIDList : IUnknown
{
	HRESULT Next(ULONG celt, PIDLIST_ABSOLUTE* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumFullIDList* ppenum);
}

HRESULT IEnumFullIDList_RemoteNext_Proxy(IEnumFullIDList This, ULONG celt, PIDLIST_ABSOLUTE* rgelt, ULONG* pceltFetched);
void IEnumFullIDList_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

alias DWORD SHGDNF;
immutable SHGDNF SHGDN_NORMAL       = 0;
immutable SHGDNF SHGDN_INFOLDER      = 0x1;
immutable SHGDNF SHGDN_FOREDITING    = 0x1000;
immutable SHGDNF SHGDN_FORADDRESSBAR = 0x4000;
immutable SHGDNF SHGDN_FORPARSING    = 0x8000;

alias DWORD SHCONTF;
immutable SHCONTF SHCONTF_CHECKING_FOR_CHILDREN = 0x10;
immutable SHCONTF SHCONTF_FOLDERS               = 0x20;
immutable SHCONTF SHCONTF_NONFOLDERS            = 0x40;
immutable SHCONTF SHCONTF_INCLUDEHIDDEN         = 0x80;
immutable SHCONTF SHCONTF_INIT_ON_FIRST_NEXT    = 0x100;
immutable SHCONTF SHCONTF_NETPRINTERSRCH        = 0x200;
immutable SHCONTF SHCONTF_SHAREABLE             = 0x400;
immutable SHCONTF SHCONTF_STORAGE               = 0x800;
immutable SHCONTF SHCONTF_NAVIGATION_ENUM       = 0x1000;
immutable SHCONTF SHCONTF_FASTITEMS             = 0x2000;
immutable SHCONTF SHCONTF_FLATLIST              = 0x4000;
immutable SHCONTF SHCONTF_ENABLE_ASYNC          = 0x8000;
immutable SHCONTF SHCONTF_INCLUDESUPERHIDDEN    = 0x10000;

alias ULONG SFGAOF;
immutable ULONG SHCIDS_ALLFIELDS      = 0x80000000;
immutable ULONG SHCIDS_CANONICALONLY  = 0x10000000;
immutable ULONG SHCIDS_BITMASK        = 0xFFFF0000;
immutable ULONG SHCIDS_COLUMNMASK     = 0x0000FFFF;
immutable ULONG SFGAO_CANCOPY         = DROPEFFECT.DROPEFFECT_COPY;
immutable ULONG SFGAO_CANMOVE         = DROPEFFECT.DROPEFFECT_MOVE;
immutable ULONG SFGAO_CANLINK         = DROPEFFECT.DROPEFFECT_LINK;
immutable ULONG SFGAO_STORAGE         = 0x00000008;
immutable ULONG SFGAO_CANRENAME       = 0x00000010;
immutable ULONG SFGAO_CANDELETE       = 0x00000020;
immutable ULONG SFGAO_HASPROPSHEET    = 0x00000040;
immutable ULONG SFGAO_DROPTARGET      = 0x00000100;
immutable ULONG SFGAO_CAPABILITYMASK  = 0x00000177;
immutable ULONG SFGAO_SYSTEM          = 0x00001000;
immutable ULONG SFGAO_ENCRYPTED       = 0x00002000;
immutable ULONG SFGAO_ISSLOW          = 0x00004000;
immutable ULONG SFGAO_GHOSTED         = 0x00008000;
immutable ULONG SFGAO_LINK            = 0x00010000;
immutable ULONG SFGAO_SHARE           = 0x00020000;
immutable ULONG SFGAO_READONLY        = 0x00040000;
immutable ULONG SFGAO_HIDDEN          = 0x00080000;
immutable ULONG SFGAO_DISPLAYATTRMASK = 0x000FC000;
immutable ULONG SFGAO_FILESYSANCESTOR = 0x10000000;
immutable ULONG SFGAO_FOLDER          = 0x20000000;
immutable ULONG SFGAO_FILESYSTEM      = 0x40000000;
immutable ULONG SFGAO_HASSUBFOLDER    = 0x80000000;
immutable ULONG SFGAO_CONTENTSMASK    = 0x80000000;
immutable ULONG SFGAO_VALIDATE        = 0x01000000;
immutable ULONG SFGAO_REMOVABLE       = 0x02000000;
immutable ULONG SFGAO_COMPRESSED      = 0x04000000;
immutable ULONG SFGAO_BROWSABLE       = 0x08000000;
immutable ULONG SFGAO_NONENUMERATED   = 0x00100000;
immutable ULONG SFGAO_NEWCONTENT      = 0x00200000;
immutable ULONG SFGAO_CANMONIKER      = 0x00400000;
immutable ULONG SFGAO_HASSTORAGE      = 0x00400000;
immutable ULONG SFGAO_STREAM          = 0x00400000;
immutable ULONG SFGAO_STORAGEANCESTOR = 0x00800000;
immutable ULONG SFGAO_STORAGECAPMASK  = 0x70C50008;
immutable ULONG SFGAO_PKEYSFGAOMASK   = 0x81044000;

immutable wchar* STR_BIND_FORCE_FOLDER_SHORTCUT_RESOLVE   = "Force Folder Shortcut Resolve\0"w.ptr;
immutable wchar* STR_AVOID_DRIVE_RESTRICTION_POLICY       = "Avoid Drive Restriction Policy\0"w.ptr;
immutable wchar* STR_SKIP_BINDING_CLSID                   = "Skip Binding CLSID\0"w.ptr;
immutable wchar* STR_PARSE_PREFER_FOLDER_BROWSING         = "Parse Prefer Folder Browsing\0"w.ptr;
immutable wchar* STR_DONT_PARSE_RELATIVE                  = "Don't Parse Relative\0"w.ptr;
immutable wchar* STR_PARSE_TRANSLATE_ALIASES              = "Parse Translate Aliases\0"w.ptr;
immutable wchar* STR_PARSE_SKIP_NET_CACHE                 = "Skip Net Resource Cache\0"w.ptr;
immutable wchar* STR_PARSE_SHELL_PROTOCOL_TO_FILE_OBJECTS = "Parse Shell Protocol To File Objects\0"w.ptr;
static if (_WIN32_IE >= 0x0700)
{
	immutable wchar* STR_TRACK_CLSID                               = "Track the CLSID\0"w.ptr;
	immutable wchar* STR_INTERNAL_NAVIGATE                         = "Internal Navigation\0"w.ptr;
	immutable wchar* STR_PARSE_PROPERTYSTORE                       = "DelegateNamedProperties\0"w.ptr;
	immutable wchar* STR_NO_VALIDATE_FILENAME_CHARS                = "NoValidateFilenameChars\0"w.ptr;
	immutable wchar* STR_BIND_DELEGATE_CREATE_OBJECT               = "Delegate Object Creation\0"w.ptr;
	immutable wchar* STR_PARSE_ALLOW_INTERNET_SHELL_FOLDERS        = "Allow binding to Internet shell folder handlers and negate STR_PARSE_PREFER_WEB_BROWSING\0"w.ptr;
	immutable wchar* STR_PARSE_PREFER_WEB_BROWSING                 = "Do not bind to Internet shell folder handlers\0"w.ptr;
	immutable wchar* STR_PARSE_SHOW_NET_DIAGNOSTICS_UI             = "Show network diagnostics UI\0"w.ptr;
	immutable wchar* STR_PARSE_DONT_REQUIRE_VALIDATED_URLS         = "Do not require validated URLs\0"w.ptr;
	immutable wchar* STR_INTERNETFOLDER_PARSE_ONLY_URLMON_BINDABLE = "Validate URL"w.ptr;
}
static if (NTDDI_VERSION >= NTDDI_WIN7)
{
	immutable wchar* STR_BIND_FOLDERS_READ_ONLY = "Folders As Read Only\0"w.ptr;
	immutable wchar* STR_BIND_FOLDER_ENUM_MODE  = "Folder Enum Mode\0"w.ptr;

	immutable wchar* STR_PARSE_WITH_EXPLICIT_PROGID            = "ExplicitProgid\0"w.ptr;
	immutable wchar* STR_PARSE_WITH_EXPLICIT_ASSOCAPP          = "ExplicitAssociationApp\0"w.ptr;
	immutable wchar* STR_PARSE_EXPLICIT_ASSOCIATION_SUCCESSFUL = "ExplicitAssociationSuccessful\0"w.ptr;
	immutable wchar* STR_PARSE_AND_CREATE_ITEM                 = "ParseAndCreateItem\0"w.ptr;

	immutable wchar* STR_ITEM_CACHE_CONTEXT = "ItemCacheContext\0"w.ptr;

	enum FOLDER_ENUM_MODE
	{
		FEM_VIEWRESULT = 0,
		FEM_NAVIGATION = 1,
	}

	extern (Windows)
	{
		immutable IID IID_IObjectWithFolderEnumMode = {0x6a9d9026, 0x0e6e, 0x464c, [0xb0, 0x00, 0x42, 0xec, 0xc0, 0x7d, 0xe6, 0x73]};
		interface IObjectWithFolderEnumMode : IUnknown
		{
			HRESULT SetMode(FOLDER_ENUM_MODE feMode);
			HRESULT GetMode(FOLDER_ENUM_MODE* pfeMode);
		}

		immutable IID IID_IParseAndCreateItem = {0x67efed0e, 0xe827, 0x4408, [0xb4, 0x93, 0x78, 0xf3, 0x98, 0x2b, 0x68, 0x5c]};
		interface IParseAndCreateItem : IUnknown
		{
			HRESULT SetItem(IShellItem psi);
 			HRESULT GetItem(REFIID riid, void** ppv);
		}
	}
}

struct EXTRASEARCH
{
	GUID guidSearch;
	WCHAR[80] wszFriendlyName;
	WCHAR[2084] wszUrl;
}
alias EXTRASEARCH* LPEXTRASEARCH;

alias char* LPVIEWSETTINGS;

enum FOLDERFLAGS : DWORD
{
	FWF_NONE                = 0,
	FWF_AUTOARRANGE         = 0x1,
	FWF_ABBREVIATEDNAMES    = 0x2,
	FWF_SNAPTOGRID          = 0x4,
	FWF_OWNERDATA           = 0x8,
	FWF_BESTFITWINDOW       = 0x10,
	FWF_DESKTOP             = 0x20,
	FWF_SINGLESEL           = 0x40,
	FWF_NOSUBFOLDERS        = 0x80,
	FWF_TRANSPARENT         = 0x100,
	FWF_NOCLIENTEDGE        = 0x200,
	FWF_NOSCROLL            = 0x400,
	FWF_ALIGNLEFT           = 0x800,
	FWF_NOICONS             = 0x1000,
	FWF_SHOWSELALWAYS       = 0x2000,
	FWF_NOVISIBLE           = 0x4000,
	FWF_SINGLECLICKACTIVATE = 0x8000,
	FWF_NOWEBVIEW           = 0x10000,
	FWF_HIDEFILENAMES       = 0x20000,
	FWF_CHECKSELECT         = 0x40000,
	FWF_NOENUMREFRESH       = 0x80000,
	FWF_NOGROUPING          = 0x100000,
	FWF_FULLROWSELECT       = 0x200000,
	FWF_NOFILTERS           = 0x400000,
	FWF_NOCOLUMNHEADER      = 0x800000,
	FWF_NOHEADERINALLVIEWS  = 0x1000000,
	FWF_EXTENDEDTILES       = 0x2000000,
	FWF_TRICHECKSELECT      = 0x4000000,
	FWF_AUTOCHECKSELECT     = 0x8000000,
	FWF_NOBROWSERVIEWSTATE  = 0x10000000,
	FWF_SUBSETGROUPS        = 0x20000000,
	FWF_USESEARCHFOLDER     = 0x40000000,
	FWF_ALLOWRTLREADING     = 0x80000000
}

enum FOLDERVIEWMODE
{
	FVM_AUTO       = -1,
	FVM_FIRST      = 1,
	FVM_ICON       = 1,
	FVM_SMALLICON  = 2,
	FVM_LIST       = 3,
	FVM_DETAILS    = 4,
	FVM_THUMBNAIL  = 5,
	FVM_TILE       = 6,
	FVM_THUMBSTRIP = 7,
	FVM_CONTENT    = 8,
	FVM_LAST       = 8
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	enum FOLDERLOGICALVIEWMODE
	{
		FLVM_UNSPECIFIED = -1,
		FLVM_FIRST       = 1,
		FLVM_DETAILS     = 1,
		FLVM_TILES       = 2,
		FLVM_ICONS       = 3,
		FLVM_LIST        = 4,
		FLVM_CONTENT     = 5,
		FLVM_LAST        = 5
	}
}

immutable IID IID_IShellFolder = {0x000214E6, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellFolder : IUnknown
{
	HRESULT ParseDisplayName(HWND hwnd, IBindCtx pbc, LPWSTR pszDisplayName, ULONG* pchEaten, PIDLIST_RELATIVE* ppidl, ULONG* pdwAttributes);
	HRESULT EnumObjects(HWND hwnd, SHCONTF grfFlags, IEnumIDList* ppenumIDList);
	HRESULT BindToObject(PCUIDLIST_RELATIVE pidl, IBindCtx pbc, REFIID riid, void** ppv);
	HRESULT BindToStorage(PCUIDLIST_RELATIVE pidl, IBindCtx pbc, REFIID riid, void** ppv);
	HRESULT CompareIDs(LPARAM lParam, PCUIDLIST_RELATIVE pidl1, PCUIDLIST_RELATIVE pidl2);
	HRESULT CreateViewObject(HWND hwndOwner, REFIID riid, void** ppv);
	HRESULT GetAttributesOf(UINT cidl, PCUITEMID_CHILD_ARRAY apidl, SFGAOF* rgfInOut);
	HRESULT GetUIObjectOf(HWND hwndOwner, UINT cidl, PCUITEMID_CHILD_ARRAY apidl, REFIID riid, UINT* rgfReserved, void** ppv);
	HRESULT GetDisplayNameOf(PCUITEMID_CHILD pidl, SHGDNF uFlags, STRRET* pName);
	HRESULT SetNameOf(HWND hwnd, PCUITEMID_CHILD pidl, LPCWSTR pszName, SHGDNF uFlags, PITEMID_CHILD* ppidlOut);
}
alias IShellFolder LPSHELLFOLDER;

HRESULT IShellFolder_RemoteSetNameOf_Proxy(IShellFolder This, HWND hwnd, PCUITEMID_CHILD pidl, LPCWSTR pszName, SHGDNF uFlags, PITEMID_CHILD* ppidlOut);
void IShellFolder_RemoteSetNameOf_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IEnumExtraSearch = {0x0E700BE1, 0x9DB6, 0x11d1, [0xA1, 0xCE, 0x00, 0xC0, 0x4F, 0xD7, 0x5D, 0x13]};
interface IEnumExtraSearch : IUnknown
{
	HRESULT Next(ULONG celt, EXTRASEARCH* rgelt, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumExtraSearch* ppenum);
}
alias IEnumExtraSearch LPENUMEXTRASEARCH;

immutable IID IID_IShellFolder2 = {0x93F2F68C, 0x1D1B, 0x11d3, [0xA3, 0x0E, 0x00, 0xC0, 0x4F, 0x79, 0xAB, 0xD1]};
interface IShellFolder2 : IShellFolder
{
	HRESULT GetDefaultSearchGUID(GUID* pguid);
	HRESULT EnumSearches(IEnumExtraSearch* ppenum);
	HRESULT GetDefaultColumn(DWORD dwRes, ULONG* pSort, ULONG* pDisplay);
	HRESULT GetDefaultColumnState(UINT iColumn, SHCOLSTATEF* pcsFlags);
	HRESULT GetDetailsEx(PCUITEMID_CHILD pidl, const(SHCOLUMNID)* pscid, VARIANT* pv);
	HRESULT GetDetailsOf(PCUITEMID_CHILD pidl, UINT iColumn, SHELLDETAILS* psd);
	HRESULT MapColumnToSCID(UINT iColumn, SHCOLUMNID* pscid);
}

struct FOLDERSETTINGS
{
	UINT ViewMode;
	UINT fFlags;
}
alias FOLDERSETTINGS* PFOLDERSETTINGS;
alias FOLDERSETTINGS* LPFOLDERSETTINGS;
alias const(FOLDERSETTINGS)* LPCFOLDERSETTINGS;

enum FOLDERVIEWOPTIONS : DWORD
{
	FVO_DEFAULT           = 0,
	FVO_VISTALAYOUT       = 0x1,
	FVO_CUSTOMPOSITION    = 0x2,
	FVO_CUSTOMORDERING    = 0x4,
	FVO_SUPPORTHYPERLINKS = 0x8,
	FVO_NOANIMATIONS      = 0x10,
	FVO_NOSCROLLTIPS      = 0x20
}

immutable IID IID_IFolderViewOptions = {0x3cc974d2, 0xb302, 0x4d36, [0xad, 0x3e, 0x06, 0xd9, 0x3f, 0x69, 0x5d, 0x3f]};
interface IFolderViewOptions : IUnknown
{
	HRESULT SetFolderViewOptions(DWORD fvoMask, DWORD fvoFlags);
	HRESULT GetFolderViewOptions(DWORD* pfvoFlags);
}

enum SVSIF : DWORD
{
	SVSI_DESELECT       = 0,
	SVSI_SELECT         = 0x1,
	SVSI_EDIT           = 0x3,
	SVSI_DESELECTOTHERS = 0x4,
	SVSI_ENSUREVISIBLE  = 0x8,
	SVSI_FOCUSED        = 0x10,
	SVSI_TRANSLATEPT    = 0x20,
	SVSI_SELECTIONMARK  = 0x40,
	SVSI_POSITIONITEM   = 0x80,
	SVSI_CHECK          = 0x100,
	SVSI_CHECK2         = 0x200,
	SVSI_KEYBOARDSELECT = 0x401,
	SVSI_NOTAKEFOCUS    = 0x40000000,
	SVSI_NOSTATECHANGE  = 0x80000000,
}

enum SVGIO : DWORD
{
	SVGIO_BACKGROUND     = 0,
	SVGIO_SELECTION      = 0x1,
	SVGIO_ALLVIEW        = 0x2,
	SVGIO_CHECKED        = 0x3,
	SVGIO_TYPE_MASK      = 0xf,
	SVGIO_FLAG_VIEWORDER = 0x80000000
}

enum SVUIA_STATUS
{
	SVUIA_DEACTIVATE       = 0,
	SVUIA_ACTIVATE_NOFOCUS = 1,
	SVUIA_ACTIVATE_FOCUS   = 2,
	SVUIA_INPLACEACTIVATE  = 3
}

version (_NEVER_)
{
	alias LPARAM LPFNSVADDPROPSHEETPAGE;
}
else
{
	alias LPFNADDPROPSHEETPAGE LPFNSVADDPROPSHEETPAGE;
}

immutable IID IID_IShellView = {0x000214E3, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellView : IOleWindow
{
	HRESULT TranslateAccelerator(MSG* pmsg);
	version (_FIX_ENABLEMODELESS_CONFLICT)
	{
		HRESULT EnableModelessSV(BOOL fEnable);
	}
	else
	{
		HRESULT EnableModeless(BOOL fEnable);
	}
	HRESULT UIActivate(UINT uState);
	HRESULT Refresh();
	HRESULT CreateViewWindow(IShellView psvPrevious, LPCFOLDERSETTINGS pfs, IShellBrowser psb, RECT* prcView, HWND* phWnd);
	HRESULT DestroyViewWindow();
	HRESULT GetCurrentInfo(LPFOLDERSETTINGS pfs);
	HRESULT AddPropertySheetPages(DWORD dwReserved, LPFNSVADDPROPSHEETPAGE pfn, LPARAM lparam);
	HRESULT SaveViewState();
	HRESULT SelectItem(PCUITEMID_CHILD pidlItem, DWORD uFlags);
	HRESULT GetItemObject(UINT uItem, REFIID riid, void** ppv);

}
alias IShellView LPSHELLVIEW;

alias GUID SHELLVIEWID;

immutable uint SV2GV_CURRENTVIEW = 0xffffffff;
immutable uint SV2GV_DEFAULTVIEW = 0xfffffffe;

align (8)
struct SV2CVW2_PARAMS
{
	DWORD cbSize;
	IShellView psvPrev;
	LPCFOLDERSETTINGS pfs;
	IShellBrowser psbOwner;
	RECT* prcView;
	const(SHELLVIEWID)* pvid;
	HWND hwndView;
}
alias SV2CVW2_PARAMS* LPSV2CVW2_PARAMS;

immutable IID IID_IShellView2 = {0x88E39E80, 0x3578, 0x11CF, [0xAE, 0x69, 0x08, 0x00, 0x2B, 0x2E, 0x12, 0x62]};
interface IShellView2 : IShellView
{
	HRESULT GetView(SHELLVIEWID* pvid, ULONG uView);
	HRESULT CreateViewWindow2(LPSV2CVW2_PARAMS lpParams);
	HRESULT HandleRename(PCUITEMID_CHILD pidlNew);
	HRESULT SelectAndPositionItem(PCUITEMID_CHILD pidlItem, UINT uFlags, POINT* ppt);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	alias DWORD SV3CVW3_FLAGS;
	immutable DWORD SV3CVW3_DEFAULT          = 0;
	immutable DWORD SV3CVW3_NONINTERACTIVE   = 0x1;
	immutable DWORD SV3CVW3_FORCEVIEWMODE    = 0x2;
	immutable DWORD SV3CVW3_FORCEFOLDERFLAGS = 0x4;

	immutable IID IID_IShellView3 = {0xec39fa88, 0xf8af, 0x41c5, [0x84, 0x21, 0x38, 0xbe, 0xd2, 0x8f, 0x46, 0x73]};
	interface IShellView3 : IShellView2
	{
		HRESULT CreateViewWindow3(IShellBrowser psbOwner, IShellView psvPrev, SV3CVW3_FLAGS dwViewFlags, DWORD dwMask, DWORD dwFlags, FOLDERVIEWMODE fvMode, const(SHELLVIEWID)* pvid, const(RECT)* prcView, HWND* phwndView);
	}
}

immutable IID IID_IFolderView = {0xcde725b0, 0xccc9, 0x4519, [0x91, 0x7e, 0x32, 0x5d, 0x72, 0xfa, 0xb4, 0xce]};
alias IID_IFolderView SID_SFolderView;
interface IFolderView : IUnknown
{
	HRESULT GetCurrentViewMode(UINT* pViewMode);
	HRESULT SetCurrentViewMode(UINT ViewMode);
	HRESULT GetFolder(REFIID riid, void** ppv);
	HRESULT Item(int iItemIndex, PITEMID_CHILD* ppidl);
	HRESULT ItemCount(UINT uFlags, int* pcItems);
	HRESULT Items(UINT uFlags, REFIID riid, void** ppv);
	HRESULT GetSelectionMarkedItem(int* piItem);
	HRESULT GetFocusedItem(int* piItem);
	HRESULT GetItemPosition(PCUITEMID_CHILD pidl, POINT* ppt);
	HRESULT GetSpacing(POINT* ppt);
	HRESULT GetDefaultSpacing(POINT* ppt);
	HRESULT GetAutoArrange();
	HRESULT SelectItem(int iItem, DWORD dwFlags);
	HRESULT SelectAndPositionItems(UINT cidl, PCUITEMID_CHILD_ARRAY apidl, POINT* apt, DWORD dwFlags);
}

static if (NTDDI_VERSION >= NTDDI_WIN7)
{
	immutable IID IID_ISearchBoxInfo = {0x6af6e03f, 0xd664, 0x4ef4, [0x96, 0x26, 0xf7, 0xe0, 0xed, 0x36, 0x75, 0x5e]};
	interface ISearchBoxInfo : IUnknown
	{
		HRESULT GetCondition(REFIID riid, void** ppv);
		HRESULT GetText(LPWSTR* ppsz);
	}
}
static if (NTDDI_VERSION >= NTDDI_VISTA || _WIN32_IE >= _WIN32_IE_IE70)
{
	alias int SORTDIRECTION;
	immutable int SORT_DESCENDING = -1;
	immutable int SORT_ASCENDING  = 1;

	struct SORTCOLUMN
	{
		PROPERTYKEY propkey;
		SORTDIRECTION direction;
	}

	enum FVTEXTTYPE
	{
		FVST_EMPTYTEXT = 0
	}


	immutable IID IID_IFolderView2 = {0x1af3a467, 0x214f, 0x4298, [0x90, 0x8e, 0x06, 0xb0, 0x3e, 0x0b, 0x39, 0xf9]};
	interface IFolderView2 : IFolderView
	{
		HRESULT SetGroupBy(REFPROPERTYKEY key, BOOL fAscending);
		HRESULT GetGroupBy(PROPERTYKEY* pkey, BOOL* pfAscending);
		deprecated
		{
			HRESULT SetViewProperty(PCUITEMID_CHILD pidl, REFPROPERTYKEY propkey, REFPROPVARIANT propvar);
			HRESULT GetViewProperty(PCUITEMID_CHILD pidl, REFPROPERTYKEY propkey, PROPVARIANT* ppropvar);
			HRESULT SetTileViewProperties(PCUITEMID_CHILD pidl, LPCWSTR pszPropList);
			HRESULT SetExtendedTileViewProperties(PCUITEMID_CHILD pidl, LPCWSTR pszPropList);
		}
		HRESULT SetText(FVTEXTTYPE iType, LPCWSTR pwszText);
		HRESULT SetCurrentFolderFlags(DWORD dwMask, DWORD dwFlags);
		HRESULT GetCurrentFolderFlags(DWORD* pdwFlags);
		HRESULT GetSortColumnCount(int* pcColumns);
		HRESULT SetSortColumns(const(SORTCOLUMN)* rgSortColumns, int cColumns);
		HRESULT GetSortColumns(SORTCOLUMN* rgSortColumns, int cColumns);
		HRESULT GetItem(int iItem, REFIID riid, void** ppv);
		HRESULT GetVisibleItem(int iStart, BOOL fPrevious, int* piItem);
		HRESULT GetSelectedItem(int iStart, int* piItem);
		HRESULT GetSelection(BOOL fNoneImpliesFolder, IShellItemArray* ppsia);
		HRESULT GetSelectionState(PCUITEMID_CHILD pidl, DWORD* pdwFlags);
		HRESULT InvokeVerbOnSelection(LPCSTR pszVerb);
		HRESULT SetViewModeAndIconSize(FOLDERVIEWMODE uViewMode, int iImageSize);
		HRESULT GetViewModeAndIconSize(FOLDERVIEWMODE* puViewMode, int* piImageSize);
		HRESULT SetGroupSubsetCount(UINT cVisibleRows);
		HRESULT GetGroupSubsetCount(UINT* pcVisibleRows);
		HRESULT SetRedraw(BOOL fRedrawOn);
		HRESULT IsMoveInSameFolder();
		HRESULT DoRename();
	}

	HRESULT IFolderView2_RemoteGetGroupBy_Proxy(IFolderView2 This, PROPERTYKEY* pkey, BOOL* pfAscending);
	void IFolderView2_RemoteGetGroupBy_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

	static if (NTDDI_VERSION >= NTDDI_VISTA)
	{
		immutable IID IID_IFolderViewSettings = {0xae8c987d, 0x8797, 0x4ed3, [0xbe, 0x72, 0x2a, 0x47, 0xdd, 0x93, 0x8d, 0xb0]};
		interface IFolderViewSettings : IUnknown
		{
			HRESULT GetColumnPropertyList(REFIID riid, void** ppv);
			HRESULT GetGroupByProperty(PROPERTYKEY* pkey, BOOL* pfGroupAscending);
			HRESULT GetViewMode(FOLDERLOGICALVIEWMODE* plvm);
			HRESULT GetIconSize(UINT* puIconSize);
			HRESULT GetFolderFlags(DWORD* pfolderMask, DWORD* pfolderFlags);
			HRESULT GetSortColumns(SORTCOLUMN* rgSortColumns, UINT cColumnsIn, UINT* pcColumnsOut);
			HRESULT GetGroupSubsetCount(UINT* pcVisibleRows);
 		}
	}
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IPreviewHandlerVisuals = {0x196bf9a5, 0xb346, 0x4ef0, [0xaa, 0x1e, 0x5d, 0xcd, 0xb7, 0x67, 0x68, 0xb1]};
	interface IPreviewHandlerVisuals : IUnknown
	{
		HRESULT SetBackgroundColor(COLORREF color);
		HRESULT SetFont(const(LOGFONTW)* plf);
		HRESULT SetTextColor(COLORREF color);
	}

	alias DWORD VPWATERMARKFLAGS;
	immutable DWORD VPWF_DEFAULT    = 0;
	immutable DWORD VPWF_ALPHABLEND = 0x1;

	enum VPCOLORFLAGS
	{
		VPCF_TEXT           = 1,
		VPCF_BACKGROUND     = 2,
		VPCF_SORTCOLUMN     = 3,
		VPCF_SUBTEXT        = 4,
		VPCF_TEXTBACKGROUND = 5
	 }

	immutable IID IID_IVisualProperties = {0xe693cf68, 0xd967, 0x4112, [0x87, 0x63, 0x99, 0x17, 0x2a, 0xee, 0x5e, 0x5a]};
	interface IVisualProperties : IUnknown
	{
		HRESULT SetWatermark(HBITMAP hbmp, VPWATERMARKFLAGS vpwf);
		HRESULT SetColor(VPCOLORFLAGS vpcf, COLORREF cr);
		HRESULT GetColor(VPCOLORFLAGS vpcf, COLORREF* pcr);
		HRESULT SetItemHeight(int cyItemInPixels);
		HRESULT GetItemHeight(int* cyItemInPixels);
		HRESULT SetFont(const(LOGFONTW)* plf, BOOL bRedraw);
		HRESULT GetFont(LOGFONTW* plf);
		HRESULT SetTheme(LPCWSTR pszSubAppName, LPCWSTR pszSubIdList);
	}
}

immutable uint CDBOSC_SETFOCUS    = 0x00000000;
immutable uint CDBOSC_KILLFOCUS   = 0x00000001;
immutable uint CDBOSC_SELCHANGE   = 0x00000002;
immutable uint CDBOSC_RENAME      = 0x00000003;
immutable uint CDBOSC_STATECHANGE = 0x00000004;

immutable IID IID_ICommDlgBrowser = {0x000214F1, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
alias IID_ICommDlgBrowser SID_SExplorerBrowserFrame;
interface ICommDlgBrowser : IUnknown
{
	HRESULT OnDefaultCommand(IShellView ppshv);
	HRESULT OnStateChange(IShellView ppshv, ULONG uChange);
	HRESULT IncludeObject(IShellView ppshv, PCUITEMID_CHILD pidl);
}
alias ICommDlgBrowser LPCOMMDLGBROWSER;

static if (NTDDI_VERSION >= NTDDI_WIN2K)
{
	immutable uint CDB2N_CONTEXTMENU_DONE  = 0x00000001;
	immutable uint CDB2N_CONTEXTMENU_START = 0x00000002;
	immutable uint CDB2GVF_SHOWALLFILES    = 0x00000001;

	static if (NTDDI_VERSION >= NTDDI_VISTA)
	{
		immutable uint CDB2GVF_ISFILESAVE       = 0x00000002;
		immutable uint CDB2GVF_ALLOWPREVIEWPANE = 0x00000004;
		immutable uint CDB2GVF_NOSELECTVERB     = 0x00000008;
		immutable uint CDB2GVF_NOINCLUDEITEM    = 0x00000010;
		immutable uint CDB2GVF_ISFOLDERPICKER   = 0x00000020;
		immutable uint CDB2GVF_ADDSHIELD        = 0x00000040;
	}

	immutable IID IID_ICommDlgBrowser2 = {0x10339516, 0x2894, 0x11d2, [0x90, 0x39, 0x00, 0xC0, 0x4F, 0x8E, 0xEB, 0x3E]};
	interface ICommDlgBrowser2 : ICommDlgBrowser
	{
		HRESULT Notify(IShellView ppshv, DWORD dwNotifyType);
		HRESULT GetDefaultMenuText(IShellView ppshv, LPWSTR pszText, int cchMax);
		HRESULT GetViewFlags(DWORD* pdwFlags);
	}
	alias ICommDlgBrowser2 LPCOMMDLGBROWSER2;
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_ICommDlgBrowser3 = {0xc8ad25a1, 0x3294, 0x41ee, [0x81, 0x65, 0x71, 0x17, 0x4b, 0xd0, 0x1c, 0x57]};
	interface ICommDlgBrowser3 : ICommDlgBrowser2
	{
		HRESULT OnColumnClicked(IShellView ppshv, int iColumn);
		HRESULT GetCurrentFilter(LPWSTR pszFileSpec, int cchFileSpec);
		HRESULT OnPreViewCreated(IShellView ppshv);
	}

	alias DWORD CM_MASK;
	immutable DWORD CM_MASK_WIDTH        = 0x1;
	immutable DWORD CM_MASK_DEFAULTWIDTH = 0x2;
	immutable DWORD CM_MASK_IDEALWIDTH   = 0x4;
	immutable DWORD CM_MASK_NAME         = 0x8;
	immutable DWORD CM_MASK_STATE        = 0x10;

	alias DWORD CM_STATE;
	immutable DWORD CM_STATE_NONE               = 0;
	immutable DWORD CM_STATE_VISIBLE            = 0x1;
	immutable DWORD CM_STATE_FIXEDWIDTH         = 0x2;
	immutable DWORD CM_STATE_NOSORTBYFOLDERNESS = 0x4;
	immutable DWORD CM_STATE_ALWAYSVISIBLE      = 0x8;

	alias DWORD CM_ENUM_FLAGS;
	immutable DWORD CM_ENUM_ALL     = 0x1;
	immutable DWORD CM_ENUM_VISIBLE = 0x2;

	enum CM_SET_WIDTH_VALUE
	{
		CM_WIDTH_USEDEFAULT = -1,
		CM_WIDTH_AUTOSIZE = -2
	}

	struct CM_COLUMNINFO
	{
		DWORD cbSize;
		DWORD dwMask;
		DWORD dwState;
		UINT uWidth;
		UINT uDefaultWidth;
		UINT uIdealWidth;
		WCHAR[80] wszName;
	}

	immutable IID IID_IColumnManager = {0xd8ec27bb, 0x3f3b, 0x4042, [0xb1, 0x0a, 0x4a, 0xcf, 0xd9, 0x24, 0xd4, 0x53]};
	interface IColumnManager : IUnknown
	{
		HRESULT SetColumnInfo(REFPROPERTYKEY propkey, const(CM_COLUMNINFO)* pcmci);
		HRESULT GetColumnInfo(REFPROPERTYKEY propkey, CM_COLUMNINFO* pcmci);
		HRESULT GetColumnCount(CM_ENUM_FLAGS dwFlags, UINT* puCount);
		HRESULT GetColumns(CM_ENUM_FLAGS dwFlags, PROPERTYKEY* rgkeyOrder, UINT cColumns);
		HRESULT SetColumns(const(PROPERTYKEY)* rgkeyOrder, UINT cVisible);
	}
}

immutable IID IID_IFolderFilterSite = {0xC0A651F5, 0xB48B, 0x11d2, [0xB5, 0xED, 0x00, 0x60, 0x97, 0xC6, 0x86, 0xF6]};
interface IFolderFilterSite : IUnknown
{
	HRESULT SetFilter(IUnknown punk);
}

immutable IID IID_IFolderFilter = {0x9CC22886, 0xDC8E, 0x11d2, [0xB1, 0xD0, 0x00, 0xC0, 0x4F, 0x8E, 0xEB, 0x3E]};
interface IFolderFilter : IUnknown
{
	HRESULT ShouldShow(IShellFolder psf, PCIDLIST_ABSOLUTE pidlFolder, PCUITEMID_CHILD pidlItem);
	HRESULT GetEnumFlags(IShellFolder psf, PCIDLIST_ABSOLUTE pidlFolder, HWND* phwnd, DWORD* pgrfFlags);
}

immutable IID IID_IInputObjectSite = {0xF1DB8392, 0x7331, 0x11D0, [0x8C, 0x99, 0x00, 0xA0, 0xC9, 0x2D, 0xBF, 0xE8]};
interface IInputObjectSite : IUnknown
{
	HRESULT OnFocusChangeIS(IUnknown punkObj, BOOL fSetFocus);
}

immutable IID IID_IInputObject = {0x68284fAA, 0x6A48, 0x11D0, [0x8c, 0x78, 0x00, 0xC0, 0x4f, 0xd9, 0x18, 0xb4]};
interface IInputObject : IUnknown
{
	HRESULT UIActivateIO(BOOL fActivate, MSG* pMsg);
	HRESULT HasFocusIO();
	HRESULT TranslateAcceleratorIO(MSG* pMsg);
}

immutable IID IID_IInputObject2 = {0x6915C085, 0x510B, 0x44cd, [0x94, 0xAF, 0x28, 0xDF, 0xA5, 0x6C, 0xF9, 0x2B]};
interface IInputObject2 : IInputObject
{
	HRESULT TranslateAcceleratorGlobal(MSG* pMsg);
}

immutable IID IID_IShellIcon = {0x000214E5, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellIcon : IUnknown
{
	HRESULT GetIconOf(PCUITEMID_CHILD pidl, UINT flags, int* pIconIndex);
}

immutable uint SBSP_DEFBROWSER         = 0x0000;
immutable uint SBSP_SAMEBROWSER        = 0x0001;
immutable uint SBSP_NEWBROWSER         = 0x0002;
immutable uint SBSP_DEFMODE            = 0x0000;
immutable uint SBSP_OPENMODE           = 0x0010;
immutable uint SBSP_EXPLOREMODE        = 0x0020;
immutable uint SBSP_HELPMODE           = 0x0040;
immutable uint SBSP_NOTRANSFERHIST     = 0x0080;
immutable uint SBSP_ABSOLUTE           = 0x0000;
immutable uint SBSP_RELATIVE           = 0x1000;
immutable uint SBSP_PARENT             = 0x2000;
immutable uint SBSP_NAVIGATEBACK       = 0x4000;
immutable uint SBSP_NAVIGATEFORWARD    = 0x8000;
immutable uint SBSP_ALLOW_AUTONAVIGATE = 0x00010000;
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable uint SBSP_KEEPSAMETEMPLATE  = 0x00020000;
	immutable uint SBSP_KEEPWORDWHEELTEXT = 0x00040000;
	immutable uint SBSP_ACTIVATE_NOFOCUS  = 0x00080000;
	immutable uint SBSP_CREATENOHISTORY   = 0x00100000;
	immutable uint SBSP_PLAYNOSOUND       = 0x00200000;
}
static if (_WIN32_IE >= _WIN32_IE_IE60SP2)
{
	immutable uint SBSP_CALLERUNTRUSTED      = 0x00800000;
	immutable uint SBSP_TRUSTFIRSTDOWNLOAD   = 0x01000000;
	immutable uint SBSP_UNTRUSTEDFORDOWNLOAD = 0x02000000;
}
immutable uint SBSP_NOAUTOSELECT   = 0x04000000;
immutable uint SBSP_WRITENOHISTORY = 0x08000000;
static if (_WIN32_IE >= _WIN32_IE_IE60SP2)
{
	immutable uint SBSP_TRUSTEDFORACTIVEX = 0x10000000;
}
static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	immutable uint SBSP_FEEDNAVIGATION = 0x20000000;
}
immutable uint SBSP_REDIRECT = 0x40000000;
immutable uint SBSP_INITIATEDBYHLINKFRAME = 0x80000000;

immutable uint FCW_STATUS      = 0x0001;
immutable uint FCW_TOOLBAR     = 0x0002;
immutable uint FCW_TREE        = 0x0003;
immutable uint FCW_INTERNETBAR = 0x0006;
immutable uint FCW_PROGRESS    = 0x0008;
immutable uint FCT_MERGE       = 0x0001;
immutable uint FCT_CONFIGABLE  = 0x0002;
immutable uint FCT_ADDTOEND    = 0x0004;
version (_NEVER_)
{
	alias LPARAM LPTBBUTTONSB;
}
else
{
	alias LPTBBUTTON LPTBBUTTONSB;
}

immutable IID IID_IShellBrowser = {0x000214E2, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellBrowser : IOleWindow
{
	HRESULT InsertMenusSB(HMENU hmenuShared, LPOLEMENUGROUPWIDTHS lpMenuWidths);
	HRESULT SetMenuSB(HMENU hmenuShared, HOLEMENU holemenuRes, HWND hwndActiveObject);
	HRESULT RemoveMenusSB(HMENU hmenuShared);
	HRESULT SetStatusTextSB(LPCWSTR pszStatusText);
	HRESULT EnableModelessSB(BOOL fEnable);
	HRESULT TranslateAcceleratorSB(MSG* pmsg, WORD wID);
	HRESULT BrowseObject(PCUIDLIST_RELATIVE pidl, UINT wFlags);
	HRESULT GetViewStateStream(DWORD grfMode, IStream* ppStrm);
	HRESULT GetControlWindow(UINT id, HWND* phwnd);
	HRESULT SendControlMsg(UINT id, UINT uMsg, WPARAM wParam, LPARAM lParam, LRESULT* pret);
	HRESULT QueryActiveShellView(IShellView* ppshv);
	HRESULT OnViewWindowActive(IShellView pshv);
	HRESULT SetToolbarItems(LPTBBUTTONSB lpButtons, UINT nButtons, UINT uFlags);
}
alias IShellBrowser LPSHELLBROWSER;

immutable IID IID_IProfferService = {0xcb728b20, 0xf786, 0x11ce, [0x92, 0xad, 0x00, 0xaa, 0x00, 0xa7, 0x4c, 0xd0]};
alias IID_IProfferService SID_SProfferService;
interface IProfferService : IUnknown
{
	HRESULT ProfferService(REFGUID guidService, IServiceProvider psp, DWORD* pdwCookie);
	HRESULT RevokeService(DWORD dwCookie);
}

immutable wchar* STR_DONT_RESOLVE_LINK = "Don't Resolve Link\0"w.ptr;
immutable wchar* STR_GET_ASYNC_HANDLER = "GetAsyncHandler\0"w.ptr;

enum SIGDN : DWORD
{
	SIGDN_NORMALDISPLAY               = 0,
	SIGDN_PARENTRELATIVEPARSING       = 0x80018001,
	SIGDN_DESKTOPABSOLUTEPARSING      = 0x80028000,
	SIGDN_PARENTRELATIVEEDITING       = 0x80031001,
	SIGDN_DESKTOPABSOLUTEEDITING      = 0x8004c000,
	SIGDN_FILESYSPATH                 = 0x80058000,
	SIGDN_URL                         = 0x80068000,
	SIGDN_PARENTRELATIVEFORADDRESSBAR = 0x8007c001,
	SIGDN_PARENTRELATIVE              = 0x80080001
}

alias DWORD SICHINTF;
immutable DWORD SICHINT_DISPLAY                       = 0;
immutable DWORD SICHINT_ALLFIELDS                     = 0x80000000;
immutable DWORD SICHINT_CANONICAL                     = 0x10000000;
immutable DWORD SICHINT_TEST_FILESYSPATH_IF_NOT_EQUAL = 0x20000000;

immutable IID IID_IShellItem = {0x43826d1e, 0xe718, 0x42ee, [0xbc, 0x55, 0xa1, 0xe2, 0x61, 0xc3, 0x7b, 0xfe]};
interface IShellItem : IUnknown
{
	HRESULT BindToHandler(IBindCtx pbc, REFGUID bhid, REFIID riid, void** ppv);
	HRESULT GetParent(IShellItem* ppsi);
	HRESULT GetDisplayName(SIGDN sigdnName, LPWSTR* ppszName);
	HRESULT GetAttributes(SFGAOF sfgaoMask, SFGAOF* psfgaoAttribs);
	HRESULT Compare(IShellItem psi, SICHINTF hint, int* piOrder);
}

PIDLIST_ABSOLUTE SHSimpleIDListFromPath(LPCWSTR pszPath);

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	HRESULT SHCreateItemFromIDList(PCIDLIST_ABSOLUTE pidl, REFIID riid, void** ppv);
	HRESULT SHCreateItemFromParsingName(PCWSTR pszPath, IBindCtx pbc, REFIID riid, void** ppv);
	HRESULT SHCreateItemWithParent(PCIDLIST_ABSOLUTE pidlParent, IShellFolder psfParent, PCUITEMID_CHILD pidl, REFIID riid, void** ppvItem);
	HRESULT SHCreateItemFromRelativeName(IShellItem psiParent, PCWSTR pszName, IBindCtx pbc, REFIID riid, void** ppv);
}
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	HRESULT SHCreateItemInKnownFolder(REFKNOWNFOLDERID kfid, DWORD dwKFFlags, PCWSTR pszItem, REFIID riid, void** ppv);
	HRESULT SHGetIDListFromObject(IUnknown punk, PIDLIST_ABSOLUTE* ppidl);
	HRESULT SHGetItemFromObject(IUnknown punk, REFIID riid, void** ppv);
	HRESULT SHGetPropertyStoreFromIDList(PCIDLIST_ABSOLUTE pidl, GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
	HRESULT SHGetPropertyStoreFromParsingName(PCWSTR pszPath, IBindCtx pbc, GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
	HRESULT SHGetNameFromIDList(PCIDLIST_ABSOLUTE pidl, SIGDN sigdnName, PWSTR* ppszName);
}
static if (NTDDI_VERSION >= NTDDI_WIN7)
{
	alias DWORD DATAOBJ_GET_ITEM_FLAGS;
	immutable DWORD DOGIF_DEFAULT       = 0;
	immutable DWORD DOGIF_TRAVERSE_LINK = 0x1;
	immutable DWORD DOGIF_NO_HDROP      = 0x2;
	immutable DWORD DOGIF_NO_URL        = 0x4;
	immutable DWORD DOGIF_ONLY_IF_ONE   = 0x8;

	HRESULT SHGetItemFromDataObject(IDataObject pdtobj, DATAOBJ_GET_ITEM_FLAGS dwFlags, REFIID riid, void** ppv);
}

immutable wchar* STR_GPS_HANDLERPROPERTIESONLY = "GPS_HANDLERPROPERTIESONLY\0"w.ptr;
immutable wchar* STR_GPS_FASTPROPERTIESONLY    = "GPS_FASTPROPERTIESONLY\0"w.ptr;
immutable wchar* STR_GPS_OPENSLOWITEM          = "GPS_OPENSLOWITEM\0"w.ptr;
immutable wchar* STR_GPS_DELAYCREATION         = "GPS_DELAYCREATION\0"w.ptr;
immutable wchar* STR_GPS_BESTEFFORT            = "GPS_BESTEFFORT\0"w.ptr;
immutable wchar* STR_GPS_NO_OPLOCK             = "GPS_NO_OPLOCK\0"w.ptr;

immutable IID IID_IShellItem2 = {0x7e9fb0d3, 0x919f, 0x4307, [0xab, 0x2e, 0x9b, 0x18, 0x60, 0x31, 0x0c, 0x93]};
interface IShellItem2 : IShellItem
{
	HRESULT GetPropertyStore(GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
	HRESULT GetPropertyStoreWithCreateObject(GETPROPERTYSTOREFLAGS flags, IUnknown punkCreateObject, REFIID riid, void** ppv);
	HRESULT GetPropertyStoreForKeys(const(PROPERTYKEY)* rgKeys, UINT cKeys, GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
	HRESULT GetPropertyDescriptionList(REFPROPERTYKEY keyType, REFIID riid, void** ppv);
	HRESULT Update(IBindCtx pbc);
	HRESULT GetProperty(REFPROPERTYKEY key, PROPVARIANT* ppropvar);
	HRESULT GetCLSID(REFPROPERTYKEY key, CLSID* pclsid);
	HRESULT GetFileTime(REFPROPERTYKEY key, FILETIME* pft);
	HRESULT GetInt32(REFPROPERTYKEY key, int* pi);
	HRESULT GetString(REFPROPERTYKEY key, LPWSTR* ppsz);
	HRESULT GetUInt32(REFPROPERTYKEY key, ULONG* pui);
	HRESULT GetUInt64(REFPROPERTYKEY key, ULONGLONG* pull);
	HRESULT GetBool(REFPROPERTYKEY key, BOOL* pf);
}

alias uint SIIGBF;
immutable uint SIIGBF_RESIZETOFIT   = 0;
immutable uint SIIGBF_BIGGERSIZEOK  = 0x1;
immutable uint SIIGBF_MEMORYONLY    = 0x2;
immutable uint SIIGBF_ICONONLY      = 0x4;
immutable uint SIIGBF_THUMBNAILONLY = 0x8;
immutable uint SIIGBF_INCACHEONLY   = 0x10;

immutable IID IID_IShellItemImageFactory = {0xbcc18b79, 0xba16, 0x442f, [0x80, 0xc4, 0x8a, 0x59, 0xc3, 0x0c, 0x46, 0x3b]};
interface IShellItemImageFactory : IUnknown
{
	HRESULT GetImage(SIZE size, SIIGBF flags, HBITMAP* phbm);
}

immutable IID IID_IUserAccountChangeCallback = {0xa561e69a, 0xb4b8, 0x4113, [0x91, 0xa5, 0x64, 0xc6, 0xbc, 0xca, 0x34, 0x30]};
interface IUserAccountChangeCallback : IUnknown
{
	HRESULT OnPictureChange(LPCWSTR pszUserName);
}

static if (NTDDI_VERSION >= NTDDI_WINXP)
{
	immutable IID IID_IEnumShellItems = {0x70629033, 0xe363, 0x4a28, [0xa5, 0x67, 0x0d, 0xb7, 0x80, 0x06, 0xe6, 0xd7]};
	interface IEnumShellItems : IUnknown
	{
		HRESULT Next(ULONG celt, IShellItem* rgelt, ULONG* pceltFetched);
		HRESULT Skip(ULONG celt);
		HRESULT Reset();
		HRESULT Clone(IEnumShellItems* ppenum);
	}

	HRESULT IEnumShellItems_RemoteNext_Proxy(IEnumShellItems This, ULONG celt, IShellItem* rgelt, ULONG* pceltFetched);
	void IEnumShellItems_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

	alias GUID STGTRANSCONFIRMATION;
	alias GUID* LPSTGTRANSCONFIRMATION;

	enum STGOP
	{
		STGOP_MOVE            = 1,
		STGOP_COPY            = 2,
		STGOP_SYNC            = 3,
		STGOP_REMOVE          = 5,
		STGOP_RENAME          = 6,
		STGOP_APPLYPROPERTIES = 8,
		STGOP_NEW             = 10
	}
}

alias DWORD TRANSFER_SOURCE_FLAGS;
immutable DWORD TSF_NORMAL                     = 0;
immutable DWORD TSF_FAIL_EXIST                 = 0;
immutable DWORD TSF_RENAME_EXIST               = 0x1;
immutable DWORD TSF_OVERWRITE_EXIST            = 0x2;
immutable DWORD TSF_ALLOW_DECRYPTION           = 0x4;
immutable DWORD TSF_NO_SECURITY                = 0x8;
immutable DWORD TSF_COPY_CREATION_TIME         = 0x10;
immutable DWORD TSF_COPY_WRITE_TIME            = 0x20;
immutable DWORD TSF_USE_FULL_ACCESS            = 0x40;
immutable DWORD TSF_DELETE_RECYCLE_IF_POSSIBLE = 0x80;
immutable DWORD TSF_COPY_HARD_LINK             = 0x100;
immutable DWORD TSF_COPY_LOCALIZED_NAME        = 0x200;
immutable DWORD TSF_MOVE_AS_COPY_DELETE        = 0x400;
immutable DWORD TSF_SUSPEND_SHELLEVENTS        = 0x800;

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	alias DWORD TRANSFER_ADVISE_STATE;
	immutable DWORD TS_NONE          = 0;
	immutable DWORD TS_PERFORMING    = 0x1;
	immutable DWORD TS_PREPARING     = 0x2;
	immutable DWORD TS_INDETERMINATE = 0x4;

	immutable IID IID_ITransferAdviseSink = {0xd594d0d8, 0x8da7, 0x457b, [0xb3, 0xb4, 0xce, 0x5d, 0xba, 0xac, 0x0b, 0x88]};
	interface ITransferAdviseSink : IUnknown
	{
		HRESULT UpdateProgress(ULONGLONG ullSizeCurrent, ULONGLONG ullSizeTotal, int nFilesCurrent, int nFilesTotal, int nFoldersCurrent, int nFoldersTotal);
		HRESULT UpdateTransferState(TRANSFER_ADVISE_STATE ts);
		HRESULT ConfirmOverwrite(IShellItem psiSource, IShellItem psiDestParent, LPCWSTR pszName);
		HRESULT ConfirmEncryptionLoss(IShellItem psiSource);
		HRESULT FileFailure(IShellItem psi, LPCWSTR pszItem, HRESULT hrError, LPWSTR pszRename, ULONG cchRename);
		HRESULT SubStreamFailure(IShellItem psi, LPCWSTR pszStreamName, HRESULT hrError);
		HRESULT PropertyFailure(IShellItem psi,  const(PROPERTYKEY)* pkey, HRESULT hrError);
	}
}
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_ITransferSource = {0x00adb003, 0xbde9, 0x45c6, [0x8e, 0x29, 0xd0, 0x9f, 0x93, 0x53, 0xe1, 0x08]};
	interface ITransferSource : IUnknown
	{
		HRESULT Advise(ITransferAdviseSink psink, DWORD* pdwCookie);
		HRESULT Unadvise(DWORD dwCookie);
		HRESULT SetProperties(IPropertyChangeArray pproparray);
		HRESULT OpenItem(IShellItem psi, TRANSFER_SOURCE_FLAGS flags, REFIID riid, void** ppv);
		HRESULT MoveItem(IShellItem psi, IShellItem psiParentDst, LPCWSTR pszNameDst, TRANSFER_SOURCE_FLAGS flags, IShellItem* ppsiNew);
		HRESULT RecycleItem(IShellItem psiSource, IShellItem psiParentDest, TRANSFER_SOURCE_FLAGS flags, IShellItem* ppsiNewDest);
		HRESULT RemoveItem(IShellItem psiSource, TRANSFER_SOURCE_FLAGS flags);
		HRESULT RenameItem(IShellItem psiSource, LPCWSTR pszNewName, TRANSFER_SOURCE_FLAGS flags, IShellItem* ppsiNewDest);
		HRESULT LinkItem(IShellItem psiSource, IShellItem psiParentDest, LPCWSTR pszNewName, TRANSFER_SOURCE_FLAGS flags, IShellItem* ppsiNewDest);
		HRESULT ApplyPropertiesToItem(IShellItem psiSource, IShellItem* ppsiNew);
		HRESULT GetDefaultDestinationName(IShellItem psiSource, IShellItem psiParentDest, LPWSTR* ppszDestinationName);
		HRESULT EnterFolder(IShellItem psiChildFolderDest);
		HRESULT LeaveFolder(IShellItem psiChildFolderDest);
	}
}

struct SHELL_ITEM_RESOURCE
{
	GUID guidType;
	WCHAR[260] szName;
}

immutable IID IID_IEnumResources = {0x2dd81fe3, 0xa83c, 0x4da9, [0xa3, 0x30, 0x47, 0x24, 0x9d, 0x34, 0x5b, 0xa1]};
interface IEnumResources : IUnknown
{
	HRESULT Next(ULONG celt, SHELL_ITEM_RESOURCE* psir, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumResources* ppenumr);
}

immutable IID IID_IShellItemResources = {0xff5693be, 0x2ce0, 0x4d48, [0xb5, 0xc5, 0x40, 0x81, 0x7d, 0x1a, 0xcd, 0xb9]};
interface IShellItemResources : IUnknown
{
	HRESULT GetAttributes(DWORD* pdwAttributes);
	HRESULT GetSize(ULONGLONG* pullSize);
	HRESULT GetTimes(FILETIME* pftCreation, FILETIME* pftWrite, FILETIME* pftAccess);
	HRESULT SetTimes(const(FILETIME)* pftCreation, const(FILETIME)* pftWrite, const(FILETIME)* pftAccess);
	HRESULT GetResourceDescription(const(SHELL_ITEM_RESOURCE)* pcsir, LPWSTR* ppszDescription);
	HRESULT EnumResources(IEnumResources* ppenumr);
	HRESULT SupportsResource(const(SHELL_ITEM_RESOURCE)* pcsir);
	HRESULT OpenResource(const(SHELL_ITEM_RESOURCE)* pcsir, REFIID riid, void** ppv);
	HRESULT CreateResource(const(SHELL_ITEM_RESOURCE)* pcsir, REFIID riid, void** ppv);
	HRESULT MarkForDelete();
}

immutable IID IID_ITransferDestination = {0x48addd32, 0x3ca5, 0x4124, [0xab, 0xe3, 0xb5, 0xa7, 0x25, 0x31, 0xb2, 0x07]};
interface ITransferDestination : IUnknown
{
	HRESULT Advise(ITransferAdviseSink psink, DWORD* pdwCookie);
	HRESULT Unadvise(DWORD dwCookie);
	HRESULT CreateItem(LPCWSTR pszName, DWORD dwAttributes, ULONGLONG ullSize, TRANSFER_SOURCE_FLAGS flags, REFIID riidItem, void** ppvItem, REFIID riidResources, void** ppvResources);
}

struct OVERLAPPED
{
	ULONG_PTR Internal;
	ULONG_PTR InternalHigh;
	union
	{
		 struct
		 {
			 DWORD Offset;
			 DWORD OffsetHigh;
		 }
		 PVOID Pointer;
	}
	 HANDLE hEvent;
}
alias OVERLAPPED* LPOVERLAPPED;

immutable IID IID_IStreamAsync = {0xfe0b6665, 0xe0ca, 0x49b9, [0xa1, 0x78, 0x2b, 0x5c, 0xb4, 0x8d, 0x92, 0xa5]};
interface IStreamAsync : IStream
{
	HRESULT ReadAsync(void* pv, DWORD cb, LPDWORD pcbRead, LPOVERLAPPED lpOverlapped);
	HRESULT WriteAsync(const(void)* lpBuffer, DWORD cb, LPDWORD pcbWritten, LPOVERLAPPED lpOverlapped);
	HRESULT OverlappedResult(LPOVERLAPPED lpOverlapped, LPDWORD lpNumberOfBytesTransferred, BOOL bWait);
	HRESULT CancelIo();
}

immutable IID IID_IStreamUnbufferedInfo = {0x8a68fdda, 0x1fdc, 0x4c20, [0x8c, 0xeb, 0x41, 0x66, 0x43, 0xb5, 0xa6, 0x25]};
interface IStreamUnbufferedInfo : IUnknown
{
	HRESULT GetSectorSize(ULONG* pcbSectorSize);
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IFileOperationProgressSink = {0x04b0f1a7, 0x9490, 0x44bc, [0x96, 0xe1, 0x42, 0x96, 0xa3, 0x12, 0x52, 0xe2]};
	interface IFileOperationProgressSink : IUnknown
	{
		HRESULT StartOperations();
		HRESULT FinishOperations(HRESULT hrResult);
		HRESULT PreRenameItem(DWORD dwFlags, IShellItem psiItem, LPCWSTR pszNewName);
		HRESULT PostRenameItem(DWORD dwFlags, IShellItem psiItem, LPCWSTR pszNewName, HRESULT hrRename, IShellItem psiNewlyCreated);
		HRESULT PreMoveItem(DWORD dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszNewName);
		HRESULT PostMoveItem(DWORD dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszNewName, HRESULT hrMove, IShellItem psiNewlyCreated);
		HRESULT PreCopyItem(DWORD dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszNewName);
		HRESULT PostCopyItem(DWORD dwFlags, IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszNewName, HRESULT hrCopy, IShellItem psiNewlyCreated);
		HRESULT PreDeleteItem(DWORD dwFlags, IShellItem psiItem);
		HRESULT PostDeleteItem(DWORD dwFlags, IShellItem psiItem, HRESULT hrDelete, IShellItem psiNewlyCreated);
		HRESULT PreNewItem(DWORD dwFlags, IShellItem psiDestinationFolder, LPCWSTR pszNewName);
		HRESULT PostNewItem(DWORD dwFlags, IShellItem psiDestinationFolder, LPCWSTR pszNewName, LPCWSTR pszTemplateName, DWORD dwFileAttributes, HRESULT hrNew, IShellItem psiNewItem);
		HRESULT UpdateProgress(UINT iWorkTotal, UINT iWorkSoFar);
		HRESULT ResetTimer();
		HRESULT PauseTimer();
		HRESULT ResumeTimer();
	}
}

alias DWORD SIATTRIBFLAGS;
immutable DWORD SIATTRIBFLAGS_AND       = 0x1;
immutable DWORD SIATTRIBFLAGS_OR        = 0x2;
immutable DWORD SIATTRIBFLAGS_APPCOMPAT = 0x3;
immutable DWORD SIATTRIBFLAGS_MASK      = 0x3;
immutable DWORD SIATTRIBFLAGS_ALLITEMS  = 0x4000;

immutable IID IID_IShellItemArray = {0xb63ea76d, 0x1f85, 0x456f, [0xa1, 0x9c, 0x48, 0x15, 0x9e, 0xfa, 0x85, 0x8b]};
interface IShellItemArray : IUnknown
{
	HRESULT BindToHandler(IBindCtx pbc, REFGUID bhid, REFIID riid, void** ppvOut);
	HRESULT GetPropertyStore(GETPROPERTYSTOREFLAGS flags, REFIID riid, void** ppv);
	HRESULT GetPropertyDescriptionList(REFPROPERTYKEY keyType, REFIID riid, void** ppv);
	HRESULT GetAttributes(SIATTRIBFLAGS AttribFlags, SFGAOF sfgaoMask, SFGAOF* psfgaoAttribs);
	HRESULT GetCount(DWORD* pdwNumItems);
	HRESULT GetItemAt(DWORD dwIndex, IShellItem* ppsi);
	HRESULT EnumItems(IEnumShellItems* ppenumShellItems);
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	HRESULT SHCreateShellItemArray(PCIDLIST_ABSOLUTE pidlParent, IShellFolder psf, UINT cidl, PCUITEMID_CHILD_ARRAY ppidl, IShellItemArray* ppsiItemArray);
	HRESULT SHCreateShellItemArrayFromDataObject(IDataObject pdo, REFIID riid, void** ppv);
	HRESULT SHCreateShellItemArrayFromIDLists(UINT cidl, PCIDLIST_ABSOLUTE_ARRAY rgpidl, IShellItemArray* ppsiItemArray);
	HRESULT SHCreateShellItemArrayFromShellItem(IShellItem psi, REFIID riid, void** ppv);
}

immutable IID IID_IInitializeWithItem = {0x7f73be3f, 0xfb79, 0x493c, [0xa6, 0xc7, 0x7e, 0xe1, 0x4e, 0x24, 0x58, 0x41]};
interface IInitializeWithItem : IUnknown
{
	HRESULT Initialize(IShellItem psi, DWORD grfMode);
}

immutable IID IID_IObjectWithSelection = {0x1c9cd5bb, 0x98e9, 0x4491, [0xa6, 0x0f, 0x31, 0xaa, 0xcc, 0x72, 0xb8, 0x3c]};
interface IObjectWithSelection : IUnknown
{
	HRESULT SetSelection(IShellItemArray psia);
	HRESULT GetSelection(REFIID riid, void** ppv);
}

immutable IID IID_IObjectWithBackReferences = {0x321a6a6a, 0xd61f, 0x4bf3, [0x97, 0xae, 0x14, 0xbe, 0x29, 0x86, 0xbb, 0x36]};
interface IObjectWithBackReferences : IUnknown
{
	HRESULT RemoveBackReferences();
}

alias DWORD PROPERTYUI_NAME_FLAGS;
immutable DWORD PUIFNF_DEFAULT  = 0;
immutable DWORD PUIFNF_MNEMONIC = 0x01;

alias DWORD PROPERTYUI_FLAGS;
immutable DWORD PUIF_DEFAULT          = 0;
immutable DWORD PUIF_RIGHTALIGN       = 0x1;
immutable DWORD PUIF_NOLABELININFOTIP = 0x2;

alias DWORD PROPERTYUI_FORMAT_FLAGS;
immutable DWORD PUIFFDF_DEFAULT      = 0;
immutable DWORD PUIFFDF_RIGHTTOLEFT  = 0x1;
immutable DWORD PUIFFDF_SHORTFORMAT  = 0x2;
immutable DWORD PUIFFDF_NOTIME       = 0x4;
immutable DWORD PUIFFDF_FRIENDLYDATE = 0x8;

immutable IID IID_IPropertyUI = {0x757a7d9f, 0x919a, 0x4118, [0x99, 0xd7, 0xdb, 0xb2, 0x08, 0xc8, 0xcc, 0x66]};
interface IPropertyUI : IUnknown
{
	HRESULT ParsePropertyName(LPCWSTR pszName, FMTID* pfmtid, PROPID* ppid, ULONG* pchEaten);
	HRESULT GetCannonicalName(REFFMTID fmtid, PROPID pid, LPWSTR pwszText, DWORD cchText);
	HRESULT GetDisplayName(REFFMTID fmtid, PROPID pid, PROPERTYUI_NAME_FLAGS flags, LPWSTR pwszText, DWORD cchText);
	HRESULT GetPropertyDescription(REFFMTID fmtid, PROPID pid, LPWSTR pwszText, DWORD cchText);
	HRESULT GetDefaultWidth(REFFMTID fmtid, PROPID pid, ULONG* pcxChars);
	HRESULT GetFlags(REFFMTID fmtid, PROPID pid, PROPERTYUI_FLAGS* pflags);
	HRESULT FormatForDisplay(REFFMTID fmtid, PROPID pid, const(PROPVARIANT)* ppropvar, PROPERTYUI_FORMAT_FLAGS puiff, LPWSTR pwszText, DWORD cchText);
	HRESULT GetHelpInfo(REFFMTID fmtid, PROPID pid, LPWSTR pwszHelpFile, DWORD cch, UINT* puHelpID);
}

static if (_WIN32_IE >= 0x0500)
{
	immutable IID IID_ICategoryProvider = {0x9af64809, 0x5864, 0x4c26, [0xa7, 0x20, 0xc1, 0xf7, 0x8c, 0x08, 0x6e, 0xe3]};
	interface ICategoryProvider : IUnknown
	{
		HRESULT CanCategorizeOnSCID(const(SHCOLUMNID)* pscid);
		HRESULT GetDefaultCategory(GUID* pguid, SHCOLUMNID* pscid);
		HRESULT GetCategoryForSCID(const(SHCOLUMNID)* pscid, GUID* pguid);
		HRESULT EnumCategories(IEnumGUID* penum);
		HRESULT GetCategoryName(const(GUID)* pguid, LPWSTR pszName, UINT cch);
		HRESULT CreateCategory(const(GUID)* pguid, REFIID riid, void** ppv);
	}

	alias DWORD CATEGORYINFO_FLAGS;
	immutable DWORD CATINFO_NORMAL         = 0;
	immutable DWORD CATINFO_COLLAPSED      = 0x1;
	immutable DWORD CATINFO_HIDDEN         = 0x2;
	immutable DWORD CATINFO_EXPANDED       = 0x4;
	immutable DWORD CATINFO_NOHEADER       = 0x8;
	immutable DWORD CATINFO_NOTCOLLAPSIBLE = 0x10;
	immutable DWORD CATINFO_NOHEADERCOUNT  = 0x20;
	immutable DWORD CATINFO_SUBSETTED      = 0x40;

	alias DWORD CATSORT_FLAGS;
	immutable DWORD CATSORT_DEFAULT = 0;
	immutable DWORD CATSORT_NAME    = 0x1;

	struct CATEGORY_INFO
	{
		CATEGORYINFO_FLAGS cif;
		WCHAR[260] wszName;
	}

	immutable IID IID_ICategorizer= {0xa3b14589, 0x9174, 0x49a8, [0x89, 0xa3, 0x06, 0xa1, 0xae, 0x2b, 0x9b, 0xa7]};
	interface ICategorizer : IUnknown
	{
		HRESULT GetDescription(LPWSTR pszDesc, UINT cch);
		HRESULT GetCategory(UINT cidl, PCUITEMID_CHILD_ARRAY apidl, DWORD* rgCategoryIds);
		HRESULT GetCategoryInfo(DWORD dwCategoryId, CATEGORY_INFO* pci);
		HRESULT CompareCategory(CATSORT_FLAGS csfFlags, DWORD dwCategoryId1, DWORD dwCategoryId2);
	}
}

static if (NTDDI_VERSION >= NTDDI_WIN2K)
{
	align (8)
	struct SHDRAGIMAGE
	{
		SIZE sizeDragImage;
		POINT ptOffset;
		HBITMAP hbmpDragImage;
		COLORREF crColorKey;
	}
	alias SHDRAGIMAGE* LPSHDRAGIMAGE;

	version (Unicode)
	{
		immutable wchar* DI_GETDRAGIMAGE = "ShellGetDragImage\0"w.ptr;
	}
	else
	{
		immutable char* DI_GETDRAGIMAGE = "ShellGetDragImage\0".ptr;
	}

	immutable IID IID_IDropTargetHelper = {0x4657278B, 0x411B, 0x11D2, [0x83, 0x9A, 0x00, 0xC0, 0x4F, 0xD9, 0x18, 0xD0]};
	interface IDropTargetHelper : IUnknown
	{
		HRESULT DragEnter(HWND hwndTarget, IDataObject pDataObject, POINT* ppt, DWORD dwEffect);
		HRESULT DragLeave();
		HRESULT DragOver(POINT* ppt, DWORD dwEffect);
		HRESULT Drop(IDataObject pDataObject, POINT* ppt, DWORD dwEffect);
		HRESULT Show(BOOL fShow);
	}

	immutable IID IID_IDragSourceHelper = {0xDE5BF786, 0x477A, 0x11D2, [0x83, 0x9D, 0x00, 0xC0, 0x4F, 0xD9, 0x18, 0xD0]};
	interface IDragSourceHelper : IUnknown
	{
		HRESULT InitializeFromBitmap(LPSHDRAGIMAGE pshdi, IDataObject pDataObject);
		HRESULT InitializeFromWindow(HWND hwnd, POINT* ppt, IDataObject pDataObject);
	}

	static if (NTDDI_VERSION >= NTDDI_VISTA)
	{
		alias DWORD DSH_FLAGS;
		immutable DWORD DSH_ALLOWDROPDESCRIPTIONTEXT = 0x1;

		immutable IID IID_IDragSourceHelper2 = {0x83E07D0D, 0x0C5F, 0x4163, [0xBF, 0x1A, 0x60, 0xB2, 0x74, 0x05, 0x1E, 0x40]};
		interface IDragSourceHelper2 : IDragSourceHelper
		{
			HRESULT SetFlags(DWORD dwFlags);
		}
	}
}

alias DWORD SLR_FLAGS;
immutable DWORD SLR_NO_UI                     = 0x1;
immutable DWORD SLR_ANY_MATCH                 = 0x2;
immutable DWORD SLR_UPDATE                    = 0x4;
immutable DWORD SLR_NOUPDATE                  = 0x8;
immutable DWORD SLR_NOSEARCH                  = 0x10;
immutable DWORD SLR_NOTRACK                   = 0x20;
immutable DWORD SLR_NOLINKINFO                = 0x40;
immutable DWORD SLR_INVOKE_MSI                = 0x80;
immutable DWORD SLR_NO_UI_WITH_MSG_PUMP       = 0x101;
immutable DWORD SLR_OFFER_DELETE_WITHOUT_FILE = 0x200;
immutable DWORD SLR_KNOWNFOLDER               = 0x400;
immutable DWORD SLR_MACHINE_IN_LOCAL_TARGET   = 0x800;
immutable DWORD SLR_UPDATE_MACHINE_AND_SID    = 0x1000;

alias DWORD SLGP_FLAGS;
immutable DWORD SLGP_SHORTPATH        = 0x1;
immutable DWORD SLGP_UNCPRIORITY      = 0x2;
immutable DWORD SLGP_RAWPATH          = 0x4;
immutable DWORD SLGP_RELATIVEPRIORITY = 0x8;

immutable IID IID_IShellLinkA = {0x000214EE, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellLinkA : IUnknown
{
	HRESULT GetPath(LPSTR pszFile, int cch, WIN32_FIND_DATAA* pfd, DWORD fFlags);
	HRESULT GetIDList(PIDLIST_ABSOLUTE* ppidl);
	HRESULT SetIDList(PCIDLIST_ABSOLUTE pidl);
	HRESULT GetDescription(LPSTR pszName, int cch);
	HRESULT SetDescription(LPCSTR pszName);
	HRESULT GetWorkingDirectory(LPSTR pszDir, int cch);
	HRESULT SetWorkingDirectory(LPCSTR pszDir);
	HRESULT GetArguments(LPSTR pszArgs, int cch);
	HRESULT SetArguments(LPCSTR pszArgs);
	HRESULT GetHotkey(WORD* pwHotkey);
	HRESULT SetHotkey(WORD wHotkey);
	HRESULT GetShowCmd(int* piShowCmd);
	HRESULT SetShowCmd(int iShowCmd);
	HRESULT GetIconLocation(LPSTR pszIconPath, int cch, int* piIcon);
	HRESULT SetIconLocation(LPCSTR pszIconPath, int iIcon);
	HRESULT SetRelativePath(LPCSTR pszPathRel, DWORD dwReserved);
	HRESULT Resolve(HWND hwnd, DWORD fFlags);
	HRESULT SetPath(LPCSTR pszFile);
}

immutable IID IID_IShellLinkW = {0x000214F9, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellLinkW : IUnknown
{
	HRESULT GetPath(LPWSTR pszFile, int cch, WIN32_FIND_DATAW* pfd, DWORD fFlags);
	HRESULT GetIDList(PIDLIST_ABSOLUTE* ppidl);
	HRESULT SetIDList(PCIDLIST_ABSOLUTE pidl);
	HRESULT GetDescription(LPWSTR pszName, int cch);
	HRESULT SetDescription(LPCWSTR pszName);
	HRESULT GetWorkingDirectory(LPWSTR pszDir, int cch);
	HRESULT SetWorkingDirectory(LPCWSTR pszDir);
	HRESULT GetArguments(LPWSTR pszArgs, int cch);
	HRESULT SetArguments(LPCWSTR pszArgs);
	HRESULT GetHotkey(WORD* pwHotkey);
	HRESULT SetHotkey(WORD wHotkey);
	HRESULT GetShowCmd(int* piShowCmd);
	HRESULT SetShowCmd(int iShowCmd);
	HRESULT GetIconLocation(LPWSTR pszIconPath, int cch, int* piIcon);
	HRESULT SetIconLocation(LPCWSTR pszIconPath, int iIcon);
	HRESULT SetRelativePath(LPCWSTR pszPathRel, DWORD dwReserved);
	HRESULT Resolve(HWND hwnd, DWORD fFlags);
	HRESULT SetPath(LPCWSTR pszFile);
}

version (Unicode)
{
	alias IShellLinkW IShellLink;
}
else
{
	alias IShellLinkA IShellLink;
}

immutable IID IID_IShellLinkDataList = {0x45e2b4ae, 0xb1c3, 0x11d0, [0xb9, 0x2f, 0x00, 0xa0, 0xc9, 0x03, 0x12, 0xe1]};
interface IShellLinkDataList : IUnknown
{
	HRESULT AddDataBlock(void* pDataBlock);
	HRESULT CopyDataBlock(DWORD dwSig, void** ppDataBlock);
	HRESULT RemoveDataBlock(DWORD dwSig);
	HRESULT GetFlags(DWORD* pdwFlags);
	HRESULT SetFlags(DWORD dwFlags);
}

static if (NTDDI_VERSION >= NTDDI_WIN2K)
{
	immutable IID IID_IResolveShellLink = {0x5cd52983, 0x9449, 0x11d2, [0x96, 0x3a, 0x00, 0xc0, 0x4f, 0x79, 0xad, 0xf0]};
	interface IResolveShellLink : IUnknown
	{
		HRESULT ResolveShellLink(IUnknown punkLink, HWND hwnd, DWORD fFlags);
	}
}

alias DWORD SPINITF;
immutable DWORD SPINITF_NORMAL     = 0;
immutable DWORD SPINITF_MODAL      = 0x1;
immutable DWORD SPINITF_NOMINIMIZE = 0x8;

immutable IID IID_IActionProgressDialog = {0x49ff1172, 0xeadc, 0x446d, [0x92, 0x85, 0x15, 0x64, 0x53, 0xa6, 0x43, 0x1c]};
interface IActionProgressDialog : IUnknown
{
	HRESULT Initialize(SPINITF flags, LPCWSTR pszTitle, LPCWSTR pszCancel);
	HRESULT Stop();
}

immutable IID IID_IHWEventHandler = {0xC1FB73D0, 0xEC3A, 0x4ba2, [0xB5, 0x12, 0x8C, 0xDB, 0x91, 0x87, 0xB6, 0xD1]};
interface IHWEventHandler : IUnknown
{
	HRESULT Initialize(LPCWSTR pszParams);
	HRESULT HandleEvent(LPCWSTR pszDeviceID, LPCWSTR pszAltDeviceID, LPCWSTR pszEventType);
	HRESULT HandleEventWithContent(LPCWSTR pszDeviceID, LPCWSTR pszAltDeviceID, LPCWSTR pszEventType, LPCWSTR pszContentTypeHandler, IDataObject pdataobject);
}

immutable IID IID_IHWEventHandler2 = {0xCFCC809F, 0x295D, 0x42e8, [0x9F, 0xFC, 0x42, 0x4B, 0x33, 0xC4, 0x87, 0xE6]};
interface IHWEventHandler2 : IHWEventHandler
{
	HRESULT HandleEventWithHWND(LPCWSTR pszDeviceID, LPCWSTR pszAltDeviceID, LPCWSTR pszEventType, HWND hwndOwner);
}


immutable DWORD ARCONTENT_AUTORUNINF     = 0x00000002;
immutable DWORD ARCONTENT_AUDIOCD        = 0x00000004;
immutable DWORD ARCONTENT_DVDMOVIE       = 0x00000008;
immutable DWORD ARCONTENT_BLANKCD        = 0x00000010;
immutable DWORD ARCONTENT_BLANKDVD       = 0x00000020;
immutable DWORD ARCONTENT_UNKNOWNCONTENT = 0x00000040;
immutable DWORD ARCONTENT_AUTOPLAYPIX    = 0x00000080;
immutable DWORD ARCONTENT_AUTOPLAYMUSIC  = 0x00000100;
immutable DWORD ARCONTENT_AUTOPLAYVIDEO  = 0x00000200;
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable DWORD ARCONTENT_VCD            = 0x00000400;
	immutable DWORD ARCONTENT_SVCD           = 0x00000800;
	immutable DWORD ARCONTENT_DVDAUDIO       = 0x00001000;
	immutable DWORD ARCONTENT_BLANKBD        = 0x00002000;
	immutable DWORD ARCONTENT_BLURAY         = 0x00004000;
	immutable DWORD ARCONTENT_NONE           = 0x00000000;
	immutable DWORD ARCONTENT_MASK           = 0x00007FFE;
	immutable DWORD ARCONTENT_PHASE_UNKNOWN  = 0x00000000;
	immutable DWORD ARCONTENT_PHASE_PRESNIFF = 0x10000000;
	immutable DWORD ARCONTENT_PHASE_SNIFFING = 0x20000000;
	immutable DWORD ARCONTENT_PHASE_FINAL    = 0x40000000;
	immutable DWORD ARCONTENT_PHASE_MASK     = 0x70000000;
}

immutable IID IID_IQueryCancelAutoPlay = {0xDDEFE873, 0x6997, 0x4e68, [0xBE, 0x26, 0x39, 0xB6, 0x33, 0xAD, 0xBE, 0x12]};
interface IQueryCancelAutoPlay : IUnknown
{
	HRESULT AllowAutoPlay(LPCWSTR pszPath, DWORD dwContentType, LPCWSTR pszLabel, DWORD dwSerialNumber);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_IDynamicHWHandler = {0xDC2601D7, 0x059E, 0x42fc, [0xA0, 0x9D, 0x2A, 0xFD, 0x21, 0xB6, 0xD5, 0xF7]};
	interface IDynamicHWHandler : IUnknown
	{
		HRESULT GetDynamicInfo(LPCWSTR pszDeviceID, DWORD dwContentType, LPWSTR* ppszAction);
	}
}

alias DWORD SPBEGINF;
immutable DWORD SPBEGINF_NORMAL          = 0;
immutable DWORD SPBEGINF_AUTOTIME        = 0x2;
immutable DWORD SPBEGINF_NOPROGRESSBAR   = 0x10;
immutable DWORD SPBEGINF_MARQUEEPROGRESS = 0x20;
immutable DWORD SPBEGINF_NOCANCELBUTTON  = 0x40;

enum SPACTION
{
	SPACTION_NONE,
	SPACTION_MOVING,
	SPACTION_COPYING,
	SPACTION_RECYCLING,
	SPACTION_APPLYINGATTRIBS,
	SPACTION_DOWNLOADING,
	SPACTION_SEARCHING_INTERNET,
	SPACTION_CALCULATING,
	SPACTION_UPLOADING,
	SPACTION_SEARCHING_FILES,
	SPACTION_DELETING,
	SPACTION_RENAMING,
	SPACTION_FORMATTING,
	SPACTION_COPY_MOVING,
}

enum SPTEXT
{
	SPTEXT_ACTIONDESCRIPTION = 1,
	SPTEXT_ACTIONDETAIL,
}

immutable IID IID_IActionProgress = {0x49ff1173, 0xeadc, 0x446d, [0x92, 0x85, 0x15, 0x64, 0x53, 0xa6, 0x43, 0x1c]};
interface IActionProgress : IUnknown
{
	HRESULT Begin(SPACTION action, SPBEGINF flags);
	HRESULT UpdateProgress(ULONGLONG ulCompleted, ULONGLONG ulTotal);
	HRESULT UpdateText(SPTEXT sptext, LPCWSTR pszText, BOOL fMayCompact);
	HRESULT QueryCancel(BOOL* pfCancelled);
	HRESULT ResetCancel();
	HRESULT End();
}

immutable IID IID_IShellExtInit = {0x000214E8, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellExtInit : IUnknown
{
	HRESULT Initialize(PCIDLIST_ABSOLUTE pidlFolder, IDataObject pdtobj,
	HKEY hkeyProgID);
}
alias IShellExtInit LPSHELLEXTINIT;

enum EXPPS : UINT
{
	EXPPS_FILETYPES = 0x1,
}

immutable IID IID_IShellPropSheetExt = {0x000214E9, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IShellPropSheetExt : IUnknown
{
	HRESULT AddPages(LPFNSVADDPROPSHEETPAGE pfnAddPage, LPARAM lParam);
	HRESULT ReplacePage(EXPPS uPageID, LPFNSVADDPROPSHEETPAGE pfnReplaceWith, LPARAM lParam);
}
IShellPropSheetExt LPSHELLPROPSHEETEXT;

immutable IID IID_IRemoteComputer = {0x000214FE, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
interface IRemoteComputer : IUnknown
{
	HRESULT Initialize(LPCWSTR pszMachine, BOOL bEnumerating);
}

immutable IID IID_IQueryContinue = {0x7307055c, 0xb24a, 0x486b, [0x9f, 0x25, 0x16, 0x3e, 0x59, 0x7a, 0x28, 0xa9]};
interface IQueryContinue : IUnknown
{
	HRESULT QueryContinue();
}

immutable IID IID_IObjectWithCancelEvent = {0xF279B885, 0x0AE9, 0x4b85, [0xAC, 0x06, 0xDD, 0xEC, 0xF9, 0x40, 0x89, 0x41]};
interface IObjectWithCancelEvent : IUnknown
{
	HRESULT GetCancelEvent(HANDLE* phEvent);
}

immutable IID IID_IUserNotification = {0xba9711ba, 0x5893, 0x4787, [0xa7, 0xe1, 0x41, 0x27, 0x71, 0x51, 0x55, 0x0b]};
interface IUserNotification : IUnknown
{
	HRESULT SetBalloonInfo(LPCWSTR pszTitle, LPCWSTR pszText, DWORD dwInfoFlags);
	HRESULT SetBalloonRetry(DWORD dwShowTime, DWORD dwInterval, UINT cRetryCount);
	HRESULT SetIconInfo(HICON hIcon, LPCWSTR pszToolTip);
	HRESULT Show(IQueryContinue pqc, DWORD dwContinuePollInterval);
	HRESULT PlaySound(LPCWSTR pszSoundName);
}

immutable IID IID_IUserNotificationCallback = {0x19108294, 0x0441, 0x4AFF, [0x80, 0x13, 0xFA, 0x0A, 0x73, 0x0B, 0x0B, 0xEA]};
interface IUserNotificationCallback : IUnknown
{
	HRESULT OnBalloonUserClick(POINT* pt);
	HRESULT OnLeftClick(POINT* pt);
	HRESULT OnContextMenu(POINT* pt);
}

immutable IID IID_IUserNotification2 = {0x215913CC, 0x57EB, 0x4FAB, [0xAB, 0x5A, 0xE5, 0xFA, 0x7B, 0xEA, 0x2A, 0x6C]};
interface IUserNotification2 : IUnknown
{
	HRESULT SetBalloonInfo(LPCWSTR pszTitle, LPCWSTR pszText, DWORD dwInfoFlags);
	HRESULT SetBalloonRetry(DWORD dwShowTime, DWORD dwInterval, UINT cRetryCount);
	HRESULT SetIconInfo(HICON hIcon, LPCWSTR pszToolTip);
	HRESULT Show(IQueryContinue pqc, DWORD dwContinuePollInterval, IUserNotificationCallback pSink);
	HRESULT PlaySound(LPCWSTR pszSoundName);
}

immutable IID IID_IItemNameLimits = {0x1df0d7f1, 0xb267, 0x4d28, [0x8b, 0x10, 0x12, 0xe2, 0x32, 0x02, 0xa5, 0xc4]};
interface IItemNameLimits : IUnknown
{
	HRESULT GetValidCharacters(LPWSTR* ppwszValidChars, LPWSTR* ppwszInvalidChars);
	HRESULT GetMaxLength(LPCWSTR pszName, int* piMaxNameLen);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_ISearchFolderItemFactory = {0xa0ffbc28, 0x5482, 0x4366, [0xbe, 0x27, 0x3e, 0x81, 0xe7, 0x8e, 0x06, 0xc2]};
	interface ISearchFolderItemFactory : IUnknown
	{
		HRESULT SetDisplayName(LPCWSTR pszDisplayName);
		HRESULT SetFolderTypeID(FOLDERTYPEID ftid);
		HRESULT SetFolderLogicalViewMode(FOLDERLOGICALVIEWMODE flvm);
		HRESULT SetIconSize(int iIconSize);
		HRESULT SetVisibleColumns(UINT cVisibleColumns, PROPERTYKEY* rgKey);
		HRESULT SetSortColumns(UINT cSortColumns, SORTCOLUMN* rgSortColumns);
		HRESULT SetGroupColumn(REFPROPERTYKEY keyGroup);
		HRESULT SetStacks(UINT cStackKeys, PROPERTYKEY* rgStackKeys);
		HRESULT SetScope(IShellItemArray psiaScope);
		HRESULT SetCondition(ICondition pCondition);
		HRESULT GetShellItem(REFIID riid, void** ppv);
		HRESULT GetIDList(PIDLIST_ABSOLUTE* ppidl);
	}
}

static if (_WIN32_IE >= 0x0400)
{
	immutable DWORD IEI_PRIORITY_MAX     = ITSAT_MAX_PRIORITY;
	immutable DWORD IEI_PRIORITY_MIN     = ITSAT_MIN_PRIORITY;
	immutable DWORD IEIT_PRIORITY_NORMAL = ITSAT_DEFAULT_PRIORITY;
	immutable DWORD IEIFLAG_ASYNC        = 0x0001;
	immutable DWORD IEIFLAG_CACHE        = 0x0002;
	immutable DWORD IEIFLAG_ASPECT       = 0x0004;
	immutable DWORD IEIFLAG_OFFLINE      = 0x0008;
	immutable DWORD IEIFLAG_GLEAM        = 0x0010;
	immutable DWORD IEIFLAG_SCREEN       = 0x0020;
	immutable DWORD IEIFLAG_ORIGSIZE     = 0x0040;
	immutable DWORD IEIFLAG_NOSTAMP      = 0x0080;
	immutable DWORD IEIFLAG_NOBORDER     = 0x0100;
	immutable DWORD IEIFLAG_QUALITY      = 0x0200;
	immutable DWORD IEIFLAG_REFRESH      = 0x0400;

	immutable IID IID_IExtractImage = {0xBB2E617C, 0x0920, 0x11d1, [0x9A, 0x0B, 0x00, 0xC0, 0x4F, 0xC2, 0xD6, 0xC1]};
	interface IExtractImage : IUnknown
	{
		HRESULT GetLocation(LPWSTR pszPathBuffer, DWORD cch, DWORD* pdwPriority, const(SIZE)* prgSize, DWORD dwRecClrDepth, DWORD* pdwFlags);
		HRESULT Extract(HBITMAP* phBmpThumbnail);
	}
	alias IExtractImage LPEXTRACTIMAGE;
}

static if (_WIN32_IE >= 0x0500)
{
	immutable IID IID_IExtractImage2 = {0x953BB1EE, 0x93B4, 0x11d1, [0x98, 0xA3, 0x00, 0xC0, 0x4F, 0xB6, 0x87, 0xDA]};
	interface IExtractImage2 : IExtractImage
	{
		HRESULT GetDateStamp(FILETIME* pDateStamp);
	}
	alias IExtractImage2 LPEXTRACTIMAGE2;

	immutable IID IID_IThumbnailHandlerFactory = {0xe35b4b2e, 0x00da, 0x4bc1, [0x9f, 0x13, 0x38, 0xbc, 0x11, 0xf5, 0xd4, 0x17]};
	interface IThumbnailHandlerFactory : IUnknown
	{
		HRESULT GetThumbnailHandler(PCUITEMID_CHILD pidlChild, IBindCtx pbc, REFIID riid, void** ppv);
	}

	immutable IID IID_IParentAndItem = {0xb3a4b685, 0xb685, 0x4805, [0x99, 0xd9, 0x5d, 0xea, 0xd2, 0x87, 0x32, 0x36]};
	interface IParentAndItem : IUnknown
	{
		HRESULT SetParentAndItem(PCIDLIST_ABSOLUTE pidlParent, IShellFolder psf, PCUITEMID_CHILD pidlChild);
		HRESULT GetParentAndItem(PIDLIST_ABSOLUTE* ppidlParent, IShellFolder* ppsf, PITEMID_CHILD* ppidlChild);
	}

	HRESULT IParentAndItem_RemoteGetParentAndItem_Proxy(IParentAndItem This, PIDLIST_ABSOLUTE* ppidlParent, IShellFolder* ppsf, PITEMID_CHILD* ppidlChild);
	void IParentAndItem_RemoteGetParentAndItem_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
}

immutable IID IID_IDockingWindow = {0x012dd920, 0x7b26, 0x11d0, [0x8c, 0xa9, 0x00, 0xa0, 0xc9, 0x2d, 0xbf, 0xe8]};
interface IDockingWindow : IOleWindow
{
	HRESULT ShowDW(BOOL fShow);
	HRESULT CloseDW(DWORD dwReserved);
	HRESULT ResizeBorderDW(LPCRECT prcBorder, IUnknown punkToolbarSite, BOOL fReserved);
}

immutable DWORD DBIM_MINSIZE   = 0x0001;
immutable DWORD DBIM_MAXSIZE   = 0x0002;
immutable DWORD DBIM_INTEGRAL  = 0x0004;
immutable DWORD DBIM_ACTUAL    = 0x0008;
immutable DWORD DBIM_TITLE     = 0x0010;
immutable DWORD DBIM_MODEFLAGS = 0x0020;
immutable DWORD DBIM_BKCOLOR   = 0x0040;

align (8)
struct DESKBANDINFO
{
	DWORD dwMask;
	POINTL ptMinSize;
	POINTL ptMaxSize;
	POINTL ptIntegral;
	POINTL ptActual;
	WCHAR[256] wszTitle;
	DWORD dwModeFlags;
	COLORREF crBkgnd;
}

immutable DWORD DBIMF_NORMAL         = 0x0000;
immutable DWORD DBIMF_FIXED          = 0x0001;
immutable DWORD DBIMF_FIXEDBMP       = 0x0004;
immutable DWORD DBIMF_VARIABLEHEIGHT = 0x0008;
immutable DWORD DBIMF_UNDELETEABLE   = 0x0010;
immutable DWORD DBIMF_DEBOSSED       = 0x0020;
immutable DWORD DBIMF_BKCOLOR        = 0x0040;
immutable DWORD DBIMF_USECHEVRON     = 0x0080;
immutable DWORD DBIMF_BREAK          = 0x0100;
immutable DWORD DBIMF_ADDTOFRONT     = 0x0200;
immutable DWORD DBIMF_TOPALIGN       = 0x0400;
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable DWORD DBIMF_NOGRIPPER     = 0x0800;
	immutable DWORD DBIMF_ALWAYSGRIPPER = 0x1000;
	immutable DWORD DBIMF_NOMARGINS     = 0x2000;
}
immutable DWORD DBIF_VIEWMODE_NORMAL      = 0x0000;
immutable DWORD DBIF_VIEWMODE_VERTICAL    = 0x0001;
immutable DWORD DBIF_VIEWMODE_FLOATING    = 0x0002;
immutable DWORD DBIF_VIEWMODE_TRANSPARENT = 0x0004;

immutable DWORD DBID_BANDINFOCHANGED = 0;
immutable DWORD DBID_SHOWONLY        = 1;
immutable DWORD DBID_MAXIMIZEBAND    = 2;
immutable DWORD DBID_PUSHCHEVRON     = 3;
immutable DWORD DBID_DELAYINIT       = 4;
immutable DWORD DBID_FINISHINIT      = 5;
immutable DWORD DBID_SETWINDOWTHEME  = 6;
immutable DWORD DBID_PERMITAUTOHIDE  = 7;

immutable DWORD DBPC_SELECTFIRST = 0xffffffff;
immutable DWORD DBPC_SELECTLAST  = 0xfffffffe;

immutable IID IID_IDeskBand = {0xEB0FE172, 0x1A3A, 0x11D0, [0x89, 0xB3, 0x00, 0xA0, 0xC9, 0x0A, 0x90, 0xAC]};
alias IID_IDeskBand CGID_DeskBand;
interface IDeskBand : IDockingWindow
{
	HRESULT GetBandInfo(DWORD dwBandID, DWORD dwViewMode, DESKBANDINFO* pdbi);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_IDeskBandInfo = {0x77E425FC, 0xCBF9, 0x4307, [0xBA, 0x6A, 0xBB, 0x57, 0x27, 0x74, 0x56, 0x61]};
	interface IDeskBandInfo : IUnknown
	{
		HRESULT GetDefaultBandWidth(DWORD dwBandID, DWORD dwViewMode, int* pnWidth);
	}

	immutable IID IID_IDeskBand2 = {0x79D16DE4, 0xABEE, 0x4021, [0x8D, 0x9D, 0x91, 0x69, 0xB2, 0x61, 0xD6, 0x57]};
	interface IDeskBand2 : IDeskBand
	{
		HRESULT CanRenderComposited(BOOL* pfCanRenderComposited);
		HRESULT SetCompositionState(BOOL fCompositionEnabled);
		HRESULT GetCompositionState(BOOL* pfCompositionEnabled);
	}
}

immutable IID IID_ITaskbarList = {0x56FDF342, 0xFD6D, 0x11d0, [0x95, 0x8A, 0x00, 0x60, 0x97, 0xC9, 0xA0, 0x90]};
interface ITaskbarList : IUnknown
{
	HRESULT HrInit();
	HRESULT AddTab(HWND hwnd);
	HRESULT DeleteTab(HWND hwnd);
	HRESULT ActivateTab(HWND hwnd);
	HRESULT SetActiveAlt(HWND hwnd);
}

immutable IID IID_ITaskbarList2 = {0x602D4995, 0xB13A, 0x429b, [0xA6, 0x6E, 0x19, 0x35, 0xE4, 0x4F, 0x43, 0x17]};
interface ITaskbarList2 : ITaskbarList
{
	HRESULT MarkFullscreenWindow(HWND hwnd, BOOL fFullscreen);
}

alias IUnknown HIMAGELIST;

alias DWORD THUMBBUTTONFLAGS;
immutable DWORD THBF_ENABLED        = 0;
immutable DWORD THBF_DISABLED       = 0x1;
immutable DWORD THBF_DISMISSONCLICK = 0x2;
immutable DWORD THBF_NOBACKGROUND   = 0x4;
immutable DWORD THBF_HIDDEN         = 0x8;
immutable DWORD THBF_NONINTERACTIVE = 0x10;

alias DWORD THUMBBUTTONMASK;
immutable DWORD THB_BITMAP  = 0x1;
immutable DWORD THB_ICON    = 0x2;
immutable DWORD THB_TOOLTIP = 0x4;
immutable DWORD THB_FLAGS   = 0x8;

align (8)
struct THUMBBUTTON
{
	THUMBBUTTONMASK dwMask;
	UINT iId;
	UINT iBitmap;
	HICON hIcon;
	WCHAR[260] szTip;
	THUMBBUTTONFLAGS dwFlags;
}
alias THUMBBUTTON* LPTHUMBBUTTON;

immutable DWORD THBN_CLICKED = 0x1800;

alias DWORD TBPFLAG;
immutable DWORD TBPF_NOPROGRESS    = 0;
immutable DWORD TBPF_INDETERMINATE = 0x1;
immutable DWORD TBPF_NORMAL        = 0x2;
immutable DWORD TBPF_ERROR         = 0x4;
immutable DWORD TBPF_PAUSED        = 0x8;

immutable IID IID_ITaskbarList3 = {0xea1afb91, 0x9e28, 0x4b86, [0x90, 0xe9, 0x9e, 0x9f, 0x8a, 0x5e, 0xef, 0xaf]};
interface ITaskbarList3 : ITaskbarList2
{
	HRESULT SetProgressValue(HWND hwnd, ULONGLONG ullCompleted, ULONGLONG ullTotal);
	HRESULT SetProgressState(HWND hwnd, TBPFLAG tbpFlags);
	HRESULT RegisterTab(HWND hwndTab, HWND hwndMDI);
	HRESULT UnregisterTab(HWND hwndTab);
	HRESULT SetTabOrder(HWND hwndTab, HWND hwndInsertBefore);
	HRESULT SetTabActive(HWND hwndTab, HWND hwndMDI, DWORD dwReserved);
	HRESULT ThumbBarAddButtons(HWND hwnd, UINT cButtons, LPTHUMBBUTTON pButton);
	HRESULT ThumbBarUpdateButtons(HWND hwnd, UINT cButtons, LPTHUMBBUTTON pButton);
	HRESULT ThumbBarSetImageList(HWND hwnd, HIMAGELIST himl);
	HRESULT SetOverlayIcon(HWND hwnd, HICON hIcon, LPCWSTR pszDescription);
	HRESULT SetThumbnailTooltip(HWND hwnd, LPCWSTR pszTip);
	HRESULT SetThumbnailClip(HWND hwnd, RECT* prcClip);
}

alias DWORD STPFLAG;
immutable DWORD STPF_NONE                      = 0;
immutable DWORD STPF_USEAPPTHUMBNAILALWAYS     = 0x1;
immutable DWORD STPF_USEAPPTHUMBNAILWHENACTIVE = 0x2;
immutable DWORD STPF_USEAPPPEEKALWAYS          = 0x4;
immutable DWORD STPF_USEAPPPEEKWHENACTIVE      = 0x8;

immutable IID IID_ITaskbarList4 = {0xc43dc798, 0x95d1, 0x4bea, [0x90, 0x30, 0xbb, 0x99, 0xe2, 0x98, 0x3a, 0x1a]};
interface ITaskbarList4 : ITaskbarList3
{
	HRESULT SetTabProperties(HWND hwndTab, STPFLAG stpFlags);
}

immutable IID IID_IStartMenuPinnedList = {0x4CD19ADA, 0x25A5, 0x4A32, [0xB3, 0xB7, 0x34, 0x7B, 0xEE, 0x5B, 0xE3, 0x6B]};
interface IStartMenuPinnedList : IUnknown
{
	HRESULT RemoveFromList(IShellItem pitem);
}

immutable IID IID_ICDBurn = {0x3d73a659, 0xe5d0, 0x4d42, [0xaf, 0xc0, 0x51, 0x21, 0xba, 0x42, 0x5c, 0x8d]};
interface ICDBurn : IUnknown
{
	HRESULT GetRecorderDriveLetter(LPWSTR pszDrive, UINT cch);
	HRESULT Burn(HWND hwnd);
	HRESULT HasRecordableDrive(BOOL* pfHasRecorder);
}

immutable ushort IDD_WIZEXTN_FIRST = 0x5000;
immutable ushort IDD_WIZEXTN_LAST  = 0x5100;

immutable IID IID_IWizardSite = {0x88960f5b, 0x422f, 0x4e7b, [0x80, 0x13, 0x73, 0x41, 0x53, 0x81, 0xc3, 0xc3]};
alias IID_IWizardSite SID_WizardSite;
interface IWizardSite : IUnknown
{
	HRESULT GetPreviousPage(HPROPSHEETPAGE* phpage);
	HRESULT GetNextPage(HPROPSHEETPAGE* phpage);
	HRESULT GetCancelledPage(HPROPSHEETPAGE* phpage);
}

immutable IID IID_IWizardExtension = {0xc02ea696, 0x86cc, 0x491e, [0x9b, 0x23, 0x74, 0x39, 0x4a, 0x04, 0x44, 0xa8]};
interface IWizardExtension : IUnknown
{
	HRESULT AddPages(HPROPSHEETPAGE* aPages, UINT cPages, UINT* pnPagesAdded);
	HRESULT GetFirstPage(HPROPSHEETPAGE* phpage);
	HRESULT GetLastPage(HPROPSHEETPAGE* phpage);
}

immutable IID IID_IWebWizardExtension = {0x0e6b3f66, 0x98d1, 0x48c0, [0xa2, 0x22, 0xfb, 0xde, 0x74, 0xe2, 0xfb, 0xc5]};
alias IID_IWebWizardExtension SID_WebWizardHost;
interface IWebWizardExtension : IWizardExtension
{
	HRESULT SetInitialURL(LPCWSTR pszURL);
	HRESULT SetErrorURL(LPCWSTR pszErrorURL);
}

immutable DWORD SHPWHF_NORECOMPRESS     = 0x00000001;
immutable DWORD SHPWHF_NONETPLACECREATE = 0x00000002;
immutable DWORD SHPWHF_NOFILESELECTOR   = 0x00000004;
immutable DWORD SHPWHF_USEMRU           = 0x00000008;
static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable DWORD SHPWHF_ANYLOCATION = 0x00000100;
}
immutable DWORD SHPWHF_VALIDATEVIAWEBFOLDERS = 0x00010000;
/+ IXMLDOMDocument not defined
immutable IID IID_IPublishingWizard = {0xaa9198bb, 0xccec, 0x472d, [0xbe, 0xed, 0x19, 0xa4, 0xf6, 0x73, 0x3f, 0x7a]};
interface IPublishingWizard : IWizardExtension
{
	HRESULT Initialize(IDataObject pdo, DWORD dwOptions, LPCWSTR pszServiceScope);
	HRESULT GetTransferManifest(HRESULT* phrFromTransfer, IXMLDOMDocument* pdocManifest);
}
+/

static if (NTDDI_VERSION >= NTDDI_WINXP || _WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IFolderViewHost = {0x1ea58f02, 0xd55a, 0x411d, [0xb0, 0x9e, 0x9e, 0x65, 0xac, 0x21, 0x60, 0x5b]};
	interface IFolderViewHost : IUnknown
	{
		HRESULT Initialize(HWND hwndParent, IDataObject pdo, RECT* prc);
	}

	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable IID IID_IExplorerBrowserEvents = {0x361bbdc7, 0xe6ee, 0x4e13, [0xbe, 0x58, 0x58, 0xe2, 0x24, 0x0c, 0x81, 0x0f]};
		interface IExplorerBrowserEvents : IUnknown
		{
			HRESULT OnNavigationPending(PCIDLIST_ABSOLUTE pidlFolder);
			HRESULT OnViewCreated(IShellView psv);
			HRESULT OnNavigationComplete(PCIDLIST_ABSOLUTE pidlFolder);
			HRESULT OnNavigationFailed(PCIDLIST_ABSOLUTE pidlFolder);
		}

		alias DWORD EXPLORER_BROWSER_OPTIONS;
		immutable DWORD EBO_NONE               = 0;
		immutable DWORD EBO_NAVIGATEONCE       = 0x1;
		immutable DWORD EBO_SHOWFRAMES         = 0x2;
		immutable DWORD EBO_ALWAYSNAVIGATE     = 0x4;
		immutable DWORD EBO_NOTRAVELLOG        = 0x8;
		immutable DWORD EBO_NOWRAPPERWINDOW    = 0x10;
		immutable DWORD EBO_HTMLSHAREPOINTVIEW = 0x20;

		alias DWORD EXPLORER_BROWSER_FILL_FLAGS;
		immutable DWORD EBF_NONE                 = 0;
		immutable DWORD EBF_SELECTFROMDATAOBJECT = 0x100;
		immutable DWORD EBF_NODROPTARGET         = 0x200;

		immutable IID IID_IExplorerBrowser = {0xdfd3b6b5, 0xc10c, 0x4be9, [0x85, 0xf6, 0xa6, 0x69, 0x69, 0xf4, 0x02, 0xf6]};
		interface IExplorerBrowser : IUnknown
		{
			HRESULT Initialize(HWND hwndParent, const(RECT)* prc, const(FOLDERSETTINGS)* pfs);
			HRESULT Destroy();
			HRESULT SetRect(HDWP* phdwp, RECT rcBrowser);
			HRESULT SetPropertyBag(LPCWSTR pszPropertyBag);
			HRESULT SetEmptyText(LPCWSTR pszEmptyText);
			HRESULT SetFolderSettings(const(FOLDERSETTINGS)* pfs);
			HRESULT Advise(IExplorerBrowserEvents psbe, DWORD* pdwCookie);
			HRESULT Unadvise(DWORD dwCookie);
			HRESULT SetOptions(EXPLORER_BROWSER_OPTIONS dwFlag);
			HRESULT GetOptions(EXPLORER_BROWSER_OPTIONS* pdwFlag);
			HRESULT BrowseToIDList(PCUIDLIST_RELATIVE pidl, UINT uFlags);
			HRESULT BrowseToObject(IUnknown punk, UINT uFlags);
			HRESULT FillFromObject(IUnknown punk, EXPLORER_BROWSER_FILL_FLAGS dwFlags);
			HRESULT RemoveAll();
			HRESULT GetCurrentView(REFIID riid, void** ppv);
		}

		immutable IID IID_IAccessibleObject = {0x95A391C5, 0x9ED4, 0x4c28, [0x84, 0x01, 0xAB, 0x9E, 0x06, 0x71, 0x9E, 0x11]};
		interface IAccessibleObject : IUnknown
		{
			HRESULT SetAccessibleName(LPCWSTR pszName);
		}
	}

	immutable IID IID_IResultsFolder = {0x96E5AE6D, 0x6AE1, 0x4b1c, [0x90, 0x0C, 0xC6, 0x48, 0x0E, 0xAA, 0x88, 0x28]};
	interface IResultsFolder : IUnknown
	{
		HRESULT AddItem(IShellItem psi);
		HRESULT AddIDList(PCIDLIST_ABSOLUTE pidl, PITEMID_CHILD* ppidlAdded);
		HRESULT RemoveItem(IShellItem psi);
		HRESULT RemoveIDList(PCIDLIST_ABSOLUTE pidl);
		HRESULT RemoveAll();
	}

	HRESULT IResultsFolder_RemoteAddIDList_Proxy(IResultsFolder This, PCIDLIST_ABSOLUTE pidl, PITEMID_CHILD* ppidlAdded);
	void IResultsFolder_RemoteAddIDList_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable IID IID_IEnumObjects = {0x2c1c7e2e, 0x2d0e, 0x4059, [0x83, 0x1e, 0x1e, 0x6f, 0x82, 0x33, 0x5c, 0x2e]};
		interface IEnumObjects : IUnknown
		{
			HRESULT Next(ULONG celt, REFIID riid, void** rgelt, ULONG* pceltFetched);
			HRESULT Skip(ULONG celt);
			HRESULT Reset();
			HRESULT Clone(IEnumObjects* ppenum);
		}

		HRESULT IEnumObjects_RemoteNext_Proxy(IEnumObjects This, ULONG celt, REFIID riid, void** rgelt, ULONG* pceltFetched);
		void IEnumObjects_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

		alias DWORD OPPROGDLGF;
		immutable DWORD OPPROGDLG_DEFAULT               = 0;
		immutable DWORD OPPROGDLG_ENABLEPAUSE           = 0x80;
		immutable DWORD OPPROGDLG_ALLOWUNDO             = 0x100;
		immutable DWORD OPPROGDLG_DONTDISPLAYSOURCEPATH = 0x200;
		immutable DWORD OPPROGDLG_DONTDISPLAYDESTPATH   = 0x400;
		immutable DWORD OPPROGDLG_NOMULTIDAYESTIMATES   = 0x800;
		immutable DWORD OPPROGDLG_DONTDISPLAYLOCATIONS  = 0x1000;

		alias DWORD PDMODE;
		immutable DWORD PDM_DEFAULT        = 0;
		immutable DWORD PDM_RUN            = 0x1;
		immutable DWORD PDM_PREFLIGHT      = 0x2;
		immutable DWORD PDM_UNDOING        = 0x4;
		immutable DWORD PDM_ERRORSBLOCKING = 0x8;
		immutable DWORD PDM_INDETERMINATE  = 0x10;

		enum PDOPSTATUS
		{
			PDOPS_RUNNING = 1,
			PDOPS_PAUSED,
			PDOPS_CANCELLED,
			PDOPS_STOPPED,
			PDOPS_ERRORS,
		}

		immutable IID IID_IOperationsProgressDialog = {0x0C9FB851, 0xE5C9, 0x43EB, [0xA3, 0x70, 0xF0, 0x67, 0x7B, 0x13, 0x87, 0x4C]};
		interface IOperationsProgressDialog : IUnknown
		{
			HRESULT StartProgressDialog(HWND hwndOwner, OPPROGDLGF flags);
			HRESULT StopProgressDialog();
			HRESULT SetOperation(SPACTION action);
			HRESULT SetMode(PDMODE mode);
			HRESULT UpdateProgress(ULONGLONG ullPointsCurrent, ULONGLONG ullPointsTotal, ULONGLONG ullSizeCurrent, ULONGLONG ullSizeTotal, ULONGLONG ullItemsCurrent, ULONGLONG ullItemsTotal);
			HRESULT UpdateLocations(IShellItem psiSource, IShellItem psiTarget, IShellItem psiItem);
			HRESULT ResetTimer();
			HRESULT PauseTimer();
			HRESULT ResumeTimer();
			HRESULT GetMilliseconds(ULONGLONG* pullElapsed, ULONGLONG* pullRemaining);
			HRESULT GetOperationStatus(PDOPSTATUS* popstatus);
		}

		immutable IID IID_IIOCancelInformation = {0xf5b0bf81, 0x8cb5, 0x4b1b, [0x94, 0x49, 0x1a, 0x15, 0x9e, 0x0c, 0x73, 0x3c]};
		interface IIOCancelInformation : IUnknown
		{
			HRESULT SetCancelInformation(DWORD dwThreadID, UINT uMsgCancel);
			HRESULT GetCancelInformation(DWORD* pdwThreadID, UINT* puMsgCancel);
		}

		immutable DWORD FOFX_NOSKIPJUNCTIONS        = 0x00010000;
		immutable DWORD FOFX_PREFERHARDLINK         = 0x00020000;
		immutable DWORD FOFX_SHOWELEVATIONPROMPT    = 0x00040000;
		immutable DWORD FOFX_EARLYFAILURE           = 0x00100000;
		immutable DWORD FOFX_PRESERVEFILEEXTENSIONS = 0x00200000;
		immutable DWORD FOFX_KEEPNEWERFILE          = 0x00400000;
		immutable DWORD FOFX_NOCOPYHOOKS            = 0x00800000;
		immutable DWORD FOFX_NOMINIMIZEBOX          = 0x01000000;
		immutable DWORD FOFX_MOVEACLSACROSSVOLUMES  = 0x02000000;
		immutable DWORD FOFX_DONTDISPLAYSOURCEPATH  = 0x04000000;
		immutable DWORD FOFX_DONTDISPLAYDESTPATH    = 0x08000000;
		immutable DWORD FOFX_REQUIREELEVATION       = 0x10000000;
		immutable DWORD FOFX_COPYASDOWNLOAD         = 0x40000000;
		immutable DWORD FOFX_DONTDISPLAYLOCATIONS   = 0x80000000;

		immutable IID IID_IFileOperation = {0x947aab5f, 0x0a5c, 0x4c13, [0xb4, 0xd6, 0x4b, 0xf7, 0x83, 0x6f, 0xc9, 0xf8]};
		interface IFileOperation : IUnknown
		{
			HRESULT Advise(IFileOperationProgressSink pfops, DWORD* pdwCookie);
			HRESULT Unadvise(DWORD dwCookie);
			HRESULT SetOperationFlags(DWORD dwOperationFlags);
			HRESULT SetProgressMessage(LPCWSTR pszMessage);
			HRESULT SetProgressDialog(IOperationsProgressDialog popd);
			HRESULT SetProperties(IPropertyChangeArray pproparray);
			HRESULT SetOwnerWindow(HWND hwndOwner);
			HRESULT ApplyPropertiesToItem(IShellItem psiItem);
			HRESULT ApplyPropertiesToItems(IUnknown punkItems);
			HRESULT RenameItem(IShellItem psiItem, LPCWSTR pszNewName, IFileOperationProgressSink pfopsItem);
			HRESULT RenameItems(IUnknown pUnkItems, LPCWSTR pszNewName);
			HRESULT MoveItem(IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszNewName, IFileOperationProgressSink pfopsItem);
			HRESULT MoveItems(IUnknown punkItems, IShellItem psiDestinationFolder);
			HRESULT CopyItem(IShellItem psiItem, IShellItem psiDestinationFolder, LPCWSTR pszCopyName, IFileOperationProgressSink pfopsItem);
			HRESULT CopyItems(IUnknown punkItems, IShellItem psiDestinationFolder);
			HRESULT DeleteItem(IShellItem psiItem, IFileOperationProgressSink pfopsItem);
			HRESULT DeleteItems(IUnknown punkItems);
			HRESULT NewItem(IShellItem psiDestinationFolder, DWORD dwFileAttributes, LPCWSTR pszName, LPCWSTR pszTemplateName, IFileOperationProgressSink pfopsItem);
			HRESULT PerformOperations();
			HRESULT GetAnyOperationsAborted(BOOL* pfAnyOperationsAborted);
		}

		immutable IID IID_IObjectProvider = {0xa6087428, 0x3be3, 0x4d73, [0xb3, 0x08, 0x7c, 0x04, 0xa5, 0x40, 0xbf, 0x1a]};
		interface IObjectProvider : IUnknown
		{
			HRESULT QueryObject(REFGUID guidObject, REFIID riid, void** ppvOut);
		}
	}

	immutable IID IID_INamespaceWalkCB = {0xd92995f8, 0xcf5e, 0x4a76, [0xbf, 0x59, 0xea, 0xd3, 0x9e, 0xa2, 0xb9, 0x7e]};
	interface INamespaceWalkCB : IUnknown
	{
		HRESULT FoundItem(IShellFolder psf, PCUITEMID_CHILD pidl);
		HRESULT EnterFolder(IShellFolder psf, PCUITEMID_CHILD pidl);
		HRESULT LeaveFolder(IShellFolder psf, PCUITEMID_CHILD pidl);
		HRESULT InitializeProgressDialog(LPWSTR* ppszTitle, LPWSTR* ppszCancel);
	}


	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable IID IID_INamespaceWalkCB2 = {0x7ac7492b, 0xc38e, 0x438a, [0x87, 0xdb, 0x68, 0x73, 0x78, 0x44, 0xff, 0x70]};
		interface INamespaceWalkCB2 : INamespaceWalkCB
		{
			HRESULT WalkComplete(HRESULT hr);
		}
	}

	alias DWORD NAMESPACEWALKFLAG;
	immutable DWORD NSWF_DEFAULT                        = 0;
	immutable DWORD NSWF_NONE_IMPLIES_ALL               = 0x1;
	immutable DWORD NSWF_ONE_IMPLIES_ALL                = 0x2;
	immutable DWORD NSWF_DONT_TRAVERSE_LINKS            = 0x4;
	immutable DWORD NSWF_DONT_ACCUMULATE_RESULT         = 0x8;
	immutable DWORD NSWF_TRAVERSE_STREAM_JUNCTIONS      = 0x10;
	immutable DWORD NSWF_FILESYSTEM_ONLY                = 0x20;
	immutable DWORD NSWF_SHOW_PROGRESS                  = 0x40;
	immutable DWORD NSWF_FLAG_VIEWORDER                 = 0x80;
	immutable DWORD NSWF_IGNORE_AUTOPLAY_HIDA           = 0x100;
	immutable DWORD NSWF_ASYNC                          = 0x200;
	immutable DWORD NSWF_DONT_RESOLVE_LINKS             = 0x400;
	immutable DWORD NSWF_ACCUMULATE_FOLDERS             = 0x800;
	immutable DWORD NSWF_DONT_SORT                      = 0x1000;
	immutable DWORD NSWF_USE_TRANSFER_MEDIUM            = 0x2000;
	immutable DWORD NSWF_DONT_TRAVERSE_STREAM_JUNCTIONS = 0x4000;

	immutable IID IID_INamespaceWalk = {0x57ced8a7, 0x3f4a, 0x432c, [0x93, 0x50, 0x30, 0xf2, 0x44, 0x83, 0xf7, 0x4f]};
	interface INamespaceWalk : IUnknown
	{
		HRESULT Walk(IUnknown punkToWalk, DWORD dwFlags, int cDepth, INamespaceWalkCB pnswcb);
		HRESULT GetIDArrayResult(UINT* pcItems, PIDLIST_ABSOLUTE** prgpidl);
	}
}

void FreeIDListArray(PIDLIST_RELATIVE* ppidls, UINT cItems)
{
	for (UINT i = 0; i < cItems; ++i)
 		CoTaskMemFree(ppidls[i]);
	CoTaskMemFree(ppidls);
}

void FreeIDListArrayFull(PIDLIST_ABSOLUTE* ppidls, UINT cItems)
{
	for (UINT i = 0; i < cItems; ++i)
 		CoTaskMemFree(ppidls[i]);
	CoTaskMemFree(ppidls);
}

void FreeIDListArrayChild(PITEMID_CHILD* ppidls, UINT cItems)
{
	for (UINT i = 0; i < cItems; ++i)
 		CoTaskMemFree(ppidls[i]);
	CoTaskMemFree(ppidls);
}

immutable DWORD ACDD_VISIBLE = 0x0001;

immutable IID IID_IAutoCompleteDropDown = {0x3CD141F4, 0x3C6A, 0x11d2, [0xBC, 0xAA, 0x00, 0xC0, 0x4F, 0xD9, 0x29, 0xDB]};
interface IAutoCompleteDropDown : IUnknown
{
	HRESULT GetDropDownStatus(DWORD* pdwFlags, LPWSTR* ppwszString);
	HRESULT ResetEnumerator();
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	HRESULT SHRemovePersonalPropertyValues(IShellItemArray psia);
	HRESULT SHAddDefaultPropertiesByExt(PCWSTR pszExt, IPropertyStore pPropStore);
	HRESULT SHCreateDefaultPropertiesOp(IShellItem psi, IFileOperation* ppFileOp);
	HRESULT SHSetDefaultProperties(HWND hwnd, IShellItem psi, DWORD dwFileOpFlags, IFileOperationProgressSink pfops);
}

static if (_WIN32_IE >= _WIN32_IE_IE40)
{
	align (8)
	struct BANDSITEINFO
	{
		DWORD dwMask;
		DWORD dwState;
		DWORD dwStyle;
	}

	immutable UINT BSID_BANDADDED   = 0;
	immutable UINT BSID_BANDREMOVED = 1;

	immutable DWORD BSIM_STATE             = 0x00000001;
	immutable DWORD BSIM_STYLE             = 0x00000002;
	immutable DWORD BSSF_VISIBLE           = 0x00000001;
	immutable DWORD BSSF_NOTITLE           = 0x00000002;
	immutable DWORD BSSF_UNDELETEABLE      = 0x00001000;
	immutable DWORD BSIS_AUTOGRIPPER       = 0x00000000;
	immutable DWORD BSIS_NOGRIPPER         = 0x00000001;
	immutable DWORD BSIS_ALWAYSGRIPPER     = 0x00000002;
	immutable DWORD BSIS_LEFTALIGN         = 0x00000004;
	immutable DWORD BSIS_SINGLECLICK       = 0x00000008;
	immutable DWORD BSIS_NOCONTEXTMENU     = 0x00000010;
	immutable DWORD BSIS_NODROPTARGET      = 0x00000020;
	immutable DWORD BSIS_NOCAPTION         = 0x00000040;
	immutable DWORD BSIS_PREFERNOLINEBREAK = 0x00000080;
	immutable DWORD BSIS_LOCKED            = 0x00000100;
	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable DWORD BSIS_PRESERVEORDERDURINGLAYOUT = 0x00000200;
		immutable DWORD BSIS_FIXEDORDER                = 0x00000400;
	}

	immutable IID IID_IBandSite = {0x4CF504B0, 0xDE96, 0x11D0, [0x8B, 0x3F, 0x00, 0xA0, 0xC9, 0x11, 0xE8, 0xE5]};
	alias IID_IBandSite SID_SBandSite;
	alias IID_IBandSite CGID_BandSite;
	interface IBandSite : IUnknown
	{
		HRESULT AddBand(IUnknown punk);
		HRESULT EnumBands(UINT uBand, DWORD* pdwBandID);
		HRESULT QueryBand(DWORD dwBandID, IDeskBand* ppstb, DWORD* pdwState, LPWSTR pszName, int cchName);
		HRESULT SetBandState(DWORD dwBandID, DWORD dwMask, DWORD dwState);
		HRESULT RemoveBand(DWORD dwBandID);
		HRESULT GetBandObject(DWORD dwBandID, REFIID riid, void** ppv);
		HRESULT SetBandSiteInfo(const(BANDSITEINFO)* pbsinfo);
		HRESULT GetBandSiteInfo(BANDSITEINFO* pbsinfo);
	}

	HRESULT IBandSite_RemoteQueryBand_Proxy(IBandSite This, DWORD dwBandID, IDeskBand* ppstb, DWORD* pdwState, LPWSTR pszName, int cchName);
	void IBandSite_RemoteQueryBand_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);
}

static if (NTDDI_VERSION >= NTDDI_WINXP)
{
	immutable IID IID_IModalWindow = {0xb4db1657, 0x70d7, 0x485e, [0x8e, 0x3e, 0x6f, 0xcb, 0x5a, 0x5c, 0x18, 0x02]};
	interface IModalWindow : IUnknown
	{
		HRESULT Show(HWND hwndOwner);
	}

	HRESULT IModalWindow_RemoteShow_Proxy(IModalWindow This, HWND hwndOwner);
	void IModalWindow_RemoteShow_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

	immutable wchar* PROPSTR_EXTENSIONCOMPLETIONSTATE = "ExtensionCompletionState\0"w.ptr;

	immutable DWORD CDBE_RET_DEFAULT          = 0;
	immutable DWORD CDBE_RET_DONTRUNOTHEREXTS = 0x1;
	immutable DWORD CDBE_RET_STOPWIZARD       = 0x2;

	alias DWORD CDBE_ACTIONS;
	immutable DWORD CDBE_TYPE_MUSIC = 0x1;
	immutable DWORD CDBE_TYPE_DATA  = 0x2;
	immutable DWORD CDBE_TYPE_ALL   = 0xffffffff;

	immutable IID IID_ICDBurnExt = {0x2271dcca, 0x74fc, 0x4414, [0x8f, 0xb7, 0xc5, 0x6b, 0x05, 0xac, 0xe2, 0xd7]};
	alias IID_ICDBurnExt SID_CDWizardHost;
	interface ICDBurnExt : IUnknown
	{
		HRESULT GetSupportedActionTypes(CDBE_ACTIONS* pdwActions);
	}
}

immutable IID IID_IContextMenuSite = {0x0811AEBE, 0x0B87, 0x4C54, [0x9E, 0x72, 0x54, 0x8C, 0xF6, 0x49, 0x01, 0x6B]};
interface IContextMenuSite : IUnknown
{
	HRESULT DoContextMenuPopup(IUnknown punkContextMenu, UINT fFlags, POINT pt);
}

immutable IID IID_IEnumReadyCallback = {0x61E00D45, 0x8FFF, 0x4e60, [0x92, 0x4E, 0x65, 0x37, 0xB6, 0x16, 0x12, 0xDD]};
interface IEnumReadyCallback : IUnknown
{
	HRESULT EnumReady();
}

immutable IID IID_IEnumerableView = {0x8C8BF236, 0x1AEC, 0x495f, [0x98, 0x94, 0x91, 0xD5, 0x7C, 0x3C, 0x68, 0x6F]};
alias IID_IEnumerableView SID_EnumerableView;
interface IEnumerableView : IUnknown
{
	HRESULT SetEnumReadyCallback(IEnumReadyCallback percb);
	HRESULT CreateEnumIDListFromContents(PCIDLIST_ABSOLUTE pidlFolder,  DWORD dwEnumFlags, IEnumIDList* ppEnumIDList);
}

static if (NTDDI_VERSION >= NTDDI_WINXP || _WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IInsertItem = {0xD2B57227, 0x3D23, 0x4b95, [0x93, 0xC0, 0x49, 0x2B, 0xD4, 0x54, 0xC3, 0x56]};
	interface IInsertItem : IUnknown
	{
		HRESULT InsertItem(PCUIDLIST_RELATIVE pidl);
	}

	static if (NTDDI_VERSION >= NTDDI_WINXP)
	{
		immutable DWORD MBHANDCID_PIDLSELECT = 0;

		immutable IID IID_IMenuBand = {0x568804CD, 0xCBD7, 0x11d0, [0x98, 0x16, 0x00, 0xC0, 0x4F, 0xD9, 0x19, 0x72]};
		interface IMenuBand : IUnknown
		{
			HRESULT IsMenuMessage(MSG* pmsg);
			HRESULT TranslateMenuMessage(MSG* pmsg, LRESULT* plRet);
		}

		immutable IID IID_IFolderBandPriv = {0x47c01f95, 0xe185, 0x412c, [0xb5, 0xc5, 0x4f, 0x27, 0xdf, 0x96, 0x5a, 0xea]};
		interface IFolderBandPriv : IUnknown
		{
			HRESULT SetCascade(BOOL fCascade);
			HRESULT SetAccelerators(BOOL fAccelerators);
			HRESULT SetNoIcons(BOOL fNoIcons);
			HRESULT SetNoText(BOOL fNoText);
		}

		immutable IID IID_IRegTreeItem = {0xA9521922, 0x0812, 0x4d44, [0x9E, 0xC3, 0x7F, 0xD3, 0x8C, 0x72, 0x6F, 0x3D]};
		interface IRegTreeItem : IUnknown
		{
			HRESULT GetCheckState(BOOL* pbCheck);
			HRESULT SetCheckState(BOOL bCheck);
		}

		immutable IID IID_IImageRecompress = {0x505f1513, 0x6b3e, 0x4892, [0xa2, 0x72, 0x59, 0xf8, 0x88, 0x9a, 0x4d, 0x3e]};
		interface IImageRecompress : IUnknown
		{
			HRESULT RecompressImage(IShellItem psi, int cx, int cy, int iQuality, IStorage pstg, IStream* ppstrmOut);
		}
	}
}

static if (_WIN32_IE >= _WIN32_IE_IE60)
{
	immutable IID IID_IDeskBar = {0xEB0FE173, 0x1A3A, 0x11D0, [0x89, 0xB3, 0x00, 0xA0, 0xC9, 0x0A, 0x90, 0xAC]};
	interface IDeskBar : IOleWindow
	{
		HRESULT SetClient(IUnknown punkClient);
		HRESULT GetClient(IUnknown* ppunkClient);
		HRESULT OnPosRectChangeDB(RECT* prc);
	}

	immutable DWORD MPOS_EXECUTE       = 0;
	immutable DWORD MPOS_FULLCANCEL    = 1;
	immutable DWORD MPOS_CANCELLEVEL   = 2;
	immutable DWORD MPOS_SELECTLEFT    = 3;
	immutable DWORD MPOS_SELECTRIGHT   = 4;
	immutable DWORD MPOS_CHILDTRACKING = 5;

	alias DWORD MP_POPUPFLAGS;
	immutable DWORD MPPF_SETFOCUS      = 0x1;
	immutable DWORD MPPF_INITIALSELECT = 0x2;
	immutable DWORD MPPF_NOANIMATE     = 0x4;
	immutable DWORD MPPF_KEYBOARD      = 0x10;
	immutable DWORD MPPF_REPOSITION    = 0x20;
	immutable DWORD MPPF_FORCEZORDER   = 0x40;
	immutable DWORD MPPF_FINALSELECT   = 0x80;
	immutable DWORD MPPF_TOP           = 0x20000000;
	immutable DWORD MPPF_LEFT          = 0x40000000;
	immutable DWORD MPPF_RIGHT         = 0x60000000;
	immutable DWORD MPPF_BOTTOM        = 0x80000000;
	immutable DWORD MPPF_POS_MASK      = 0xe0000000;
	immutable DWORD MPPF_ALIGN_LEFT    = 0x2000000;
	immutable DWORD MPPF_ALIGN_RIGHT   = 0x4000000;

	immutable IID IID_IMenuPopup = {0xD1E7AFEB, 0x6A2E, 0x11d0, [0x8C, 0x78, 0x00, 0xC0, 0x4F, 0xD9, 0x18, 0xB4]};
	interface IMenuPopup : IDeskBar
	{
		HRESULT Popup(POINTL* ppt, RECTL* prcExclude, MP_POPUPFLAGS dwFlags);
		HRESULT OnSelect(DWORD dwSelectType);
		HRESULT SetSubMenu(IMenuPopup pmp, BOOL fSet);
	}
}

static if (_WIN32_IE >= _WIN32_IE_IE70)
{
	immutable IID IID_IInitializeWithBindCtx = {0x71c0d2bc, 0x726d, 0x45cc, [0xa6, 0xc0, 0x2e, 0x31, 0xc1, 0xdb, 0x21, 0x59]};
	interface IInitializeWithBindCtx : IUnknown
	{
		HRESULT Initialize(IBindCtx pbc);
	}

	immutable IID IID_IShellItemFilter = {0x2659B475, 0xEEB8, 0x48b7, [0x8F, 0x07, 0xB3, 0x78, 0x81, 0x0F, 0x48, 0xCF]};
	interface IShellItemFilter : IUnknown
	{
		HRESULT IncludeItem(IShellItem psi);
		HRESULT GetEnumFlagsForItem(IShellItem psi, SHCONTF* pgrfFlags);
	}
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	enum FILE_USAGE_TYPE
	{
		FUT_PLAYING,
		FUT_EDITING,
		FUT_GENERIC,
	}

	immutable DWORD OF_CAP_CANSWITCHTO = 0x0001;
	immutable DWORD OF_CAP_CANCLOSE    = 0x0002;

	immutable IID IID_IFileIsInUse = {0x64a1cbf0, 0x3a1a, 0x4461, [0x91, 0x58, 0x37, 0x69, 0x69, 0x69, 0x39, 0x50]};
	interface IFileIsInUse : IUnknown
	{
		HRESULT GetAppName(LPWSTR* ppszName);
		HRESULT GetUsage(FILE_USAGE_TYPE* pfut);
		HRESULT GetCapabilities(DWORD* pdwCapFlags);
		HRESULT GetSwitchToHWND(HWND* phwnd);
		HRESULT CloseFile();
	}

	enum FDE_OVERWRITE_RESPONSE
	{
		FDEOR_DEFAULT,
		FDEOR_ACCEPT,
		FDEOR_REFUSE,
	}

	enum FDE_SHAREVIOLATION_RESPONSE
	{
		FDESVR_DEFAULT,
		FDESVR_ACCEPT,
		FDESVR_REFUSE,
	}

	enum FDAP
	{
		FDAP_BOTTOM,
		FDAP_TOP,
	}

	immutable IID IID_IFileDialogEvents = {0x973510db, 0x7d7f, 0x452b, [0x89, 0x75, 0x74, 0xa8, 0x58, 0x28, 0xd3, 0x54]};
	interface IFileDialogEvents : IUnknown
	{
		HRESULT OnFileOk(IFileDialog pfd);
		HRESULT OnFolderChanging(IFileDialog pfd, IShellItem psiFolder);
		HRESULT OnFolderChange(IFileDialog pfd);
		HRESULT OnSelectionChange(IFileDialog pfd);
		HRESULT OnShareViolation(IFileDialog pfd, IShellItem psi, FDE_SHAREVIOLATION_RESPONSE* pResponse);
		HRESULT OnTypeChange(IFileDialog pfd);
		HRESULT OnOverwrite(IFileDialog pfd, IShellItem psi, FDE_OVERWRITE_RESPONSE* pResponse);
	}

	alias DWORD FILEOPENDIALOGOPTIONS;
	immutable DWORD FOS_OVERWRITEPROMPT    = 0x2;
	immutable DWORD FOS_STRICTFILETYPES    = 0x4;
	immutable DWORD FOS_NOCHANGEDIR        = 0x8;
	immutable DWORD FOS_PICKFOLDERS        = 0x20;
	immutable DWORD FOS_FORCEFILESYSTEM    = 0x40;
	immutable DWORD FOS_ALLNONSTORAGEITEMS = 0x80;
	immutable DWORD FOS_NOVALIDATE         = 0x100;
	immutable DWORD FOS_ALLOWMULTISELECT   = 0x200;
	immutable DWORD FOS_PATHMUSTEXIST      = 0x800;
	immutable DWORD FOS_FILEMUSTEXIST      = 0x1000;
	immutable DWORD FOS_CREATEPROMPT       = 0x2000;
	immutable DWORD FOS_SHAREAWARE         = 0x4000;
	immutable DWORD FOS_NOREADONLYRETURN   = 0x8000;
	immutable DWORD FOS_NOTESTFILECREATE   = 0x10000;
	immutable DWORD FOS_HIDEMRUPLACES      = 0x20000;
	immutable DWORD FOS_HIDEPINNEDPLACES   = 0x40000;
	immutable DWORD FOS_NODEREFERENCELINKS = 0x100000;
	immutable DWORD FOS_DONTADDTORECENT    = 0x2000000;
	immutable DWORD FOS_FORCESHOWHIDDEN    = 0x10000000;
	immutable DWORD FOS_DEFAULTNOMINIMODE  = 0x20000000;
	immutable DWORD FOS_FORCEPREVIEWPANEON = 0x40000000;

	immutable IID IID_IFileDialog = {0x42f85136, 0xdb7e, 0x439c, [0x85, 0xf1, 0xe4, 0x07, 0x5d, 0x13, 0x5f, 0xc8]};
	interface IFileDialog : IModalWindow
	{
		HRESULT SetFileTypes(UINT cFileTypes, const(COMDLG_FILTERSPEC)* rgFilterSpec);
		HRESULT SetFileTypeIndex(UINT iFileType);
		HRESULT GetFileTypeIndex(UINT* piFileType);
		HRESULT Advise(IFileDialogEvents pfde, DWORD* pdwCookie);
		HRESULT Unadvise(DWORD dwCookie);
		HRESULT SetOptions(FILEOPENDIALOGOPTIONS fos);
		HRESULT GetOptions(FILEOPENDIALOGOPTIONS* pfos);
		HRESULT SetDefaultFolder(IShellItem psi);
		HRESULT SetFolder(IShellItem psi);
		HRESULT GetFolder(IShellItem* ppsi);
		HRESULT GetCurrentSelection(IShellItem* ppsi);
		HRESULT SetFileName(LPCWSTR pszName);
		HRESULT GetFileName(LPWSTR* pszName);
		HRESULT SetTitle(LPCWSTR pszTitle);
		HRESULT SetOkButtonLabel(LPCWSTR pszText);
		HRESULT SetFileNameLabel(LPCWSTR pszLabel);
		HRESULT GetResult(IShellItem* ppsi);
		HRESULT AddPlace(IShellItem psi, FDAP fdap);
		HRESULT SetDefaultExtension(LPCWSTR pszDefaultExtension);
		HRESULT Close(HRESULT hr);
		HRESULT SetClientGuid(REFGUID guid);
		HRESULT ClearClientData();
		HRESULT SetFilter(IShellItemFilter pFilter);
	}

	immutable IID IID_IFileSaveDialog = {0x84bccd23, 0x5fde, 0x4cdb, [0xae, 0xa4, 0xaf, 0x64, 0xb8, 0x3d, 0x78, 0xab]};
	interface IFileSaveDialog : IFileDialog
	{
		HRESULT SetSaveAsItem(IShellItem psi);
		HRESULT SetProperties(IPropertyStore pStore);
		HRESULT SetCollectedProperties(IPropertyDescriptionList pList, BOOL fAppendDefault);
		HRESULT GetProperties(IPropertyStore* ppStore);
		HRESULT ApplyProperties(IShellItem psi, IPropertyStore pStore, HWND hwnd, IFileOperationProgressSink pSink);
	}

	immutable IID IID_IFileOpenDialog = {0xd57c7288, 0xd4ad, 0x4768, [0xbe, 0x02, 0x9d, 0x96, 0x95, 0x32, 0xd9, 0x60]};
	interface IFileOpenDialog : IFileDialog
	{
		HRESULT GetResults(IShellItemArray* ppenum);
		HRESULT GetSelectedItems(IShellItemArray* ppsai);
	}

	alias DWORD CDCONTROLSTATEF;
	immutable DWORD CDCS_INACTIVE       = 0;
	immutable DWORD CDCS_ENABLED        = 0x1;
	immutable DWORD CDCS_VISIBLE        = 0x2;
	immutable DWORD CDCS_ENABLEDVISIBLE = 0x3;

	immutable IID IID_IFileDialogCustomize = {0xe6fdd21a, 0x163f, 0x4975, [0x9c, 0x8c, 0xa6, 0x9f, 0x1b, 0xa3, 0x70, 0x34]};
	interface IFileDialogCustomize : IUnknown
	{
		HRESULT EnableOpenDropDown(DWORD dwIDCtl);
		HRESULT AddMenu(DWORD dwIDCtl, LPCWSTR pszLabel);
		HRESULT AddPushButton(DWORD dwIDCtl, LPCWSTR pszLabel);
		HRESULT AddComboBox(DWORD dwIDCtl);
		HRESULT AddRadioButtonList(DWORD dwIDCtl);
		HRESULT AddCheckButton(DWORD dwIDCtl, LPCWSTR pszLabel, BOOL bChecked);
		HRESULT AddEditBox(DWORD dwIDCtl, LPCWSTR pszText);
		HRESULT AddSeparator(DWORD dwIDCtl);
		HRESULT AddText(DWORD dwIDCtl, LPCWSTR pszText);
		HRESULT SetControlLabel(DWORD dwIDCtl, LPCWSTR pszLabel);
		HRESULT GetControlState(DWORD dwIDCtl, CDCONTROLSTATEF* pdwState);
		HRESULT SetControlState(DWORD dwIDCtl, CDCONTROLSTATEF dwState);
		HRESULT GetEditBoxText(DWORD dwIDCtl, WCHAR** ppszText);
		HRESULT SetEditBoxText(DWORD dwIDCtl, LPCWSTR pszText);
		HRESULT GetCheckButtonState(DWORD dwIDCtl, BOOL* pbChecked);
		HRESULT SetCheckButtonState(DWORD dwIDCtl, BOOL bChecked);
		HRESULT AddControlItem(DWORD dwIDCtl, DWORD dwIDItem, LPCWSTR pszLabel);
		HRESULT RemoveControlItem(DWORD dwIDCtl, DWORD dwIDItem);
		HRESULT RemoveAllControlItems(DWORD dwIDCtl);
		HRESULT GetControlItemState(DWORD dwIDCtl, DWORD dwIDItem, CDCONTROLSTATEF* pdwState);
		HRESULT SetControlItemState(DWORD dwIDCtl, DWORD dwIDItem, CDCONTROLSTATEF dwState);
		HRESULT GetSelectedControlItem(DWORD dwIDCtl, DWORD* pdwIDItem);
		HRESULT SetSelectedControlItem(DWORD dwIDCtl, DWORD dwIDItem);
		HRESULT StartVisualGroup(DWORD dwIDCtl, LPCWSTR pszLabel);
		HRESULT EndVisualGroup();
		HRESULT MakeProminent(DWORD dwIDCtl);
		HRESULT SetControlItemText(DWORD dwIDCtl, DWORD dwIDItem, LPCWSTR pszLabel);
	}

	immutable IID IID_IFileDialogControlEvents = {0x36116642, 0xD713, 0x4b97, [0x9B, 0x83, 0x74, 0x84, 0xA9, 0xD0, 0x04, 0x33]};
	interface IFileDialogControlEvents : IUnknown
	{
		HRESULT OnItemSelected(IFileDialogCustomize pfdc, DWORD dwIDCtl, DWORD dwIDItem);
		HRESULT OnButtonClicked(IFileDialogCustomize pfdc, DWORD dwIDCtl);
		HRESULT OnCheckButtonToggled(IFileDialogCustomize pfdc, DWORD dwIDCtl, BOOL bChecked);
		HRESULT OnControlActivating(IFileDialogCustomize pfdc, DWORD dwIDCtl);
	}

	immutable IID IID_IFileDialog2 = {0x61744fc7, 0x85b5, 0x4791, [0xa9, 0xb0, 0x27, 0x22, 0x76, 0x30, 0x9b, 0x13]};
	interface IFileDialog2 : IFileDialog
	{
		HRESULT SetCancelButtonLabel(LPCWSTR pszLabel);
		HRESULT SetNavigationRoot(IShellItem psi);
	}

	enum ASSOCIATIONLEVEL
	{
		AL_MACHINE,
		AL_EFFECTIVE,
		AL_USER,
	}

	enum ASSOCIATIONTYPE
	{
		AT_FILEEXTENSION,
		AT_URLPROTOCOL,
		AT_STARTMENUCLIENT,
		AT_MIMETYPE,
	}

	immutable IID IID_IApplicationAssociationRegistration = {0x4e530b0a, 0xe611, 0x4c77, [0xa3, 0xac, 0x90, 0x31, 0xd0, 0x22, 0x28, 0x1b]};
	interface IApplicationAssociationRegistration : IUnknown
	{
		HRESULT QueryCurrentDefault(LPCWSTR pszQuery, ASSOCIATIONTYPE atQueryType, ASSOCIATIONLEVEL alQueryLevel, LPWSTR* ppszAssociation);
		HRESULT QueryAppIsDefault(LPCWSTR pszQuery, ASSOCIATIONTYPE atQueryType, ASSOCIATIONLEVEL alQueryLevel, LPCWSTR pszAppRegistryName, BOOL* pfDefault);
		HRESULT QueryAppIsDefaultAll(ASSOCIATIONLEVEL alQueryLevel, LPCWSTR pszAppRegistryName, BOOL* pfDefault);
		HRESULT SetAppAsDefault(LPCWSTR pszAppRegistryName, LPCWSTR pszSet, ASSOCIATIONTYPE atSetType);
		HRESULT SetAppAsDefaultAll(LPCWSTR pszAppRegistryName);
		HRESULT ClearUserAssociations();
	}

	HRESULT SHCreateAssociationRegistration(REFIID riid, void** ppv);

	immutable IID IID_IApplicationAssociationRegistrationUI = {0x1f76a169, 0xf994, 0x40ac, [0x8f, 0xc8, 0x09, 0x59, 0xe8, 0x87, 0x47, 0x10]};
	interface IApplicationAssociationRegistrationUI : IUnknown
	{
		HRESULT LaunchAdvancedAssociationUI(LPCWSTR pszAppRegistryName);
	}
}


align (1)
struct DELEGATEITEMID
{
	WORD cbSize;
	WORD wOuter;
	WORD cbInner;
	BYTE[1] rgb;
}
alias const(DELEGATEITEMID)* PCDELEGATEITEMID;
alias DELEGATEITEMID* PDELEGATEITEMID;

immutable IID IID_IDelegateFolder = {0xADD8BA80, 0x002B, 0x11D0, [0x8F, 0x0F, 0x00, 0xC0, 0x4F, 0xD7, 0xD0, 0x62]};
interface IDelegateFolder : IUnknown
{
	HRESULT SetItemAlloc(IMalloc pmalloc);
}

static if (_WIN32_IE >= _WIN32_IE_IE60)
{
	alias DWORD BROWSERFRAMEOPTIONS;
	immutable DWORD BFO_NONE                             = 0;
	immutable DWORD BFO_BROWSER_PERSIST_SETTINGS         = 0x1;
	immutable DWORD BFO_RENAME_FOLDER_OPTIONS_TOINTERNET = 0x2;
	immutable DWORD BFO_BOTH_OPTIONS                     = 0x4;
	immutable DWORD BIF_PREFER_INTERNET_SHORTCUT         = 0x8;
	immutable DWORD BFO_BROWSE_NO_IN_NEW_PROCESS         = 0x10;
	immutable DWORD BFO_ENABLE_HYPERLINK_TRACKING        = 0x20;
	immutable DWORD BFO_USE_IE_OFFLINE_SUPPORT           = 0x40;
	immutable DWORD BFO_SUBSTITUE_INTERNET_START_PAGE    = 0x80;
	immutable DWORD BFO_USE_IE_LOGOBANDING               = 0x100;
	immutable DWORD BFO_ADD_IE_TOCAPTIONBAR              = 0x200;
	immutable DWORD BFO_USE_DIALUP_REF                   = 0x400;
	immutable DWORD BFO_USE_IE_TOOLBAR                   = 0x800;
	immutable DWORD BFO_NO_PARENT_FOLDER_SUPPORT         = 0x1000;
	immutable DWORD BFO_NO_REOPEN_NEXT_RESTART           = 0x2000;
	immutable DWORD BFO_GO_HOME_PAGE                     = 0x4000;
	immutable DWORD BFO_PREFER_IEPROCESS                 = 0x8000;
	immutable DWORD BFO_SHOW_NAVIGATION_CANCELLED        = 0x10000;
	immutable DWORD BFO_USE_IE_STATUSBAR                 = 0x20000;
	immutable DWORD BFO_QUERY_ALL                        = 0xffffffff;

	immutable IID IID_IBrowserFrameOptions = {0x10DF43C8, 0x1DBE, 0x11d3, [0x8B, 0x34, 0x00, 0x60, 0x97, 0xDF, 0x5B, 0xD4]};
	interface IBrowserFrameOptions : IUnknown
	{
		HRESULT GetFrameOptions(BROWSERFRAMEOPTIONS dwMask, BROWSERFRAMEOPTIONS* pdwOptions);
	}
	alias IBrowserFrameOptions LPBROWSERFRAMEOPTIONS;
}

static if (_WIN32_IE >= _WIN32_IE_IE60SP2)
{
	alias DWORD NWMF;
	immutable DWORD NWMF_UNLOADING       = 0x1;
	immutable DWORD NWMF_USERINITED      = 0x2;
	immutable DWORD NWMF_FIRST           = 0x4;
	immutable DWORD NWMF_OVERRIDEKEY     = 0x8;
	immutable DWORD NWMF_SHOWHELP        = 0x10;
	immutable DWORD NWMF_HTMLDIALOG      = 0x20;
	immutable DWORD NWMF_FROMDIALOGCHILD = 0x40;
	immutable DWORD NWMF_USERREQUESTED   = 0x80;
	immutable DWORD NWMF_USERALLOWED     = 0x100;
	immutable DWORD NWMF_FORCEWINDOW     = 0x10000;
	immutable DWORD NWMF_FORCETAB        = 0x20000;
	immutable DWORD NWMF_SUGGESTWINDOW   = 0x40000;
	immutable DWORD NWMF_SUGGESTTAB      = 0x80000;
	immutable DWORD NWMF_INACTIVETAB     = 0x100000;

	immutable IID IID_INewWindowManager = {0xD2BC4C84, 0x3F72, 0x4a52, [0xA6, 0x04, 0x7B, 0xCB, 0xF3, 0x98, 0x2C, 0xBB]};
	alias IID_INewWindowManager SID_SNewWindowManager;
	interface INewWindowManager : IUnknown
	{
		HRESULT EvaluateNewWindow(LPCWSTR pszUrl, LPCWSTR pszName, LPCWSTR pszUrlContext, LPCWSTR pszFeatures, BOOL fReplace, DWORD dwFlags, DWORD dwUserActionTime);
	}

	enum ATTACHMENT_PROMPT
	{
		ATTACHMENT_PROMPT_NONE,
		ATTACHMENT_PROMPT_SAVE,
		ATTACHMENT_PROMPT_EXEC,
		ATTACHMENT_PROMPT_EXEC_OR_SAVE,
	}

	enum ATTACHMENT_ACTION
	{
		ATTACHMENT_ACTION_CANCEL,
		ATTACHMENT_ACTION_SAVE,
		ATTACHMENT_ACTION_EXEC,
	}

	immutable IID IID_IAttachmentExecute = {0x73db1241, 0x1e85, 0x4581, [0x8e, 0x4f, 0xa8, 0x1e, 0x1d, 0x0f, 0x8c, 0x57]};
	interface IAttachmentExecute : IUnknown
	{
		HRESULT SetClientTitle(LPCWSTR pszTitle);
		HRESULT SetClientGuid(REFGUID guid);
		HRESULT SetLocalPath(LPCWSTR pszLocalPath);
		HRESULT SetFileName(LPCWSTR pszFileName);
		HRESULT SetSource(LPCWSTR pszSource);
		HRESULT SetReferrer(LPCWSTR pszReferrer);
		HRESULT CheckPolicy();
		HRESULT Prompt(HWND hwnd, ATTACHMENT_PROMPT prompt, ATTACHMENT_ACTION* paction);
		HRESULT Save();
		HRESULT Execute(HWND hwnd, LPCWSTR pszVerb, HANDLE* phProcess);
		HRESULT SaveWithUI(HWND hwnd);
		HRESULT ClearClientState();
	}
}

static if (_WIN32_IE >= _WIN32_IE_IE60)
{
	align (8)
	struct SMDATA
	{
		DWORD dwMask;
		DWORD dwFlags;
		HMENU hmenu;
		HWND hwnd;
		UINT uId;
		UINT uIdParent;
		UINT uIdAncestor;
		IUnknown punk;
		PIDLIST_ABSOLUTE pidlFolder;
		PUITEMID_CHILD pidlItem;
		IShellFolder psf;
		void* pvUserData;
	}
	alias SMDATA* LPSMDATA;

	immutable DWORD SMDM_SHELLFOLDER = 0x00000001;
	immutable DWORD SMDM_HMENU       = 0x00000002;
	immutable DWORD SMDM_TOOLBAR     = 0x00000004;

	align (8)
	struct SMINFO
	{
		DWORD dwMask;
		DWORD dwType;
		DWORD dwFlags;
		int iIcon;
	}
	alias SMINFO* PSMINFO;

	align (8)
	struct SMCSHCHANGENOTIFYSTRUCT
	{
		int lEvent;
		PCIDLIST_ABSOLUTE pidl1;
		PCIDLIST_ABSOLUTE pidl2;
	}
	alias SMCSHCHANGENOTIFYSTRUCT* PSMCSHCHANGENOTIFYSTRUCT;

	immutable DWORD SMIM_TYPE  = 0x1;
	immutable DWORD SMIM_FLAGS = 0x2;
	immutable DWORD SMIM_ICON  = 0x4;

	immutable DWORD SMIT_SEPARATOR = 0x1;
	immutable DWORD SMIT_STRING    = 0x2;

	immutable DWORD SMIF_ICON        = 0x1;
	immutable DWORD SMIF_ACCELERATOR = 0x2;
	immutable DWORD SMIF_DROPTARGET  = 0x4;
	immutable DWORD SMIF_SUBMENU     = 0x8;
	immutable DWORD SMIF_CHECKED     = 0x20;
	immutable DWORD SMIF_DROPCASCADE = 0x40;
	immutable DWORD SMIF_HIDDEN      = 0x80;
	immutable DWORD SMIF_DISABLED    = 0x100;
	immutable DWORD SMIF_TRACKPOPUP  = 0x200;
	immutable DWORD SMIF_DEMOTED     = 0x400;
	immutable DWORD SMIF_ALTSTATE    = 0x800;
	immutable DWORD SMIF_DRAGNDROP   = 0x1000;
	immutable DWORD SMIF_NEW         = 0x2000;

	immutable DWORD SMC_INITMENU          = 0x00000001;
	immutable DWORD SMC_CREATE            = 0x00000002;
	immutable DWORD SMC_EXITMENU          = 0x00000003;
	immutable DWORD SMC_GETINFO           = 0x00000005;
	immutable DWORD SMC_GETSFINFO         = 0x00000006;
	immutable DWORD SMC_GETOBJECT         = 0x00000007;
	immutable DWORD SMC_GETSFOBJECT       = 0x00000008;
	immutable DWORD SMC_SFEXEC            = 0x00000009;
	immutable DWORD SMC_SFSELECTITEM      = 0x0000000A;
	immutable DWORD SMC_REFRESH           = 0x00000010;
	immutable DWORD SMC_DEMOTE            = 0x00000011;
	immutable DWORD SMC_PROMOTE           = 0x00000012;
	immutable DWORD SMC_DEFAULTICON       = 0x00000016;
	immutable DWORD SMC_NEWITEM           = 0x00000017;
	immutable DWORD SMC_CHEVRONEXPAND     = 0x00000019;
	immutable DWORD SMC_DISPLAYCHEVRONTIP = 0x0000002A;
	immutable DWORD SMC_SETSFOBJECT       = 0x0000002D;
	immutable DWORD SMC_SHCHANGENOTIFY    = 0x0000002E;
	immutable DWORD SMC_CHEVRONGETTIP     = 0x0000002F;
	immutable DWORD SMC_SFDDRESTRICTED    = 0x00000030;
	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable DWORD SMC_SFEXEC_MIDDLE          = 0x00000031;
		immutable DWORD SMC_GETAUTOEXPANDSTATE     = 0x00000041;
		immutable DWORD SMC_AUTOEXPANDCHANGE       = 0x00000042;
		immutable DWORD SMC_GETCONTEXTMENUMODIFIER = 0x00000043;
		immutable DWORD SMC_GETBKCONTEXTMENU       = 0x00000044;
		immutable DWORD SMC_OPEN                   = 0x00000045;
		immutable DWORD SMAE_EXPANDED              = 0x00000001;
		immutable DWORD SMAE_CONTRACTED            = 0x00000002;
		immutable DWORD SMAE_USER                  = 0x00000004;
		immutable DWORD SMAE_VALID                 = 0x00000007;
	}

	immutable IID IID_IShellMenuCallback = {0x4CA300A1, 0x9B8D, 0x11d1, [0x8B, 0x22, 0x00, 0xC0, 0x4F, 0xD9, 0x18, 0xD0]};
	interface IShellMenuCallback : IUnknown
	{
		HRESULT CallbackSM(LPSMDATA psmd, UINT uMsg, WPARAM wParam, LPARAM lParam);
	}

	immutable DWORD SMINIT_DEFAULT           = 0x00000000;
	immutable DWORD SMINIT_RESTRICT_DRAGDROP = 0x00000002;
	immutable DWORD SMINIT_TOPLEVEL          = 0x00000004;
	immutable DWORD SMINIT_CACHED            = 0x00000010;
	static if (_WIN32_IE >= _WIN32_IE_IE70)
	{
		immutable DWORD SMINIT_AUTOEXPAND      = 0x00000100;
		immutable DWORD SMINIT_AUTOTOOLTIP     = 0x00000200;
		immutable DWORD SMINIT_DROPONCONTAINER = 0x00000400;
	}
	immutable DWORD SMINIT_VERTICAL   = 0x10000000;
	immutable DWORD SMINIT_HORIZONTAL = 0x20000000;
	immutable DWORD ANCESTORDEFAULT   = 0xffffffff;
	immutable DWORD SMSET_TOP         = 0x10000000;
	immutable DWORD SMSET_BOTTOM      = 0x20000000;
	immutable DWORD SMSET_DONTOWN     = 0x00000001;
	immutable DWORD SMINV_REFRESH     = 0x00000001;
	immutable DWORD SMINV_ID          = 0x00000008;

	immutable IID IID_IShellMenu = {0xEE1F7637, 0xE138, 0x11d1, [0x83, 0x79, 0x00, 0xC0, 0x4F, 0xD9, 0x18, 0xD0]};
	interface IShellMenu : IUnknown
	{
		HRESULT Initialize(IShellMenuCallback psmc, UINT uId, UINT uIdAncestor, DWORD dwFlags);
		HRESULT GetMenuInfo(IShellMenuCallback* ppsmc, UINT* puId, UINT* puIdAncestor, DWORD* pdwFlags);
		HRESULT SetShellFolder(IShellFolder psf, PCIDLIST_ABSOLUTE pidlFolder, HKEY hKey, DWORD dwFlags);
		HRESULT GetShellFolder(DWORD* pdwFlags, PIDLIST_ABSOLUTE* ppidl, REFIID riid, void** ppv);
		HRESULT SetMenu(HMENU hmenu, HWND hwnd, DWORD dwFlags);
		HRESULT GetMenu(HMENU* phmenu, HWND* phwnd, DWORD* pdwFlags);
		HRESULT InvalidateItem(LPSMDATA psmd, DWORD dwFlags);
		HRESULT GetState(LPSMDATA psmd);
		HRESULT SetMenuToolbar(IUnknown punk, DWORD dwFlags);
	}
}

immutable IID IID_IShellRunDll = {0xfce4bde0, 0x4b68, 0x4b80, [0x8e, 0x9c, 0x74, 0x26, 0x31, 0x5a, 0x73, 0x88]};
interface IShellRunDll : IUnknown
{
	HRESULT Run(LPCWSTR pszArgs);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	enum KF_CATEGORY
	{
		KF_CATEGORY_VIRTUAL = 1,
		KF_CATEGORY_FIXED,
		KF_CATEGORY_COMMON,
		KF_CATEGORY_PERUSER,
	}

	alias DWORD KF_DEFINITION_FLAGS;
	immutable DWORD KFDF_LOCAL_REDIRECT_ONLY = 0x2;
	immutable DWORD KFDF_ROAMABLE            = 0x4;
	immutable DWORD KFDF_PRECREATE           = 0x8;
	immutable DWORD KFDF_STREAM              = 0x10;
	immutable DWORD KFDF_PUBLISHEXPANDEDPATH = 0x20;

	alias DWORD KF_REDIRECT_FLAGS;
	immutable DWORD KF_REDIRECT_USER_EXCLUSIVE               = 0x1;
	immutable DWORD KF_REDIRECT_COPY_SOURCE_DACL             = 0x2;
	immutable DWORD KF_REDIRECT_OWNER_USER                   = 0x4;
	immutable DWORD KF_REDIRECT_SET_OWNER_EXPLICIT           = 0x8;
	immutable DWORD KF_REDIRECT_CHECK_ONLY                   = 0x10;
	immutable DWORD KF_REDIRECT_WITH_UI                      = 0x20;
	immutable DWORD KF_REDIRECT_UNPIN                        = 0x40;
	immutable DWORD KF_REDIRECT_PIN                          = 0x80;
	immutable DWORD KF_REDIRECT_COPY_CONTENTS                = 0x200;
	immutable DWORD KF_REDIRECT_DEL_SOURCE_CONTENTS          = 0x400;
	immutable DWORD KF_REDIRECT_EXCLUDE_ALL_KNOWN_SUBFOLDERS = 0x800;

	alias DWORD KF_REDIRECTION_CAPABILITIES;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_ALLOW_ALL              = 0xff;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_REDIRECTABLE           = 0x1;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_DENY_ALL               = 0xfff00;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_DENY_POLICY_REDIRECTED = 0x100;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_DENY_POLICY            = 0x200;
	immutable DWORD KF_REDIRECTION_CAPABILITIES_DENY_PERMISSIONS       = 0x400;

	struct KNOWNFOLDER_DEFINITION
	{
		KF_CATEGORY category;
		LPWSTR pszName;
		LPWSTR pszDescription;
		KNOWNFOLDERID fidParent;
		LPWSTR pszRelativePath;
		LPWSTR pszParsingName;
		LPWSTR pszTooltip;
		LPWSTR pszLocalizedName;
		LPWSTR pszIcon;
		LPWSTR pszSecurity;
		DWORD dwAttributes;
		KF_DEFINITION_FLAGS kfdFlags;
		FOLDERTYPEID ftidType;
	}

	immutable IID IID_IKnownFolder = {0x3AA7AF7E, 0x9B36, 0x420c, [0xA8, 0xE3, 0xF7, 0x7D, 0x46, 0x74, 0xA4, 0x88]};
	interface IKnownFolder : IUnknown
	{
		HRESULT GetId(KNOWNFOLDERID* pkfid);
		HRESULT GetCategory(KF_CATEGORY* pCategory);
		HRESULT GetShellItem(DWORD dwFlags, REFIID riid, void** ppv);
		HRESULT GetPath(DWORD dwFlags, LPWSTR* ppszPath);
		HRESULT SetPath(DWORD dwFlags, LPCWSTR pszPath);
		HRESULT GetIDList(DWORD dwFlags, PIDLIST_ABSOLUTE* ppidl);
		HRESULT GetFolderType(FOLDERTYPEID* pftid);
		HRESULT GetRedirectionCapabilities(KF_REDIRECTION_CAPABILITIES* pCapabilities);
		HRESULT GetFolderDefinition(KNOWNFOLDER_DEFINITION* pKFD);
	}

	enum FFFP_MODE
	{
		FFFP_EXACTMATCH,
		FFFP_NEARESTPARENTMATCH,
	}

	immutable IID IID_IKnownFolderManager = {0x8BE2D872, 0x86AA, 0x4d47, [0xB7, 0x76, 0x32, 0xCC, 0xA4, 0x0C, 0x70, 0x18]};
	interface IKnownFolderManager : IUnknown
	{
		HRESULT FolderIdFromCsidl(int nCsidl, KNOWNFOLDERID* pfid);
		HRESULT FolderIdToCsidl(REFKNOWNFOLDERID rfid, int* pnCsidl);
		HRESULT GetFolderIds(KNOWNFOLDERID** ppKFId, UINT* pCount);
		HRESULT GetFolder(REFKNOWNFOLDERID rfid, IKnownFolder* ppkf);
		HRESULT GetFolderByName(LPCWSTR pszCanonicalName, IKnownFolder* ppkf);
		HRESULT RegisterFolder(REFKNOWNFOLDERID rfid, const(KNOWNFOLDER_DEFINITION)* pKFD);
		HRESULT UnregisterFolder(REFKNOWNFOLDERID rfid);
		HRESULT FindFolderFromPath(LPCWSTR pszPath, FFFP_MODE mode, IKnownFolder* ppkf);
		HRESULT FindFolderFromIDList(PCIDLIST_ABSOLUTE pidl, IKnownFolder* ppkf);
		HRESULT Redirect(REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags, LPCWSTR pszTargetPath, UINT cFolders, const(KNOWNFOLDERID)* pExclusion, LPWSTR* ppszError);
	}

	HRESULT IKnownFolderManager_RemoteRedirect_Proxy(IKnownFolderManager This, REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags, LPCWSTR pszTargetPath, UINT cFolders, const(GUID)* pExclusion, LPWSTR* ppszError);
	void IKnownFolderManager_RemoteRedirect_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

	void FreeKnownFolderDefinitionFields(KNOWNFOLDER_DEFINITION* pKFD)
	{
		CoTaskMemFree(pKFD.pszName);
		CoTaskMemFree(pKFD.pszDescription);
		CoTaskMemFree(pKFD.pszRelativePath);
		CoTaskMemFree(pKFD.pszParsingName);
		CoTaskMemFree(pKFD.pszTooltip);
		CoTaskMemFree(pKFD.pszLocalizedName);
		CoTaskMemFree(pKFD.pszIcon);
		CoTaskMemFree(pKFD.pszSecurity);
	}

	enum SHARE_ROLE
	{
		SHARE_ROLE_INVALID     = -1,
		SHARE_ROLE_READER      = 0,
		SHARE_ROLE_CONTRIBUTOR = 1,
		SHARE_ROLE_CO_OWNER    = 2,
		SHARE_ROLE_OWNER       = 3,
		SHARE_ROLE_CUSTOM      = 4,
		SHARE_ROLE_MIXED       = 5
	}

	enum DEF_SHARE_ID
	{
		DEFSHAREID_USERS  = 1,
		DEFSHAREID_PUBLIC = 2,
	}

	immutable IID IID_ISharingConfigurationManager = {0xB4CD448A, 0x9C86, 0x4466, [0x92, 0x01, 0x2E, 0x62, 0x10, 0x5B, 0x87, 0xAE]};
	interface ISharingConfigurationManager : IUnknown
	{
		HRESULT CreateShare(DEF_SHARE_ID dsid, SHARE_ROLE role);
		HRESULT DeleteShare(DEF_SHARE_ID dsid);
		HRESULT ShareExists(DEF_SHARE_ID dsid);
		HRESULT GetSharePermissions(DEF_SHARE_ID dsid, SHARE_ROLE* pRole);
		HRESULT SharePrinters();
		HRESULT StopSharingPrinters();
		HRESULT ArePrintersShared();
	}
}

immutable IID IID_IPreviousVersionsInfo = {0x76e54780, 0xad74, 0x48e3, [0xa6, 0x95, 0x3b, 0xa9, 0xa0, 0xaf, 0xf1, 0x0d]};
interface IPreviousVersionsInfo : IUnknown
{
	HRESULT AreSnapshotsAvailable(LPCWSTR pszPath, BOOL fOkToBeSlow, BOOL* pfAvailable);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_IRelatedItem = {0xa73ce67a, 0x8ab1, 0x44f1, [0x8d, 0x43, 0xd2, 0xfc, 0xbf, 0x6b, 0x1c, 0xd0]};
	interface IRelatedItem : IUnknown
	{
		HRESULT GetItemIDList(PIDLIST_ABSOLUTE* ppidl);
		HRESULT GetItem(IShellItem* ppsi);
	}

	immutable IID IID_IIdentityName = {0x7d903fca, 0xd6f9, 0x4810, [0x83, 0x32, 0x94, 0x6c, 0x01, 0x77, 0xe2, 0x47]};
	interface  IIdentityName : IRelatedItem
	{
	}

	immutable IID IID_IDelegateItem = {0x3c5a1c94, 0xc951, 0x4cb7, [0xbb, 0x6d, 0x3b, 0x93, 0xf3, 0x0c, 0xce, 0x93]};
	interface IDelegateItem : IRelatedItem
	{
	}

	immutable IID IID_ICurrentItem = {0x240a7174, 0xd653, 0x4a1d, [0xa6, 0xd3, 0xd4, 0x94, 0x3c, 0xfb, 0xfe, 0x3d]};
	interface ICurrentItem : IRelatedItem
	{
	}

	immutable IID IID_ITransferMediumItem = {0x77f295d5, 0x2d6f, 0x4e19, [0xb8, 0xae, 0x32, 0x2f, 0x3e, 0x72, 0x1a, 0xb5]};
	interface ITransferMediumItem : IRelatedItem
	{
	}

	immutable IID IID_IUseToBrowseItem = {0x05edda5c, 0x98a3, 0x4717, [0x8a, 0xdb, 0xc5, 0xe7, 0xda, 0x99, 0x1e, 0xb1]};
	interface IUseToBrowseItem : IRelatedItem
	{
	}

	immutable IID IID_IDisplayItem = {0xc6fd5997, 0x9f6b, 0x4888, [0x87, 0x03, 0x94, 0xe8, 0x0e, 0x8c, 0xde, 0x3f]};
	interface IDisplayItem : IRelatedItem
	{
	}

	immutable IID IID_IViewStateIdentityItem = {0x9D264146, 0xA94F, 0x4195, [0x9F, 0x9F, 0x3B, 0xB1, 0x2C, 0xE0, 0xC9, 0x55]};
	interface IViewStateIdentityItem : IRelatedItem
	{
	}

	immutable IID IID_IPreviewItem = {0x36149969, 0x0A8F, 0x49c8, [0x8B, 0x00, 0x4A, 0xEC, 0xB2, 0x02, 0x22, 0xFB]};
	interface IPreviewItem : IRelatedItem
	{
	}
}

immutable IID IID_IDestinationStreamFactory = {0x8a87781b, 0x39a7, 0x4a1f, [0xaa, 0xb3, 0xa3, 0x9b, 0x9c, 0x34, 0xa7, 0xd9]};
interface IDestinationStreamFactory : IUnknown
{
	HRESULT GetDestinationStream(IStream* ppstm);
}

alias int NMCII_FLAGS;
immutable int NMCII_ITEMS   = 0x1;
immutable int NMCII_FOLDERS = 0x2;

alias int NMCSAEI_FLAGS;
immutable int NMCSAEI_SELECT = 0;
immutable int NMCSAEI_EDIT   = 0x1;

immutable IID IID_INewMenuClient = {0xdcb07fdc, 0x3bb5, 0x451c, [0x90, 0xbe, 0x96, 0x66, 0x44, 0xfe, 0xd7, 0xb0]};
alias IID_INewMenuClient SID_SNewMenuClient;
interface INewMenuClient : IUnknown
{
	HRESULT IncludeItems(NMCII_FLAGS* pflags);
	HRESULT SelectAndEditItem(PCIDLIST_ABSOLUTE pidlItem, NMCSAEI_FLAGS flags);
}

immutable GUID SID_SCommandBarState = {0xB99EAA5C, 0x3850, 0x4400, [0xBC, 0x33, 0x2C, 0xE5, 0x34, 0x04, 0x8B, 0xF8]};

alias DWORD NSTCSTYLE;
immutable DWORD NSTCS_HASEXPANDOS         = 0x1;
immutable DWORD NSTCS_HASLINES            = 0x2;
immutable DWORD NSTCS_SINGLECLICKEXPAND   = 0x4;
immutable DWORD NSTCS_FULLROWSELECT       = 0x8;
immutable DWORD NSTCS_SPRINGEXPAND        = 0x10;
immutable DWORD NSTCS_HORIZONTALSCROLL    = 0x20;
immutable DWORD NSTCS_ROOTHASEXPANDO      = 0x40;
immutable DWORD NSTCS_SHOWSELECTIONALWAYS = 0x80;
immutable DWORD NSTCS_NOINFOTIP           = 0x200;
immutable DWORD NSTCS_EVENHEIGHT          = 0x400;
immutable DWORD NSTCS_NOREPLACEOPEN       = 0x800;
immutable DWORD NSTCS_DISABLEDRAGDROP     = 0x1000;
immutable DWORD NSTCS_NOORDERSTREAM       = 0x2000;
immutable DWORD NSTCS_RICHTOOLTIP         = 0x4000;
immutable DWORD NSTCS_BORDER              = 0x8000;
immutable DWORD NSTCS_NOEDITLABELS        = 0x10000;
immutable DWORD NSTCS_TABSTOP             = 0x20000;
immutable DWORD NSTCS_FAVORITESMODE       = 0x80000;
immutable DWORD NSTCS_AUTOHSCROLL         = 0x100000;
immutable DWORD NSTCS_FADEINOUTEXPANDOS   = 0x200000;
immutable DWORD NSTCS_EMPTYTEXT           = 0x400000;
immutable DWORD NSTCS_CHECKBOXES          = 0x800000;
immutable DWORD NSTCS_PARTIALCHECKBOXES   = 0x1000000;
immutable DWORD NSTCS_EXCLUSIONCHECKBOXES = 0x2000000;
immutable DWORD NSTCS_DIMMEDCHECKBOXES    = 0x4000000;
immutable DWORD NSTCS_NOINDENTCHECKS      = 0x8000000;
immutable DWORD NSTCS_ALLOWJUNCTIONS      = 0x10000000;
immutable DWORD NSTCS_SHOWTABSBUTTON      = 0x20000000;
immutable DWORD NSTCS_SHOWDELETEBUTTON    = 0x40000000;
immutable DWORD NSTCS_SHOWREFRESHBUTTON   = 0x80000000;

alias DWORD NSTCROOTSTYLE;
immutable DWORD NSTCRS_VISIBLE  = 0;
immutable DWORD NSTCRS_HIDDEN   = 0x1;
immutable DWORD NSTCRS_EXPANDED = 0x2;

alias DWORD NSTCITEMSTATE;
immutable DWORD NSTCIS_NONE             = 0;
immutable DWORD NSTCIS_SELECTED         = 0x1;
immutable DWORD NSTCIS_EXPANDED         = 0x2;
immutable DWORD NSTCIS_BOLD             = 0x4;
immutable DWORD NSTCIS_DISABLED         = 0x8;
immutable DWORD NSTCIS_SELECTEDNOEXPAND = 0x10;

enum NSTCGNI
{
	NSTCGNI_NEXT,
	NSTCGNI_NEXTVISIBLE,
	NSTCGNI_PREV,
	NSTCGNI_PREVVISIBLE,
	NSTCGNI_PARENT,
	NSTCGNI_CHILD,
	NSTCGNI_FIRSTVISIBLE,
	NSTCGNI_LASTVISIBLE,
}

immutable IID IID_INameSpaceTreeControl = {0x028212A3, 0xB627, 0x47e9, [0x88, 0x56, 0xC1, 0x42, 0x65, 0x55, 0x4E, 0x4F]};
alias IID_INameSpaceTreeControl SID_SNavigationPane;
interface INameSpaceTreeControl : IUnknown
{
	HRESULT Initialize(HWND hwndParent, RECT* prc, NSTCSTYLE nsctsFlags);
	HRESULT TreeAdvise(IUnknown punk, DWORD* pdwCookie);
	HRESULT TreeUnadvise(DWORD dwCookie);
	HRESULT AppendRoot(IShellItem psiRoot, SHCONTF grfEnumFlags, NSTCROOTSTYLE grfRootStyle, IShellItemFilter pif);
	HRESULT InsertRoot(int iIndex, IShellItem psiRoot, SHCONTF grfEnumFlags, NSTCROOTSTYLE grfRootStyle, IShellItemFilter pif);
	HRESULT RemoveRoot(IShellItem psiRoot);
	HRESULT RemoveAllRoots();
	HRESULT GetRootItems(IShellItemArray* ppsiaRootItems);
	HRESULT SetItemState(IShellItem psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE nstcisFlags);
	HRESULT GetItemState(IShellItem psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE* pnstcisFlags);
	HRESULT GetSelectedItems(IShellItemArray* psiaItems);
	HRESULT GetItemCustomState(IShellItem psi, int* piStateNumber);
	HRESULT SetItemCustomState(IShellItem psi, int iStateNumber);
	HRESULT EnsureItemVisible(IShellItem psi);
	HRESULT SetTheme(LPCWSTR pszTheme);
	HRESULT GetNextItem(IShellItem psi, NSTCGNI nstcgi, IShellItem* ppsiNext);
	HRESULT HitTest(POINT* ppt, IShellItem* ppsiOut);
	HRESULT GetItemRect(IShellItem psi, RECT* prect);
	HRESULT CollapseAll();
}

alias DWORD NSTCSTYLE2;
immutable DWORD NSTCS2_DEFAULT                  = 0;
immutable DWORD NSTCS2_INTERRUPTNOTIFICATIONS   = 0x1;
immutable DWORD NSTCS2_SHOWNULLSPACEMENU        = 0x2;
immutable DWORD NSTCS2_DISPLAYPADDING           = 0x4;
immutable DWORD NSTCS2_DISPLAYPINNEDONLY        = 0x8;
immutable DWORD NTSCS2_NOSINGLETONAUTOEXPAND    = 0x10;
immutable DWORD NTSCS2_NEVERINSERTNONENUMERATED = 0x20;
immutable DWORD NSTCS2_ALLMASK                  = NSTCS2_INTERRUPTNOTIFICATIONS | NSTCS2_SHOWNULLSPACEMENU | NSTCS2_DISPLAYPADDING;

immutable IID IID_INameSpaceTreeControl2 = {0x7cc7aed8, 0x290e, 0x49bc, [0x89, 0x45, 0xc1, 0x40, 0x1c, 0xc9, 0x30, 0x6c]};
interface INameSpaceTreeControl2 : INameSpaceTreeControl
{
	HRESULT SetControlStyle(NSTCSTYLE nstcsMask, NSTCSTYLE nstcsStyle);
	HRESULT GetControlStyle(NSTCSTYLE nstcsMask, NSTCSTYLE* pnstcsStyle);
	HRESULT SetControlStyle2(NSTCSTYLE2 nstcsMask, NSTCSTYLE2 nstcsStyle);
	HRESULT GetControlStyle2(NSTCSTYLE2 nstcsMask, NSTCSTYLE2* pnstcsStyle);
}

alias DWORD NSTCECLICKTYPE;
immutable DWORD NSTCECT_LBUTTON = 0x1;
immutable DWORD NSTCECT_MBUTTON = 0x2;
immutable DWORD NSTCECT_RBUTTON = 0x3;
immutable DWORD NSTCECT_BUTTON  = 0x3;
immutable DWORD NSTCECT_DBLCLICK = 0x4;

bool ISLBUTTON(DWORD x)
{
	return NSTCECT_LBUTTON == (x & NSTCECT_BUTTON);
}

bool ISMBUTTON(DWORD x)
{
	return NSTCECT_MBUTTON == (x & NSTCECT_BUTTON);
}

bool ISRBUTTON(DWORD x)
{
	return NSTCECT_RBUTTON == (x & NSTCECT_BUTTON);
}

bool ISDBLCLICK(DWORD x)
{
	return NSTCECT_DBLCLICK == (x & NSTCECT_DBLCLICK);
}

alias DWORD NSTCEHITTEST;
immutable DWORD NSTCEHT_NOWHERE         = 0x1;
immutable DWORD NSTCEHT_ONITEMICON      = 0x2;
immutable DWORD NSTCEHT_ONITEMLABEL     = 0x4;
immutable DWORD NSTCEHT_ONITEMINDENT    = 0x8;
immutable DWORD NSTCEHT_ONITEMBUTTON    = 0x10;
immutable DWORD NSTCEHT_ONITEMRIGHT     = 0x20;
immutable DWORD NSTCEHT_ONITEMSTATEICON = 0x40;
immutable DWORD NSTCEHT_ONITEM          = 0x46;
immutable DWORD NSTCEHT_ONITEMTABBUTTON = 0x1000;

immutable IID IID_INameSpaceTreeControlEvents = {0x93D77985, 0xB3D8, 0x4484, [0x83, 0x18, 0x67, 0x2C, 0xDD, 0xA0, 0x02, 0xCE]};
interface INameSpaceTreeControlEvents : IUnknown
{
	HRESULT OnItemClick(IShellItem psi, NSTCEHITTEST nstceHitTest, NSTCECLICKTYPE nstceClickType);
	HRESULT OnPropertyItemCommit(IShellItem psi);
	HRESULT OnItemStateChanging(IShellItem psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE nstcisState);
	HRESULT OnItemStateChanged(IShellItem psi, NSTCITEMSTATE nstcisMask, NSTCITEMSTATE nstcisState);
	HRESULT OnSelectionChanged(IShellItemArray psiaSelection);
	HRESULT OnKeyboardInput(UINT uMsg, WPARAM wParam, LPARAM lParam);
	HRESULT OnBeforeExpand(IShellItem psi);
	HRESULT OnAfterExpand(IShellItem psi);
	HRESULT OnBeginLabelEdit(IShellItem psi);
	HRESULT OnEndLabelEdit(IShellItem psi);
	HRESULT OnGetToolTip(IShellItem psi, LPWSTR pszTip, int cchTip);
	HRESULT OnBeforeItemDelete(IShellItem psi);
	HRESULT OnItemAdded(IShellItem psi, BOOL fIsRoot);
	HRESULT OnItemDeleted(IShellItem psi, BOOL fIsRoot);
	HRESULT OnBeforeContextMenu(IShellItem psi, REFIID riid, void** ppv);
	HRESULT OnAfterContextMenu(IShellItem psi, IContextMenu pcmIn, REFIID riid, void** ppv);
	HRESULT OnBeforeStateImageChange(IShellItem psi);
	HRESULT OnGetDefaultIconIndex(IShellItem psi, int* piDefaultIcon, int* piOpenIcon);
}

immutable int NSTCDHPOS_ONTOP = -1;

immutable IID IID_INameSpaceTreeControlDropHandler = {0xF9C665D6, 0xC2F2, 0x4c19, [0xBF, 0x33, 0x83, 0x22, 0xD7, 0x35, 0x2F, 0x51]};
interface INameSpaceTreeControlDropHandler : IUnknown
{
	HRESULT OnDragEnter(IShellItem psiOver, IShellItemArray psiaData, BOOL fOutsideSource, DWORD grfKeyState, DWORD* pdwEffect);
	HRESULT OnDragOver(IShellItem psiOver, IShellItemArray psiaData, DWORD grfKeyState, DWORD* pdwEffect);
	HRESULT OnDragPosition(IShellItem psiOver, IShellItemArray psiaData, int iNewPosition, int iOldPosition);
	HRESULT OnDrop(IShellItem psiOver, IShellItemArray psiaData, int iPosition, DWORD grfKeyState, DWORD* pdwEffect);
	HRESULT OnDropPosition(IShellItem psiOver, IShellItemArray psiaData, int iNewPosition, int iOldPosition);
	HRESULT OnDragLeave(IShellItem psiOver);
}

immutable IID IID_INameSpaceTreeAccessible = {0x71f312de, 0x43ed, 0x4190, [0x84, 0x77, 0xe9, 0x53, 0x6b, 0x82, 0x35, 0x0b]};
interface INameSpaceTreeAccessible : IUnknown
{
	HRESULT OnGetDefaultAccessibilityAction(IShellItem psi, BSTR* pbstrDefaultAction);
	HRESULT OnDoDefaultAccessibilityAction(IShellItem psi);
	HRESULT OnGetAccessibilityRole(IShellItem psi, VARIANT* pvarRole);
}

struct NSTCCUSTOMDRAW
{
	IShellItem psi;
	UINT uItemState;
	NSTCITEMSTATE nstcis;
	LPCWSTR pszText;
	int iImage;
	HIMAGELIST himl;
	int iLevel;
	int iIndent;
}

immutable IID IID_INameSpaceTreeControlCustomDraw = {0x2D3BA758, 0x33EE, 0x42d5, [0xBB, 0x7B, 0x5F, 0x34, 0x31, 0xD8, 0x6C, 0x78]};
interface INameSpaceTreeControlCustomDraw : IUnknown
{
	HRESULT PrePaint(HDC hdc, RECT* prc, LRESULT* plres);
	HRESULT PostPaint(HDC hdc, RECT* prc);
	HRESULT ItemPrePaint(HDC hdc, RECT* prc, NSTCCUSTOMDRAW* pnstccdItem, COLORREF* pclrText, COLORREF* pclrTextBk, LRESULT* plres);
	HRESULT ItemPostPaint(HDC hdc, RECT* prc, NSTCCUSTOMDRAW* pnstccdItem);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	alias DWORD NSTCFOLDERCAPABILITIES;
	immutable DWORD NSTCFC_NONE                  = 0;
	immutable DWORD NSTCFC_PINNEDITEMFILTERING   = 0x1;
	immutable DWORD NSTCFC_DELAY_REGISTER_NOTIFY = 0x2;

	immutable IID IID_INameSpaceTreeControlFolderCapabilities = {0xe9701183, 0xe6b3, 0x4ff2, [0x85, 0x68, 0x81, 0x36, 0x15, 0xfe, 0xc7, 0xbe]};
	interface INameSpaceTreeControlFolderCapabilities : IUnknown
	{
		HRESULT GetFolderCapabilities(NSTCFOLDERCAPABILITIES nfcMask, NSTCFOLDERCAPABILITIES* pnfcValue);
	}
}

immutable HRESULT E_PREVIEWHANDLER_DRM_FAIL = 0x86420001;
immutable HRESULT E_PREVIEWHANDLER_NOAUTH   = 0x86420002;
immutable HRESULT E_PREVIEWHANDLER_NOTFOUND = 0x86420003;
immutable HRESULT E_PREVIEWHANDLER_CORRUPT  = 0x86420004;

immutable IID IID_IPreviewHandler = {0x8895b1c6, 0xb41f, 0x4c1c, [0xa5, 0x62, 0x0d, 0x56, 0x42, 0x50, 0x83, 0x6f]};
interface IPreviewHandler : IUnknown
{
	HRESULT SetWindow(HWND hwnd, const(RECT)* prc);
	HRESULT SetRect(const(RECT)* prc);
	HRESULT DoPreview();
	HRESULT Unload();
	HRESULT SetFocus();
	HRESULT QueryFocus(HWND* phwnd);
	HRESULT TranslateAccelerator(MSG* pmsg);
}

struct PREVIEWHANDLERFRAMEINFO
{
	HACCEL haccel;
	UINT cAccelEntries;
}

immutable IID IID_IPreviewHandlerFrame = {0xfec87aaf, 0x35f9, 0x447a, [0xad, 0xb7, 0x20, 0x23, 0x44, 0x91, 0x40, 0x1a]};
interface IPreviewHandlerFrame : IUnknown
{
	HRESULT GetWindowContext(PREVIEWHANDLERFRAMEINFO* pinfo);
	HRESULT TranslateAccelerator(MSG* pmsg);
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_ITrayDeskBand = {0x6D67E846, 0x5B9C, 0x4db8, [0x9C, 0xBC, 0xDD, 0xE1, 0x2F, 0x42, 0x54, 0xF1]};
	interface ITrayDeskBand : IUnknown
	{
		HRESULT ShowDeskBand(REFCLSID clsid);
		HRESULT HideDeskBand(REFCLSID clsid);
		HRESULT IsDeskBandShown(REFCLSID clsid);
		HRESULT DeskBandRegistrationChanged();
	}

	immutable IID IID_IBandHost = {0xB9075C7C, 0xD48E, 0x403f, [0xAB, 0x99, 0xD6, 0xC7, 0x7A, 0x10, 0x84, 0xAC]};
	alias IID_IBandHost SID_SBandHost;
	interface IBandHost : IUnknown
	{
		HRESULT CreateBand(REFCLSID rclsidBand, BOOL fAvailable, BOOL fVisible, REFIID riid, void** ppv);
		HRESULT SetBandAvailability(REFCLSID rclsidBand, BOOL fAvailable);
		HRESULT DestroyBand(REFCLSID rclsidBand);
	}

	alias GUID EXPLORERPANE;

	alias const(EXPLORERPANE)* REFEXPLORERPANE;

	alias DWORD EXPLORERPANESTATE;
	immutable DWORD EPS_DONTCARE     = 0;
	immutable DWORD EPS_DEFAULT_ON   = 0x1;
	immutable DWORD EPS_DEFAULT_OFF  = 0x2;
	immutable DWORD EPS_STATEMASK    = 0xffff;
	immutable DWORD EPS_INITIALSTATE = 0x10000;
	immutable DWORD EPS_FORCE        = 0x20000;

	immutable IID IID_IExplorerPaneVisibility = {0xe07010ec, 0xbc17, 0x44c0, [0x97, 0xb0, 0x46, 0xc7, 0xc9, 0x5b, 0x9e, 0xdc]};
	alias IID_IExplorerPaneVisibility SID_ExplorerPaneVisibility;
	interface IExplorerPaneVisibility : IUnknown
	{
		HRESULT GetPaneState(REFEXPLORERPANE ep, EXPLORERPANESTATE* peps);
	}

	immutable IID IID_IContextMenuCB = {0x3409E930, 0x5A39, 0x11d1, [0x83, 0xFA, 0x00, 0xA0, 0xC9, 0x0D, 0xC8, 0x49]};
	interface IContextMenuCB : IUnknown
	{
		HRESULT CallBack(IShellFolder psf, HWND hwndOwner, IDataObject pdtobj, UINT uMsg, WPARAM wParam, LPARAM lParam);
	}
}

immutable IID IID_IDefaultExtractIconInit = {0x41ded17d, 0xd6b3, 0x4261, [0x99, 0x7d, 0x88, 0xc6, 0x0e, 0x4b, 0x1d, 0x58]};
interface IDefaultExtractIconInit : IUnknown
{
	HRESULT SetFlags(UINT uFlags);
	HRESULT SetKey(HKEY hkey);
	HRESULT SetNormalIcon(LPCWSTR pszFile, int iIcon);
	HRESULT SetOpenIcon(LPCWSTR pszFile, int iIcon);
	HRESULT SetShortcutIcon(LPCWSTR pszFile, int iIcon);
	HRESULT SetDefaultIcon(LPCWSTR pszFile, int iIcon);
}

HRESULT SHCreateDefaultExtractIcon(REFIID riid, void** ppv);

alias DWORD EXPCMDSTATE;
immutable DWORD ECS_ENABLED    = 0;
immutable DWORD ECS_DISABLED   = 0x1;
immutable DWORD ECS_HIDDEN     = 0x2;
immutable DWORD ECS_CHECKBOX   = 0x4;
immutable DWORD ECS_CHECKED    = 0x8;
immutable DWORD ECS_RADIOCHECK = 0x10;

alias DWORD EXPCMDFLAGS;
immutable DWORD ECF_DEFAULT         = 0;
immutable DWORD ECF_HASSUBCOMMANDS  = 0x1;
immutable DWORD ECF_HASSPLITBUTTON  = 0x2;
immutable DWORD ECF_HIDELABEL       = 0x4;
immutable DWORD ECF_ISSEPARATOR     = 0x8;
immutable DWORD ECF_HASLUASHIELD    = 0x10;
immutable DWORD ECF_SEPARATORBEFORE = 0x20;
immutable DWORD ECF_SEPARATORAFTER  = 0x40;
immutable DWORD ECF_ISDROPDOWN      = 0x80;

immutable IID IID_IExplorerCommand = {0xa08ce4d0, 0xfa25, 0x44ab, [0xb5, 0x7c, 0xc7, 0xb1, 0xc3, 0x23, 0xe0, 0xb9]};
interface IExplorerCommand : IUnknown
{
	HRESULT GetTitle(IShellItemArray psiItemArray, LPWSTR* ppszName);
	HRESULT GetIcon(IShellItemArray psiItemArray, LPWSTR* ppszIcon);
	HRESULT GetToolTip(IShellItemArray psiItemArray, LPWSTR* ppszInfotip);
	HRESULT GetCanonicalName(GUID* pguidCommandName);
	HRESULT GetState(IShellItemArray psiItemArray, BOOL fOkToBeSlow, EXPCMDSTATE* pCmdState);
	HRESULT Invoke(IShellItemArray psiItemArray, IBindCtx pbc);
	HRESULT GetFlags(EXPCMDFLAGS* pFlags);
	HRESULT EnumSubCommands(IEnumExplorerCommand* ppEnum);
}

immutable IID IID_IExplorerCommandState = {0xbddacb60, 0x7657, 0x47ae, [0x84, 0x45, 0xd2, 0x3e, 0x1a, 0xcf, 0x82, 0xae]};
interface IExplorerCommandState : IUnknown
{
	HRESULT GetState(IShellItemArray psiItemArray, BOOL fOkToBeSlow, EXPCMDSTATE* pCmdState);
}

immutable IID IID_IInitializeCommand = {0x85075acf, 0x231f, 0x40ea, [0x96, 0x10, 0xd2, 0x6b, 0x7b, 0x58, 0xf6, 0x38]};
interface IInitializeCommand : IUnknown
{
	HRESULT Initialize(LPCWSTR pszCommandName, IPropertyBag ppb);
}

immutable IID IID_IEnumExplorerCommand = {0xa88826f8, 0x186f, 0x4987, [0xaa, 0xde, 0xea, 0x0c, 0xef, 0x8f, 0xbf, 0xe8]};
interface IEnumExplorerCommand : IUnknown
{
	HRESULT Next(ULONG celt, IExplorerCommand* pUICommand, ULONG* pceltFetched);
	HRESULT Skip(ULONG celt);
	HRESULT Reset();
	HRESULT Clone(IEnumExplorerCommand* ppenum);
}

HRESULT IEnumExplorerCommand_RemoteNext_Proxy(IEnumExplorerCommand This, ULONG celt, IExplorerCommand* pUICommand, ULONG* pceltFetched);
void IEnumExplorerCommand_RemoteNext_Stub(IRpcStubBuffer This, IRpcChannelBuffer _pRpcChannelBuffer, PRPC_MESSAGE _pRpcMessage, DWORD* _pdwStubPhase);

immutable IID IID_IExplorerCommandProvider = {0x64961751, 0x0835, 0x43c0, [0x8f, 0xfe, 0xd5, 0x76, 0x86, 0x53, 0x0e, 0x64]};
interface IExplorerCommandProvider : IUnknown
{
	HRESULT GetCommands(IUnknown punkSite, REFIID riid, void** ppv);
	HRESULT GetCommand(REFGUID rguidCommandId, REFIID riid, void** ppv);
}

immutable IID IID_IMarkupCallback = {0x4440306e, 0xd79a, 0x48d0, [0x88, 0xe6, 0xa4, 0x26, 0x92, 0x27, 0x9b, 0xfb]};
interface IMarkupCallback : IUnknown
{
	HRESULT GetState(DWORD dwId, UINT uState);
	HRESULT Notify(DWORD dwId, int nCode, int iLink);
	HRESULT InvalidateRect(DWORD dwId, const(RECT)* prc);
	HRESULT OnCustomDraw(DWORD dwDrawStage, HDC hdc, const(RECT)* prc, DWORD dwId, int iLink, UINT uItemState, LRESULT* pdwResult);
	HRESULT CustomDrawText(HDC hDC, LPCWSTR lpString, int nCount, RECT* pRect, UINT uFormat, BOOL fLink);
}

alias HANDLE HTHEME;

enum MARKUPSIZE
{
	MARKUPSIZE_CALCWIDTH,
	MARKUPSIZE_CALCHEIGHT,
}

enum MARKUPLINKTEXT
{
	MARKUPLINKTEXT_URL,
	MARKUPLINKTEXT_ID,
	MARKUPLINKTEXT_TEXT,
}

alias DWORD MARKUPSTATE;
immutable DWORD MARKUPSTATE_FOCUSED       = 0x1;
immutable DWORD MARKUPSTATE_ENABLED       = 0x2;
immutable DWORD MARKUPSTATE_VISITED       = 0x4;
immutable DWORD MARKUPSTATE_HOT           = 0x8;
immutable DWORD MARKUPSTATE_DEFAULTCOLORS = 0x10;
immutable DWORD MARKUPSTATE_ALLOWMARKUP   = 0x40000000;

enum MARKUPMESSAGE
{
	MARKUPMESSAGE_KEYEXECUTE,
	MARKUPMESSAGE_CLICKEXECUTE,
	MARKUPMESSAGE_WANTFOCUS,
}

immutable IID IID_IControlMarkup = {0xD6D2FBAE, 0xF116, 0x458c, [0x8C, 0x34, 0x03, 0x56, 0x98, 0x77, 0xA2, 0xD2]};
interface IControlMarkup : IUnknown
{
	HRESULT SetCallback(IUnknown punk);
	HRESULT GetCallback(REFIID riid, void** ppvUnk);
	HRESULT SetId(DWORD dwId);
	HRESULT GetId(DWORD* pdwId);
	HRESULT SetFonts(HFONT hFont, HFONT hFontUnderline);
	HRESULT GetFonts(HFONT* phFont, HFONT* phFontUnderline);
	HRESULT SetText(LPCWSTR pwszText);
	HRESULT GetText(BOOL bRaw, LPWSTR pwszText, DWORD* pdwCch);
	HRESULT SetLinkText(int iLink, UINT uMarkupLinkText, LPCWSTR pwszText);
	HRESULT GetLinkText(int iLink, UINT uMarkupLinkText, LPWSTR pwszText, DWORD* pdwCch);
	HRESULT SetRenderFlags(UINT uDT);
	HRESULT GetRenderFlags(UINT* puDT, HTHEME* phTheme, int* piPartId, int* piStateIdNormal, int* piStateIdLink);
	HRESULT SetThemeRenderFlags(UINT uDT, HTHEME hTheme, int iPartId, int iStateIdNormal, int iStateIdLink);
	HRESULT GetState(int iLink, UINT uStateMask, UINT* puState);
	HRESULT SetState(int iLink, UINT uStateMask, UINT uState);
	HRESULT DrawText(HDC hdcClient, LPCRECT prcClient);
	HRESULT SetLinkCursor();
	HRESULT CalcIdealSize(HDC hdc, UINT uMarkUpCalc, RECT* prc);
	HRESULT SetFocus();
	HRESULT KillFocus();
	HRESULT IsTabbable();
	HRESULT OnButtonDown(POINT pt);
	HRESULT OnButtonUp(POINT pt);
	HRESULT OnKeyDown(UINT uVirtKey);
	HRESULT HitTest(POINT pt, int* piLink);
	HRESULT GetLinkRect(int iLink, RECT* prc);
	HRESULT GetControlRect(RECT* prcControl);
	HRESULT GetLinkCount(UINT* pcLinks);
}

immutable IID IID_IInitializeNetworkFolder = {0x6e0f9881, 0x42a8, 0x4f2a, [0x97, 0xf8, 0x8a, 0xf4, 0xe0, 0x26, 0xd9, 0x2d]};
interface IInitializeNetworkFolder : IUnknown
{
	HRESULT Initialize(PCIDLIST_ABSOLUTE pidl, PCIDLIST_ABSOLUTE pidlTarget, UINT uDisplayType, LPCWSTR pszResName, LPCWSTR pszProvider);
}

enum CPVIEW
{
	CPVIEW_CLASSIC  = 0,
	CPVIEW_ALLITEMS = CPVIEW_CLASSIC,
	CPVIEW_CATEGORY = 1,
	CPVIEW_HOME     = CPVIEW_CATEGORY,
}

immutable IID IID_IOpenControlPanel = {0xD11AD862, 0x66DE, 0x4DF4, [0xBF, 0x6C, 0x1F, 0x56, 0x21, 0x99, 0x6A, 0xF1]};
interface IOpenControlPanel : IUnknown
{
	HRESULT Open(LPCWSTR pszName, LPCWSTR pszPage, IUnknown punkSite);
	HRESULT GetPath(LPCWSTR pszName, LPWSTR pszPath, UINT cchPath);
	HRESULT GetCurrentView(CPVIEW* pView);
}

immutable IID IID_IComputerInfoChangeNotify = {0x0DF60D92, 0x6818, 0x46d6, [0xB3, 0x58, 0xD6, 0x61, 0x70, 0xDD, 0xE4, 0x66]};
interface IComputerInfoChangeNotify : IUnknown
{
	HRESULT ComputerInfoChanged();
}

immutable wchar* STR_FILE_SYS_BIND_DATA = "File System Bind Data\0"w.ptr;

immutable IID IID_IFileSystemBindData = {0x01E18D10, 0x4D8B, 0x11d2, [0x85, 0x5D, 0x00, 0x60, 0x08, 0x05, 0x93, 0x67]};
interface IFileSystemBindData : IUnknown
{
	HRESULT SetFindData(const(WIN32_FIND_DATAW)* pfd);
	HRESULT GetFindData(WIN32_FIND_DATAW* pfd);
}

immutable IID IID_IFileSystemBindData2 = {0x3acf075f, 0x71db, 0x4afa, [0x81, 0xf0, 0x3f, 0xc4, 0xfd, 0xf2, 0xa5, 0xb8]};
interface IFileSystemBindData2 : IFileSystemBindData
{
	HRESULT SetFileID(LARGE_INTEGER liFileID);
	HRESULT GetFileID(LARGE_INTEGER* pliFileID);
	HRESULT SetJunctionCLSID(REFCLSID clsid);
	HRESULT GetJunctionCLSID(CLSID* pclsid);
}

static if (NTDDI_VERSION >= NTDDI_WIN7)
{
	enum KNOWNDESTCATEGORY
	{
		KDC_FREQUENT = 1,
		KDC_RECENT,
	}

	immutable IID IID_ICustomDestinationList = {0x6332debf, 0x87b5, 0x4670, [0x90, 0xc0, 0x5e, 0x57, 0xb4, 0x08, 0xa4, 0x9e]};
	interface ICustomDestinationList : IUnknown
	{
		HRESULT SetAppID(LPCWSTR pszAppID);
		HRESULT BeginList(UINT* pcMinSlots, REFIID riid, void** ppv);
		HRESULT AppendCategory(LPCWSTR pszCategory, IObjectArray poa);
		HRESULT AppendKnownCategory(KNOWNDESTCATEGORY category);
		HRESULT AddUserTasks(IObjectArray poa);
		HRESULT CommitList();
		HRESULT GetRemovedDestinations(REFIID riid, void** ppv);
		HRESULT DeleteList(LPCWSTR pszAppID);
		HRESULT AbortList();
	}

	immutable IID IID_IApplicationDestinations = {0x12337d35, 0x94c6, 0x48a0, [0xbc, 0xe7, 0x6a, 0x9c, 0x69, 0xd4, 0xd6, 0x00]};
	interface IApplicationDestinations : IUnknown
	{
		HRESULT SetAppID(LPCWSTR pszAppID);
		HRESULT RemoveDestination(IUnknown punk);
		HRESULT RemoveAllDestinations();
	}

	enum APPDOCLISTTYPE
	{
		ADLT_RECENT,
		ADLT_FREQUENT,
	}

	immutable IID IID_IApplicationDocumentLists = {0x3c594f9f, 0x9f30, 0x47a1, [0x97, 0x9a, 0xc9, 0xe8, 0x3d, 0x3d, 0x0a, 0x06]};
	interface IApplicationDocumentLists : IUnknown
	{
		HRESULT SetAppID(LPCWSTR pszAppID);
		HRESULT GetList(APPDOCLISTTYPE listtype, UINT cItemsDesired, REFIID riid, void** ppv);
	}

	immutable IID IID_IObjectWithAppUserModelID = {0x36db0196, 0x9665, 0x46d1, [0x9b, 0xa7, 0xd3, 0x70, 0x9e, 0xec, 0xf9, 0xed]};
	interface IObjectWithAppUserModelID : IUnknown
	{
		HRESULT SetAppID(LPCWSTR pszAppID);
		HRESULT GetAppID(LPWSTR* ppszAppID);
	}

	immutable IID IID_IObjectWithProgID = {0x71e806fb, 0x8dee, 0x46fc, [0xbf, 0x8c, 0x77, 0x48, 0xa8, 0xa1, 0xae, 0x13]};
	interface IObjectWithProgID : IUnknown
	{
		HRESULT SetProgID(LPCWSTR pszProgID);
		HRESULT GetProgID(LPWSTR* ppszProgID);
	}

	immutable IID IID_IUpdateIDList = {0x6589b6d2, 0x5f8d, 0x4b9e, [0xb7, 0xe0, 0x23, 0xcd, 0xd9, 0x71, 0x7d, 0x8c]};
	interface IUpdateIDList : IUnknown
	{
		HRESULT Update(IBindCtx pbc, PCUITEMID_CHILD pidlIn, PITEMID_CHILD* ppidlOut);
	}

	HRESULT SetCurrentProcessExplicitAppUserModelID(PCWSTR AppID);
	HRESULT GetCurrentProcessExplicitAppUserModelID(PWSTR* AppID);
}

immutable IID IID_IDesktopGadget = {0xc1646bc4, 0xf298, 0x4f91, [0xa2, 0x04, 0xeb, 0x2d, 0xd1, 0x70, 0x9d, 0x1a]};
interface IDesktopGadget : IUnknown
{
	HRESULT RunGadget(LPCWSTR gadgetPath);
}

immutable wchar* HOMEGROUP_SECURITY_GROUP = "HomeUsers\0"w.ptr;

alias DWORD HOMEGROUPSHARINGCHOICES;
immutable DWORD HGSC_NONE             = 0;
immutable DWORD HGSC_MUSICLIBRARY     = 0x1;
immutable DWORD HGSC_PICTURESLIBRARY  = 0x2;
immutable DWORD HGSC_VIDEOSLIBRARY    = 0x4;
immutable DWORD HGSC_DOCUMENTSLIBRARY = 0x8;
immutable DWORD HGSC_PRINTERS         = 0x10;

immutable IID IID_IHomeGroup = {0x7a3bd1d9, 0x35a9, 0x4fb3, [0xa4, 0x67, 0xf4, 0x8c, 0xac, 0x35, 0xe2, 0xd0]};
interface IHomeGroup : IUnknown
{
	HRESULT IsMember(BOOL* member);
	HRESULT ShowSharingWizard(HWND owner, HOMEGROUPSHARINGCHOICES* sharingchoices);
}

immutable IID IID_IInitializeWithPropertyStore = {0xC3E12EB5, 0x7D8D, 0x44f8, [0xB6, 0xDD, 0x0E, 0x77, 0xB3, 0x4D, 0x6D, 0xE4]};
interface IInitializeWithPropertyStore : IUnknown
{
	HRESULT Initialize(IPropertyStore pps);
}

immutable IID IID_IOpenSearchSource = {0xF0EE7333, 0xE6FC, 0x479b, [0x9F, 0x25, 0xA8, 0x60, 0xC2, 0x34, 0xA3, 0x8E]};
interface IOpenSearchSource : IUnknown
{
	HRESULT GetResults(HWND hwnd, LPCWSTR pszQuery, DWORD dwStartIndex, DWORD dwCount, REFIID riid, void** ppv);
}

enum LIBRARYFOLDERFILTER
{
	LFF_FORCEFILESYSTEM = 1,
	LFF_STORAGEITEMS    = 2,
	LFF_ALLITEMS        = 3,
}

alias DWORD LIBRARYOPTIONFLAGS;
immutable DWORD LOF_DEFAULT         = 0;
immutable DWORD LOF_PINNEDTONAVPANE = 0x1;
immutable DWORD LOF_MASK_ALL        = 0x1;

enum DEFAULTSAVEFOLDERTYPE
{
	DSFT_DETECT = 1,
	DSFT_PRIVATE,
	DSFT_PUBLIC,
}

alias DWORD LIBRARYSAVEFLAGS;
immutable DWORD LSF_FAILIFTHERE      = 0;
immutable DWORD LSF_OVERRIDEEXISTING = 0x1;
immutable DWORD  LSF_MAKEUNIQUENAME  = 0x2;

immutable IID IID_IShellLibrary = {0x11a66efa, 0x382e, 0x451a, [0x92, 0x34, 0x1e, 0x0e, 0x12, 0xef, 0x30, 0x85]};
interface IShellLibrary : IUnknown
{
	HRESULT LoadLibraryFromItem(IShellItem psiLibrary, DWORD grfMode);
	HRESULT LoadLibraryFromKnownFolder(REFKNOWNFOLDERID kfidLibrary, DWORD grfMode);
	HRESULT AddFolder(IShellItem psiLocation);
	HRESULT RemoveFolder(IShellItem psiLocation);
	HRESULT GetFolders(LIBRARYFOLDERFILTER lff, REFIID riid, void** ppv);
	HRESULT ResolveFolder(IShellItem psiFolderToResolve, DWORD dwTimeout, REFIID riid, void** ppv);
	HRESULT GetDefaultSaveFolder(DEFAULTSAVEFOLDERTYPE dsft, REFIID riid, void** ppv);
	HRESULT SetDefaultSaveFolder(DEFAULTSAVEFOLDERTYPE dsft, IShellItem psi);
	HRESULT GetOptions(LIBRARYOPTIONFLAGS* plofOptions);
	HRESULT SetOptions(LIBRARYOPTIONFLAGS lofMask, LIBRARYOPTIONFLAGS lofOptions);
	HRESULT GetFolderType(FOLDERTYPEID* pftid);
	HRESULT SetFolderType(REFFOLDERTYPEID ftid);
	HRESULT GetIcon(LPWSTR* ppszIcon);
	HRESULT SetIcon(LPCWSTR pszIcon);
	HRESULT Commit();
	HRESULT Save(IShellItem psiFolderToSaveIn, LPCWSTR pszLibraryName, LIBRARYSAVEFLAGS lsf, IShellItem* ppsiSavedTo);
	HRESULT SaveInKnownFolder(REFKNOWNFOLDERID kfidToSaveIn, LPCWSTR pszLibraryName, LIBRARYSAVEFLAGS lsf, IShellItem* ppsiSavedTo);
}

immutable IID LIBID_ShellObjects = {0x50a7e9b1, 0x70ef, 0x11d1, [0xb7, 0x5a, 0x00, 0xa0, 0xc9, 0x05, 0x64, 0xfe]};

immutable CLSID CLSID_ShellDesktop                         = {0x00021400, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
immutable CLSID CLSID_ShellFSFolder                        = {0xF3364BA0, 0x65B9, 0x11CE, [0xA9, 0xBA, 0x00, 0xAA, 0x00, 0x4A, 0xE8, 0x37]};
immutable CLSID CLSID_NetworkPlaces                        = {0x208D2C60, 0x3AEA, 0x1069, [0xA2, 0xD7, 0x08, 0x00, 0x2B, 0x30, 0x30, 0x9D]};
immutable CLSID CLSID_ShellLink                            = {0x00021401, 0x0000, 0x0000, [0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x46]};
immutable CLSID CLSID_QueryCancelAutoPlay                  = {0x331F1768, 0x05A9, 0x4ddd, [0xB8, 0x6E, 0xDA, 0xE3, 0x4D, 0xDC, 0x99, 0x8A]};
immutable CLSID CLSID_DriveSizeCategorizer                 = {0x94357B53, 0xCA29, 0x4b78, [0x83, 0xAE, 0xE8, 0xFE, 0x74, 0x09, 0x13, 0x4F]};
immutable CLSID CLSID_DriveTypeCategorizer                 = {0xB0A8F3CF, 0x4333, 0x4bab, [0x88, 0x73, 0x1C, 0xCB, 0x1C, 0xAD, 0xA4, 0x8B]};
immutable CLSID CLSID_FreeSpaceCategorizer                 = {0xB5607793, 0x24AC, 0x44c7, [0x82, 0xE2, 0x83, 0x17, 0x26, 0xAA, 0x6C, 0xB7]};
immutable CLSID CLSID_TimeCategorizer                      = {0x3bb4118f, 0xddfd, 0x4d30, [0xa3, 0x48, 0x9f, 0xb5, 0xd6, 0xbf, 0x1a, 0xfe]};
immutable CLSID CLSID_SizeCategorizer                      = {0x55d7b852, 0xf6d1, 0x42f2, [0xaa, 0x75, 0x87, 0x28, 0xa1, 0xb2, 0xd2, 0x64]};
immutable CLSID CLSID_AlphabeticalCategorizer              = {0x3c2654c6, 0x7372, 0x4f6b, [0xb3, 0x10, 0x55, 0xd6, 0x12, 0x8f, 0x49, 0xd2]};
immutable CLSID CLSID_MergedCategorizer                    = {0x8e827c11, 0x33e7, 0x4bc1, [0xb2, 0x42, 0x8c, 0xd9, 0xa1, 0xc2, 0xb3, 0x04]};
immutable CLSID CLSID_ImageProperties                      = {0x7ab770c7, 0x0e23, 0x4d7a, [0x8a, 0xa2, 0x19, 0xbf, 0xad, 0x47, 0x98, 0x29]};
immutable CLSID CLSID_PropertiesUI                         = {0xd912f8cf, 0x0396, 0x4915, [0x88, 0x4e, 0xfb, 0x42, 0x5d, 0x32, 0x94, 0x3b]};
immutable CLSID CLSID_UserNotification                     = {0x0010890e, 0x8789, 0x413c, [0xad, 0xbc, 0x48, 0xf5, 0xb5, 0x11, 0xb3, 0xaf]};
immutable CLSID CLSID_CDBurn                               = {0xfbeb8a05, 0xbeee, 0x4442, [0x80, 0x4e, 0x40, 0x9d, 0x6c, 0x45, 0x15, 0xe9]};
immutable CLSID CLSID_TaskbarList                          = {0x56FDF344, 0xFD6D, 0x11d0, [0x95, 0x8A, 0x00, 0x60, 0x97, 0xC9, 0xA0, 0x90]};
immutable CLSID CLSID_StartMenuPin                         = {0xa2a9545d, 0xa0c2, 0x42b4, [0x97, 0x08, 0xa0, 0xb2, 0xba, 0xdd, 0x77, 0xc8]};
immutable CLSID CLSID_WebWizardHost                        = {0xc827f149, 0x55c1, 0x4d28, [0x93, 0x5e, 0x57, 0xe4, 0x7c, 0xae, 0xd9, 0x73]};
immutable CLSID CLSID_PublishDropTarget                    = {0xCC6EEFFB, 0x43F6, 0x46c5, [0x96, 0x19, 0x51, 0xD5, 0x71, 0x96, 0x7F, 0x7D]};
immutable CLSID CLSID_PublishingWizard                     = {0x6b33163c, 0x76a5, 0x4b6c, [0xbf, 0x21, 0x45, 0xde, 0x9c, 0xd5, 0x03, 0xa1]};
immutable CLSID CLSID_InternetPrintOrdering                = {0xadd36aa8, 0x751a, 0x4579, [0xa2, 0x66, 0xd6, 0x6f, 0x52, 0x02, 0xcc, 0xbb]};
immutable CLSID CLSID_FolderViewHost                       = {0x20b1cb23, 0x6968, 0x4eb9, [0xb7, 0xd4, 0xa6, 0x6d, 0x00, 0xd0, 0x7c, 0xee]};
immutable CLSID CLSID_ExplorerBrowser                      = {0x71f96385, 0xddd6, 0x48d3, [0xa0, 0xc1, 0xae, 0x06, 0xe8, 0xb0, 0x55, 0xfb]};
immutable CLSID CLSID_ImageRecompress                      = {0x6e33091c, 0xd2f8, 0x4740, [0xb5, 0x5e, 0x2e, 0x11, 0xd1, 0x47, 0x7a, 0x2c]};
immutable CLSID CLSID_TrayBandSiteService                  = {0xF60AD0A0, 0xE5E1, 0x45cb, [0xB5, 0x1A, 0xE1, 0x5B, 0x9F, 0x8B, 0x29, 0x34]};
immutable CLSID CLSID_TrayDeskBand                         = {0xE6442437, 0x6C68, 0x4f52, [0x94, 0xDD, 0x2C, 0xFE, 0xD2, 0x67, 0xEF, 0xB9]};
immutable CLSID CLSID_AttachmentServices                   = {0x4125dd96, 0xe03a, 0x4103, [0x8f, 0x70, 0xe0, 0x59, 0x7d, 0x80, 0x3b, 0x9c]};
immutable CLSID CLSID_DocPropShellExtension                = {0x883373C3, 0xBF89, 0x11D1, [0xBE, 0x35, 0x08, 0x00, 0x36, 0xB1, 0x1A, 0x03]};
immutable CLSID CLSID_ShellItem                            = {0x9ac9fbe1, 0xe0a2, 0x4ad6, [0xb4, 0xee, 0xe2, 0x12, 0x01, 0x3e, 0xa9, 0x17]};
immutable CLSID CLSID_NamespaceWalker                      = {0x72eb61e0, 0x8672, 0x4303, [0x91, 0x75, 0xf2, 0xe4, 0xc6, 0x8b, 0x2e, 0x7c]};
immutable CLSID CLSID_FileOperation                        = {0x3ad05575, 0x8857, 0x4850, [0x92, 0x77, 0x11, 0xb8, 0x5b, 0xdb, 0x8e, 0x09]};
immutable CLSID CLSID_FileOpenDialog                       = {0xDC1C5A9C, 0xE88A, 0x4dde, [0xA5, 0xA1, 0x60, 0xF8, 0x2A, 0x20, 0xAE, 0xF7]};
immutable CLSID CLSID_FileSaveDialog                       = {0xC0B4E2F3, 0xBA21, 0x4773, [0x8D, 0xBA, 0x33, 0x5E, 0xC9, 0x46, 0xEB, 0x8B]};
immutable CLSID CLSID_KnownFolderManager                   = {0x4df0c730, 0xdf9d, 0x4ae3, [0x91, 0x53, 0xaa, 0x6b, 0x82, 0xe9, 0x79, 0x5a]};
immutable CLSID CLSID_FSCopyHandler                        = {0xD197380A, 0x0A79, 0x4dc8, [0xA0, 0x33, 0xED, 0x88, 0x2C, 0x2F, 0xA1, 0x4B]};
immutable CLSID CLSID_SharingConfigurationManager          = {0x49F371E1, 0x8C5C, 0x4d9c, [0x9A, 0x3B, 0x54, 0xA6, 0x82, 0x7F, 0x51, 0x3C]};
immutable CLSID CLSID_PreviousVersions                     = {0x596AB062, 0xB4D2, 0x4215, [0x9F, 0x74, 0xE9, 0x10, 0x9B, 0x0A, 0x81, 0x53]};
immutable CLSID CLSID_NetworkConnections                   = {0x7007ACC7, 0x3202, 0x11D1, [0xAA, 0xD2, 0x00, 0x80, 0x5F, 0xC1, 0x27, 0x0E]};
immutable CLSID CLSID_NamespaceTreeControl                 = {0xAE054212, 0x3535, 0x4430, [0x83, 0xED, 0xD5, 0x01, 0xAA, 0x66, 0x80, 0xE6]};
immutable CLSID CLSID_IENamespaceTreeControl               = {0xACE52D03, 0xE5CD, 0x4b20, [0x82, 0xFF, 0xE7, 0x1B, 0x11, 0xBE, 0xAE, 0x1D]};
immutable CLSID CLSID_ScheduledTasks                       = {0xD6277990, 0x4C6A, 0x11CF, [0x8D, 0x87, 0x00, 0xAA, 0x00, 0x60, 0xF5, 0xBF]};
immutable CLSID CLSID_ApplicationAssociationRegistration   = {0x591209c7, 0x767b, 0x42b2, [0x9f, 0xba, 0x44, 0xee, 0x46, 0x15, 0xf2, 0xc7]};
immutable CLSID CLSID_ApplicationAssociationRegistrationUI = {0x1968106d, 0xf3b5, 0x44cf, [0x89, 0x0e, 0x11, 0x6f, 0xcb, 0x9e, 0xce, 0xf1]};
immutable CLSID CLSID_SearchFolderItemFactory              = {0x14010e02, 0xbbbd, 0x41f0, [0x88, 0xe3, 0xed, 0xa3, 0x71, 0x21, 0x65, 0x84]};
immutable CLSID CLSID_OpenControlPanel                     = {0x06622D85, 0x6856, 0x4460, [0x8D, 0xE1, 0xA8, 0x19, 0x21, 0xB4, 0x1C, 0x4B]};
immutable CLSID CLSID_MailRecipient                        = {0x9E56BE60, 0xC50F, 0x11CF, [0x9A, 0x2C, 0x00, 0xA0, 0xC9, 0x0A, 0x90, 0xCE]};
immutable CLSID CLSID_NetworkExplorerFolder                = {0xF02C1A0D, 0xBE21, 0x4350, [0x88, 0xB0, 0x73, 0x67, 0xFC, 0x96, 0xEF, 0x3C]};
immutable CLSID CLSID_DestinationList                      = {0x77f10cf0, 0x3db5, 0x4966, [0xb5, 0x20, 0xb7, 0xc5, 0x4f, 0xd3, 0x5e, 0xd6]};
immutable CLSID CLSID_ApplicationDestinations              = {0x86c14003, 0x4d6b, 0x4ef3, [0xa7, 0xb4, 0x05, 0x06, 0x66, 0x3b, 0x2e, 0x68]};
immutable CLSID CLSID_ApplicationDocumentLists             = {0x86bec222, 0x30f2, 0x47e0, [0x9f, 0x25, 0x60, 0xd1, 0x1c, 0xd7, 0x5c, 0x28]};
immutable CLSID CLSID_HomeGroup                            = {0xDE77BA04, 0x3C92, 0x4d11, [0xA1, 0xA5, 0x42, 0x35, 0x2A, 0x53, 0xE0, 0xE3]};
immutable CLSID CLSID_ShellLibrary                         = {0xd9b3211d, 0xe57f, 0x4426, [0xaa, 0xef, 0x30, 0xa8, 0x06, 0xad, 0xd3, 0x97]};
immutable CLSID CLSID_AppStartupLink                       = {0x273eb5e7, 0x88b0, 0x4843, [0xbf, 0xef, 0xe2, 0xc8, 0x1d, 0x43, 0xaa, 0xe5]};
immutable CLSID CLSID_EnumerableObjectCollection           = {0x2d3468c1, 0x36a7, 0x43b6, [0xac, 0x24, 0xd3, 0xf0, 0x2f, 0xd9, 0x60, 0x7a]};
immutable CLSID CLSID_DesktopGadget                        = {0x924ccc1b, 0x6562, 0x4c85, [0x86, 0x57, 0xd1, 0x77, 0x92, 0x52, 0x22, 0xb6]};
alias CLSID_PublishingWizard SID_PublishingWizard;

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	HRESULT SHGetTemporaryPropertyForItem(IShellItem psi, REFPROPERTYKEY propkey, PROPVARIANT* ppropvar);
	HRESULT SHSetTemporaryPropertyForItem(IShellItem psi, REFPROPERTYKEY propkey, REFPROPVARIANT propvar);
}
static if (NTDDI_VERSION >= NTDDI_WIN7 && _WIN32_IE >= _WIN32_IE_IE70)
{
	alias DWORD LIBRARYMANAGEDIALOGOPTIONS;
	immutable DWORD LMD_DEFAULT                          = 0;
	immutable DWORD LMD_ALLOWUNINDEXABLENETWORKLOCATIONS = 0x1;

	HRESULT SHShowManageLibraryUI(IShellItem psiLibrary, HWND hwndOwner, LPCWSTR pszTitle, LPCWSTR pszInstruction, LIBRARYMANAGEDIALOGOPTIONS lmdOptions);
	HRESULT SHResolveLibrary(IShellItem psiLibrary);

	HRESULT SHCreateLibrary(REFIID riid, void** ppv)
	{
		return CoCreateInstance(&CLSID_ShellLibrary, null, CLSCTX.CLSCTX_INPROC_SERVER, riid, ppv);
	}

	HRESULT SHLoadLibraryFromItem(IShellItem psiLibrary, DWORD grfMode, REFIID riid, void** ppv)
	{
		*ppv = null;
		IShellLibrary plib;
		HRESULT hr = CoCreateInstance(&CLSID_ShellLibrary, null, CLSCTX.CLSCTX_INPROC_SERVER, &IID_IShellLibrary, cast(void**)&plib);
		if (SUCCEEDED(hr))
		{
			hr = plib.LoadLibraryFromItem(psiLibrary, grfMode);
			if (SUCCEEDED(hr))
				hr = plib.QueryInterface(riid, ppv);
			plib.Release();
		}
		return hr;
	}

	HRESULT SHLoadLibraryFromKnownFolder(REFKNOWNFOLDERID kfidLibrary, DWORD grfMode, REFIID riid, void** ppv)
	{
		*ppv = null;
		IShellLibrary plib;
		HRESULT hr = CoCreateInstance(&CLSID_ShellLibrary, null, CLSCTX.CLSCTX_INPROC_SERVER, &IID_IShellLibrary, cast(void**)&plib);
		if (SUCCEEDED(hr))
		{
			hr = plib.LoadLibraryFromKnownFolder(kfidLibrary, grfMode);
			if (SUCCEEDED(hr))
				hr = plib.QueryInterface(riid, ppv);
			plib.Release();
		}
		return hr;
	}

	HRESULT SHLoadLibraryFromParsingName(PCWSTR pszParsingName, DWORD grfMode, REFIID riid, void** ppv)
	{
		*ppv = null;
		IShellItem psiLibrary;
		HRESULT hr = SHCreateItemFromParsingName(pszParsingName, null, &IID_IShellItem, cast(void**)&psiLibrary);
		if (SUCCEEDED(hr))
		{
			hr = SHLoadLibraryFromItem(psiLibrary, grfMode, riid, ppv);
			psiLibrary.Release();
		}
		return hr;
	}

	HRESULT SHAddFolderPathToLibrary(IShellLibrary plib, PCWSTR pszFolderPath)
	{
		IShellItem psiFolder;
		HRESULT hr = SHCreateItemFromParsingName(pszFolderPath, null, &IID_IShellItem, cast(void**)&psiFolder);
		if (SUCCEEDED(hr))
		{
			hr = plib.AddFolder(psiFolder);
			psiFolder.Release();
		}
		return hr;
	}

	HRESULT SHRemoveFolderPathFromLibrary(IShellLibrary plib, PCWSTR pszFolderPath)
	{
		PIDLIST_ABSOLUTE pidlFolder = SHSimpleIDListFromPath(pszFolderPath);
		HRESULT hr = pidlFolder ? S_OK : E_INVALIDARG;
		if (SUCCEEDED(hr))
		{
			IShellItem psiFolder;
			hr = SHCreateItemFromIDList(pidlFolder, &IID_IShellItem, cast(void**)&psiFolder);
			if (SUCCEEDED(hr))
			{
				hr = plib.RemoveFolder(psiFolder);
				psiFolder.Release();
			}
			CoTaskMemFree(pidlFolder);
		}
		return hr;
	}

	HRESULT SHResolveFolderPathInLibrary(IShellLibrary plib, PCWSTR pszFolderPath, DWORD dwTimeout, PWSTR* ppszResolvedPath)
	{
		*ppszResolvedPath = null;
		PIDLIST_ABSOLUTE pidlFolder = SHSimpleIDListFromPath(pszFolderPath);
		HRESULT hr = pidlFolder ? S_OK : E_INVALIDARG;
		if (SUCCEEDED(hr))
		{
			IShellItem psiFolder;
			hr = SHCreateItemFromIDList(pidlFolder, &IID_IShellItem, cast(void**)&psiFolder);
			if (SUCCEEDED(hr))
			{
				IShellItem psiResolved;
				hr = plib.ResolveFolder(psiFolder, dwTimeout, &IID_IShellItem, cast(void**)&psiResolved);
				if (SUCCEEDED(hr))
				{
					hr = psiResolved.GetDisplayName(SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, ppszResolvedPath);
					psiResolved.Release();
				}
				psiFolder.Release();
			}
			CoTaskMemFree(pidlFolder);
		}
		return hr;
	}

	HRESULT SHSaveLibraryInFolderPath(IShellLibrary plib, PCWSTR pszFolderPath, PCWSTR pszLibraryName, LIBRARYSAVEFLAGS lsf, PWSTR* ppszSavedToPath)
	{
		if (ppszSavedToPath !is null)
			*ppszSavedToPath = null;

		IShellItem psiFolder;
		HRESULT hr = SHCreateItemFromParsingName(pszFolderPath, null, &IID_IShellItem, cast(void**)&psiFolder);
		if (SUCCEEDED(hr))
		{
			IShellItem psiSavedTo;
			hr = plib.Save(psiFolder, pszLibraryName, lsf, &psiSavedTo);
			if (SUCCEEDED(hr))
			{
				if (ppszSavedToPath !is null)
					hr = psiSavedTo.GetDisplayName(SIGDN.SIGDN_DESKTOPABSOLUTEPARSING, ppszSavedToPath);
				psiSavedTo.Release();
			}
			psiFolder.Release();
		}
		return hr;
	}
}

static if (NTDDI_VERSION >= NTDDI_VISTA)
{
	immutable IID IID_IAssocHandlerInvoker = {0x92218CAB, 0xECAA, 0x4335, [0x81, 0x33, 0x80, 0x7F, 0xD2, 0x34, 0xC2, 0xEE]};
	interface IAssocHandlerInvoker : IUnknown
	{
		HRESULT SupportsSelection();
		HRESULT Invoke();
	}

	immutable IID IID_IAssocHandler = {0xF04061AC, 0x1659, 0x4a3f, [0xA9, 0x54, 0x77, 0x5A, 0xA5, 0x7F, 0xC0, 0x83]};
	interface IAssocHandler : IUnknown
	{
		HRESULT GetName(LPWSTR* ppsz);
		HRESULT GetUIName(LPWSTR* ppsz);
		HRESULT GetIconLocation(LPWSTR* ppszPath, int* pIndex);
		HRESULT IsRecommended();
		HRESULT MakeDefault(LPCWSTR pszDescription);
		HRESULT Invoke(IDataObject pdo);
		HRESULT CreateInvoker(IDataObject pdo, IAssocHandlerInvoker* ppInvoker);
	}

	immutable IID IID_IEnumAssocHandlers = {0x973810ae, 0x9599, 0x4b88, [0x9e, 0x4d, 0x6e, 0xe9, 0x8c, 0x95, 0x52, 0xda]};
	interface IEnumAssocHandlers : IUnknown
	{
		HRESULT Next(ULONG celt, IAssocHandler* rgelt, ULONG* pceltFetched);
	}

	alias int ASSOC_FILTER;
	immutable int ASSOC_FILTER_NONE        = 0;
	immutable int ASSOC_FILTER_RECOMMENDED = 0x1;

	HRESULT SHAssocEnumHandlers(LPCWSTR pszExtra, ASSOC_FILTER afFilter, IEnumAssocHandlers* ppEnumHandler);
}

static if (NTDDI_VERSION >= NTDDI_WIN7)
{
	HRESULT SHAssocEnumHandlersForProtocolByApplication(PCWSTR protocol, REFIID riid, void** enumHandlers);
}

alias jp.ku6.windows.win32api.propidl.BSTR_UserSize BSTR_UserSize;
alias jp.ku6.windows.win32api.propidl.BSTR_UserMarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserUnmarshal BSTR_UserMarshal;
alias jp.ku6.windows.win32api.propidl.BSTR_UserFree BSTR_UserFree;

uint HACCEL_UserSize(uint* pFlags, uint Offset, HACCEL* pHaccel);
ubyte* HACCEL_UserMarshal(uint* pFlags, ubyte* pBuffer, HACCEL* pHaccel);
ubyte* HACCEL_UserUnmarshal(uint* pFlags, ubyte* pBuffer, HACCEL* pHaccel);
void HACCEL_UserFree(uint* pFlags, HACCEL* pHaccel);

alias jp.ku6.windows.win32api.objidl.HBITMAP_UserSize HBITMAP_UserSize;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserMarshal HBITMAP_UserMarshal;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserUnmarshal HBITMAP_UserUnmarshal;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserFree HBITMAP_UserFree;

uint HGLOBAL_UserSize(uint* pFlags, uint Offset, HGLOBAL* pHglobal);
ubyte* HGLOBAL_UserMarshal(uint* pFlags, ubyte* pBuffer, HGLOBAL* pHglobal);
ubyte* HGLOBAL_UserUnmarshal(uint* pFlags, ubyte* pBuffer, HGLOBAL* pHglobal);
void HGLOBAL_UserFree(uint* pFlags, HGLOBAL* pHglobal);

alias jp.ku6.windows.win32api.objidl.HICON_UserSize HICON_UserSize;
alias jp.ku6.windows.win32api.objidl.HICON_UserMarshal HICON_UserMarshal;
alias jp.ku6.windows.win32api.objidl.HICON_UserUnmarshal HICON_UserUnmarshal;
alias jp.ku6.windows.win32api.objidl.HICON_UserFree HICON_UserFree;

uint HMENU_UserSize(uint* pFlags, uint Offset, HMENU* pHmenu);
ubyte* HMENU_UserMarshal(uint* pBuffer, ubyte* , HMENU* pHmenu);
ubyte* HMENU_UserUnmarshal(uint* pBuffer, ubyte* , HMENU* pHmenu);
void HMENU_UserFree(uint* pFlags, HMENU* pHmenu);

uint HWND_UserSize(uint* pFlags, uint Offset, HWND* pHwnd);
ubyte* HWND_UserMarshal(uint* pFlags, ubyte* pBuffer, HWND* pHwnd);
ubyte* HWND_UserUnmarshal(uint* pFlags, ubyte* pBuffer, HWND* pHwnd);
void HWND_UserFree(uint* pFlags, HWND* pHwnd);

alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserSize LPSAFEARRAY_UserSize;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserMarshal LPSAFEARRAY_UserMarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserUnmarshal LPSAFEARRAY_UserUnmarshal;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserFree LPSAFEARRAY_UserFree;

uint PCIDLIST_ABSOLUTE_UserSize(uint* pFlags, uint Offset, PCIDLIST_ABSOLUTE* pCuidList);
ubyte* PCIDLIST_ABSOLUTE_UserMarshal(uint* pFlags, ubyte* pBuffer, PCIDLIST_ABSOLUTE* pCuidList);
ubyte* PCIDLIST_ABSOLUTE_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PCIDLIST_ABSOLUTE* pCuidList);
void PCIDLIST_ABSOLUTE_UserFree(uint* pFlags, PCIDLIST_ABSOLUTE* pCuidList);

uint PCUIDLIST_RELATIVE_UserSize(uint* pFlags, uint Offset, PCUIDLIST_RELATIVE* pCuidList);
ubyte* PCUIDLIST_RELATIVE_UserMarshal(uint* pFlags, ubyte* pBuffer, PCUIDLIST_RELATIVE* pCuidList);
ubyte* PCUIDLIST_RELATIVE_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PCUIDLIST_RELATIVE* pCuidList);
void PCUIDLIST_RELATIVE_UserFree(uint* pFlags, PCUIDLIST_RELATIVE* pCuidList);

uint PCUITEMID_CHILD_UserSize(uint* pFlags, uint Offset, PCUITEMID_CHILD* pCuitemId);
ubyte* PCUITEMID_CHILD_UserMarshal(uint* pFlags, ubyte* pBuffer, PCUITEMID_CHILD* pCuitemId);
ubyte* PCUITEMID_CHILD_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PCUITEMID_CHILD* pCuitemId);
void PCUITEMID_CHILD_UserFree(uint* pFlags, PCUITEMID_CHILD* pCuitemId);

uint PIDLIST_ABSOLUTE_UserSize(uint* pFlags, uint Offset, PIDLIST_ABSOLUTE* pIdList);
ubyte* PIDLIST_ABSOLUTE_UserMarshal(uint* pFlags, ubyte* pBuffer, PIDLIST_ABSOLUTE* pIdList);
ubyte* PIDLIST_ABSOLUTE_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PIDLIST_ABSOLUTE* pIdList);
void PIDLIST_ABSOLUTE_UserFree(uint* pFlags, PIDLIST_ABSOLUTE* pIdList);

uint PIDLIST_RELATIVE_UserSize(uint* pFlags, uint Offset, PIDLIST_RELATIVE* pIdList);
ubyte* PIDLIST_RELATIVE_UserMarshal(uint* pFlags, ubyte* pBuffer, PIDLIST_RELATIVE* pIdList);
ubyte* PIDLIST_RELATIVE_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PIDLIST_RELATIVE* pIdList);
void PIDLIST_RELATIVE_UserFree(uint* pFlags, PIDLIST_RELATIVE* pIdList);

uint PITEMID_CHILD_UserSize(uint* pFlags, uint Offset, PITEMID_CHILD* pItemId);
ubyte* PITEMID_CHILD_UserMarshal(uint* pFlags, ubyte* pBuffer, PITEMID_CHILD* pItemId);
ubyte* PITEMID_CHILD_UserUnmarshal(uint* pFlags, ubyte* pBuffer, PITEMID_CHILD* pItemId);
void PITEMID_CHILD_UserFree(uint* pFlags, PITEMID_CHILD* pItemId);

uint VARIANT_UserSize(uint* pFlags, uint Offset, VARIANT* pVariant);
ubyte* VARIANT_UserMarshal(uint* pFlags, ubyte* pBuffer, VARIANT* pVariant);
ubyte* VARIANT_UserUnmarshal(uint* pFlags, ubyte* pBuffer, VARIANT* pVariant);
void VARIANT_UserFree(uint* pFlags, VARIANT* pVariant);

alias jp.ku6.windows.win32api.propidl.BSTR_UserSize64 BSTR_UserSize64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserMarshal64 BSTR_UserMarshal64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserUnmarshal64 BSTR_UserUnmarshal64;
alias jp.ku6.windows.win32api.propidl.BSTR_UserFree64 BSTR_UserFree64;

uint HACCEL_UserSize64(uint* pFlags, uint Offset, HACCEL* pHaccel);
ubyte* HACCEL_UserMarshal64(uint* pFlags, ubyte* pBuffer, HACCEL* pHaccel);
ubyte* HACCEL_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HACCEL* pHaccel);
void HACCEL_UserFree64(uint* pFlags, HACCEL* pHaccel);

alias jp.ku6.windows.win32api.objidl.HBITMAP_UserSize64 HBITMAP_UserSize64;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserMarshal64 HBITMAP_UserMarshal64;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserUnmarshal64 HBITMAP_UserUnmarshal64;
alias jp.ku6.windows.win32api.objidl.HBITMAP_UserFree64 HBITMAP_UserFree64;

uint HGLOBAL_UserSize64(uint* pFlags, uint Offset, HGLOBAL* pHglobal);
ubyte* HGLOBAL_UserMarshal64(uint* pFlags, ubyte* pBuffer, HGLOBAL* pHglobal);
ubyte* HGLOBAL_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HGLOBAL* pHglobal);
void HGLOBAL_UserFree64(uint* pFlags, HGLOBAL* pHglobal);

alias jp.ku6.windows.win32api.objidl.HICON_UserSize64 HICON_UserSize64;
alias jp.ku6.windows.win32api.objidl.HICON_UserMarshal64 HICON_UserMarshal64;
alias jp.ku6.windows.win32api.objidl.HICON_UserUnmarshal64 HICON_UserUnmarshal64;
alias jp.ku6.windows.win32api.objidl.HICON_UserFree64 HICON_UserFree64;

uint HMENU_UserSize64(uint* pFlags, uint Offset, HMENU* pHmenu);
ubyte* HMENU_UserMarshal64(uint* pFlags, ubyte* pBuffer, HMENU* pHmenu);
ubyte* HMENU_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HMENU* pHmenu);
void HMENU_UserFree64(uint* pFlags, HMENU* pHmenu);

uint HWND_UserSize64(uint* pFlags, uint Offset, HWND* pHwnd);
ubyte* HWND_UserMarshal64(uint* pFlags, ubyte* pBuffer, HWND* pHwnd);
ubyte* HWND_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, HWND* pHwnd);
void HWND_UserFree64(uint* pFlags, HWND* pHwnd);

alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserSize64 LPSAFEARRAY_UserSize64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserMarshal64 LPSAFEARRAY_UserMarshal64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserUnmarshal64 LPSAFEARRAY_UserUnmarshal64;
alias jp.ku6.windows.win32api.propidl.LPSAFEARRAY_UserFree64 LPSAFEARRAY_UserFree64;

uint PCIDLIST_ABSOLUTE_UserSize64(uint* pFlags, uint Offset, PCIDLIST_ABSOLUTE* pCuidList);
ubyte* PCIDLIST_ABSOLUTE_UserMarshal64(uint* pFlags, ubyte* pBuffer, PCIDLIST_ABSOLUTE* pCuidList);
ubyte* PCIDLIST_ABSOLUTE_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PCIDLIST_ABSOLUTE* pCuidList);
void PCIDLIST_ABSOLUTE_UserFree64(uint* pFlags, PCIDLIST_ABSOLUTE* pCuidList);

uint PCUIDLIST_RELATIVE_UserSize64(uint* pFlags, uint Offset, PCUIDLIST_RELATIVE* pCuidList);
ubyte* PCUIDLIST_RELATIVE_UserMarshal64(uint* pFlags, ubyte* pBuffer, PCUIDLIST_RELATIVE* pCuidList);
ubyte* PCUIDLIST_RELATIVE_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PCUIDLIST_RELATIVE* pCuidList);
void PCUIDLIST_RELATIVE_UserFree64(uint* pFlags, PCUIDLIST_RELATIVE* pCuidList);

uint PCUITEMID_CHILD_UserSize64(uint* pFlags, uint Offset, PCUITEMID_CHILD* pCuitemId);
ubyte* PCUITEMID_CHILD_UserMarshal64(uint* pFlags, ubyte* pBuffer, PCUITEMID_CHILD* pCuitemId);
ubyte* PCUITEMID_CHILD_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PCUITEMID_CHILD* pCuitemId);
void PCUITEMID_CHILD_UserFree64(uint* pFlags, PCUITEMID_CHILD* pCuitemId);

uint PIDLIST_ABSOLUTE_UserSize64(uint* pFlags, uint Offset, PIDLIST_ABSOLUTE* pIdList);
ubyte* PIDLIST_ABSOLUTE_UserMarshal64(uint* pFlags, ubyte* pBuffer, PIDLIST_ABSOLUTE* pIdList);
ubyte* PIDLIST_ABSOLUTE_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PIDLIST_ABSOLUTE* pIdList);
void PIDLIST_ABSOLUTE_UserFree64(uint* pFlags, PIDLIST_ABSOLUTE* pIdList);

uint PIDLIST_RELATIVE_UserSize64(uint* pFlags, uint Offset, PIDLIST_RELATIVE* pIdList);
ubyte* PIDLIST_RELATIVE_UserMarshal64(uint* pFlags, ubyte* pBuffer, PIDLIST_RELATIVE* pIdList);
ubyte* PIDLIST_RELATIVE_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PIDLIST_RELATIVE* pIdList);
void PIDLIST_RELATIVE_UserFree64(uint* pFlags, PIDLIST_RELATIVE* pIdList);

uint PITEMID_CHILD_UserSize64(uint* pFlags, uint Offset, PITEMID_CHILD* pItemId);
ubyte* PITEMID_CHILD_UserMarshal64(uint* pFlags, ubyte* pBuffer, PITEMID_CHILD* pItemId);
ubyte* PITEMID_CHILD_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, PITEMID_CHILD* pItemId);
void PITEMID_CHILD_UserFree64(uint* pFlags, PITEMID_CHILD* pItemId);

uint VARIANT_UserSize64(uint* pFlags, uint Offset, VARIANT* pVariant);
ubyte* VARIANT_UserMarshal64(uint* pFlags, ubyte* pBuffer, VARIANT* pVariant);
ubyte* VARIANT_UserUnmarshal64(uint* pFlags, ubyte* pBuffer, VARIANT* pVariant);
void VARIANT_UserFree64(uint* pFlags, VARIANT* pVariant);

HRESULT IEnumIDList_Next_Proxy(IEnumIDList This, ULONG celt, PITEMID_CHILD* rgelt, ULONG* pceltFetched);
HRESULT IEnumIDList_Next_Stub(IEnumIDList This, ULONG celt, PITEMID_CHILD* rgelt, ULONG* pceltFetched);
HRESULT IEnumFullIDList_Next_Proxy(IEnumFullIDList This, ULONG celt, PIDLIST_ABSOLUTE* rgelt, ULONG* pceltFetched);
HRESULT IEnumFullIDList_Next_Stub(IEnumFullIDList This, ULONG celt, PIDLIST_ABSOLUTE* rgelt, ULONG* pceltFetched);
HRESULT IShellFolder_SetNameOf_Proxy(IShellFolder This, HWND hwnd, PCUITEMID_CHILD pidl, LPCWSTR pszName, SHGDNF uFlags, PITEMID_CHILD* ppidlOut);
HRESULT IShellFolder_SetNameOf_Stub(IShellFolder This, HWND hwnd, PCUITEMID_CHILD pidl, LPCWSTR pszName, SHGDNF uFlags, PITEMID_CHILD* ppidlOut);
HRESULT IFolderView2_GetGroupBy_Proxy(IFolderView2 This, PROPERTYKEY* pkey, BOOL* pfAscending);
HRESULT IFolderView2_GetGroupBy_Stub(IFolderView2 This, PROPERTYKEY* pkey, BOOL* pfAscending);
HRESULT IEnumShellItems_Next_Proxy(IEnumShellItems This, ULONG celt, IShellItem* rgelt, ULONG* pceltFetched);
HRESULT IEnumShellItems_Next_Stub(IEnumShellItems This, ULONG celt, IShellItem* rgelt, ULONG* pceltFetched);
HRESULT IParentAndItem_GetParentAndItem_Proxy(IParentAndItem This, PIDLIST_ABSOLUTE* ppidlParent, IShellFolder* ppsf, PITEMID_CHILD* ppidlChild);
HRESULT IParentAndItem_GetParentAndItem_Stub(IParentAndItem This, PIDLIST_ABSOLUTE* ppidlParent, IShellFolder* ppsf, PITEMID_CHILD* ppidlChild);
HRESULT IResultsFolder_AddIDList_Proxy(IResultsFolder This, PCIDLIST_ABSOLUTE pidl, PITEMID_CHILD* ppidlAdded);
HRESULT IResultsFolder_AddIDList_Stub(IResultsFolder This, PCIDLIST_ABSOLUTE pidl, PITEMID_CHILD* ppidlAdded);
HRESULT IEnumObjects_Next_Proxy(IEnumObjects This, ULONG celt, REFIID riid, void** rgelt, ULONG* pceltFetched);
HRESULT IEnumObjects_Next_Stub(IEnumObjects This, ULONG celt, REFIID riid, void** rgelt, ULONG* pceltFetched);
HRESULT IBandSite_QueryBand_Proxy(IBandSite This, DWORD dwBandID, IDeskBand* ppstb, DWORD* pdwState, LPWSTR pszName, int cchName);
HRESULT IBandSite_QueryBand_Stub(IBandSite This, DWORD dwBandID, IDeskBand* ppstb, DWORD* pdwState, LPWSTR pszName, int cchName);
HRESULT IModalWindow_Show_Proxy(IModalWindow This, HWND hwndOwner);
HRESULT IModalWindow_Show_Stub(IModalWindow This, HWND hwndOwner);
HRESULT IKnownFolderManager_Redirect_Proxy(IKnownFolderManager This, REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags, LPCWSTR pszTargetPath, UINT cFolders, const(KNOWNFOLDERID)* pExclusion, LPWSTR* ppszError);
HRESULT IKnownFolderManager_Redirect_Stub(IKnownFolderManager This, REFKNOWNFOLDERID rfid, HWND hwnd, KF_REDIRECT_FLAGS flags, LPCWSTR pszTargetPath, UINT cFolders, const(GUID)* pExclusion, LPWSTR* ppszError);
HRESULT IEnumExplorerCommand_Next_Proxy(IEnumExplorerCommand This, ULONG celt, IExplorerCommand* pUICommand, ULONG* pceltFetched);
HRESULT IEnumExplorerCommand_Next_Stub(IEnumExplorerCommand This, ULONG celt, IExplorerCommand* pUICommand, ULONG* pceltFetched);

